
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Gtk.Objects.AppChooserWidget
    ( 

-- * Exported types
    AppChooserWidget(..)                    ,
    AppChooserWidgetK                       ,
    toAppChooserWidget                      ,
    noAppChooserWidget                      ,


 -- * Methods
-- ** appChooserWidgetGetDefaultText
    appChooserWidgetGetDefaultText          ,


-- ** appChooserWidgetGetShowAll
    appChooserWidgetGetShowAll              ,


-- ** appChooserWidgetGetShowDefault
    appChooserWidgetGetShowDefault          ,


-- ** appChooserWidgetGetShowFallback
    appChooserWidgetGetShowFallback         ,


-- ** appChooserWidgetGetShowOther
    appChooserWidgetGetShowOther            ,


-- ** appChooserWidgetGetShowRecommended
    appChooserWidgetGetShowRecommended      ,


-- ** appChooserWidgetNew
    appChooserWidgetNew                     ,


-- ** appChooserWidgetSetDefaultText
    appChooserWidgetSetDefaultText          ,


-- ** appChooserWidgetSetShowAll
    appChooserWidgetSetShowAll              ,


-- ** appChooserWidgetSetShowDefault
    appChooserWidgetSetShowDefault          ,


-- ** appChooserWidgetSetShowFallback
    appChooserWidgetSetShowFallback         ,


-- ** appChooserWidgetSetShowOther
    appChooserWidgetSetShowOther            ,


-- ** appChooserWidgetSetShowRecommended
    appChooserWidgetSetShowRecommended      ,




 -- * Properties
-- ** DefaultText
    AppChooserWidgetDefaultTextPropertyInfo ,
    constructAppChooserWidgetDefaultText    ,
    getAppChooserWidgetDefaultText          ,
    setAppChooserWidgetDefaultText          ,


-- ** ShowAll
    AppChooserWidgetShowAllPropertyInfo     ,
    constructAppChooserWidgetShowAll        ,
    getAppChooserWidgetShowAll              ,
    setAppChooserWidgetShowAll              ,


-- ** ShowDefault
    AppChooserWidgetShowDefaultPropertyInfo ,
    constructAppChooserWidgetShowDefault    ,
    getAppChooserWidgetShowDefault          ,
    setAppChooserWidgetShowDefault          ,


-- ** ShowFallback
    AppChooserWidgetShowFallbackPropertyInfo,
    constructAppChooserWidgetShowFallback   ,
    getAppChooserWidgetShowFallback         ,
    setAppChooserWidgetShowFallback         ,


-- ** ShowOther
    AppChooserWidgetShowOtherPropertyInfo   ,
    constructAppChooserWidgetShowOther      ,
    getAppChooserWidgetShowOther            ,
    setAppChooserWidgetShowOther            ,


-- ** ShowRecommended
    AppChooserWidgetShowRecommendedPropertyInfo,
    constructAppChooserWidgetShowRecommended,
    getAppChooserWidgetShowRecommended      ,
    setAppChooserWidgetShowRecommended      ,




 -- * Signals
-- ** ApplicationActivated
    AppChooserWidgetApplicationActivatedCallback,
    AppChooserWidgetApplicationActivatedCallbackC,
    AppChooserWidgetApplicationActivatedSignalInfo,
    afterAppChooserWidgetApplicationActivated,
    appChooserWidgetApplicationActivatedCallbackWrapper,
    appChooserWidgetApplicationActivatedClosure,
    mkAppChooserWidgetApplicationActivatedCallback,
    noAppChooserWidgetApplicationActivatedCallback,
    onAppChooserWidgetApplicationActivated  ,


-- ** ApplicationSelected
    AppChooserWidgetApplicationSelectedCallback,
    AppChooserWidgetApplicationSelectedCallbackC,
    AppChooserWidgetApplicationSelectedSignalInfo,
    afterAppChooserWidgetApplicationSelected,
    appChooserWidgetApplicationSelectedCallbackWrapper,
    appChooserWidgetApplicationSelectedClosure,
    mkAppChooserWidgetApplicationSelectedCallback,
    noAppChooserWidgetApplicationSelectedCallback,
    onAppChooserWidgetApplicationSelected   ,


-- ** PopulatePopup
    AppChooserWidgetPopulatePopupCallback   ,
    AppChooserWidgetPopulatePopupCallbackC  ,
    AppChooserWidgetPopulatePopupSignalInfo ,
    afterAppChooserWidgetPopulatePopup      ,
    appChooserWidgetPopulatePopupCallbackWrapper,
    appChooserWidgetPopulatePopupClosure    ,
    mkAppChooserWidgetPopulatePopupCallback ,
    noAppChooserWidgetPopulatePopupCallback ,
    onAppChooserWidgetPopulatePopup         ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Gtk.Types
import GI.Gtk.Callbacks
import qualified GI.Atk as Atk
import qualified GI.GObject as GObject
import qualified GI.Gio as Gio

newtype AppChooserWidget = AppChooserWidget (ForeignPtr AppChooserWidget)
foreign import ccall "gtk_app_chooser_widget_get_type"
    c_gtk_app_chooser_widget_get_type :: IO GType

type instance ParentTypes AppChooserWidget = AppChooserWidgetParentTypes
type AppChooserWidgetParentTypes = '[Box, Container, Widget, GObject.Object, Atk.ImplementorIface, AppChooser, Buildable, Orientable]

instance GObject AppChooserWidget where
    gobjectIsInitiallyUnowned _ = True
    gobjectType _ = c_gtk_app_chooser_widget_get_type
    

class GObject o => AppChooserWidgetK o
instance (GObject o, IsDescendantOf AppChooserWidget o) => AppChooserWidgetK o

toAppChooserWidget :: AppChooserWidgetK o => o -> IO AppChooserWidget
toAppChooserWidget = unsafeCastTo AppChooserWidget

noAppChooserWidget :: Maybe AppChooserWidget
noAppChooserWidget = Nothing

-- signal AppChooserWidget::application-activated
type AppChooserWidgetApplicationActivatedCallback =
    Gio.AppInfo ->
    IO ()

noAppChooserWidgetApplicationActivatedCallback :: Maybe AppChooserWidgetApplicationActivatedCallback
noAppChooserWidgetApplicationActivatedCallback = Nothing

type AppChooserWidgetApplicationActivatedCallbackC =
    Ptr () ->                               -- object
    Ptr Gio.AppInfo ->
    Ptr () ->                               -- user_data
    IO ()

foreign import ccall "wrapper"
    mkAppChooserWidgetApplicationActivatedCallback :: AppChooserWidgetApplicationActivatedCallbackC -> IO (FunPtr AppChooserWidgetApplicationActivatedCallbackC)

appChooserWidgetApplicationActivatedClosure :: AppChooserWidgetApplicationActivatedCallback -> IO Closure
appChooserWidgetApplicationActivatedClosure cb = newCClosure =<< mkAppChooserWidgetApplicationActivatedCallback wrapped
    where wrapped = appChooserWidgetApplicationActivatedCallbackWrapper cb

appChooserWidgetApplicationActivatedCallbackWrapper ::
    AppChooserWidgetApplicationActivatedCallback ->
    Ptr () ->
    Ptr Gio.AppInfo ->
    Ptr () ->
    IO ()
appChooserWidgetApplicationActivatedCallbackWrapper _cb _ application _ = do
    application' <- (newObject Gio.AppInfo) application
    _cb  application'

onAppChooserWidgetApplicationActivated :: (GObject a, MonadIO m) => a -> AppChooserWidgetApplicationActivatedCallback -> m SignalHandlerId
onAppChooserWidgetApplicationActivated obj cb = liftIO $ connectAppChooserWidgetApplicationActivated obj cb SignalConnectBefore
afterAppChooserWidgetApplicationActivated :: (GObject a, MonadIO m) => a -> AppChooserWidgetApplicationActivatedCallback -> m SignalHandlerId
afterAppChooserWidgetApplicationActivated obj cb = connectAppChooserWidgetApplicationActivated obj cb SignalConnectAfter

connectAppChooserWidgetApplicationActivated :: (GObject a, MonadIO m) =>
                                               a -> AppChooserWidgetApplicationActivatedCallback -> SignalConnectMode -> m SignalHandlerId
connectAppChooserWidgetApplicationActivated obj cb after = liftIO $ do
    cb' <- mkAppChooserWidgetApplicationActivatedCallback (appChooserWidgetApplicationActivatedCallbackWrapper cb)
    connectSignalFunPtr obj "application-activated" cb' after

-- signal AppChooserWidget::application-selected
type AppChooserWidgetApplicationSelectedCallback =
    Gio.AppInfo ->
    IO ()

noAppChooserWidgetApplicationSelectedCallback :: Maybe AppChooserWidgetApplicationSelectedCallback
noAppChooserWidgetApplicationSelectedCallback = Nothing

type AppChooserWidgetApplicationSelectedCallbackC =
    Ptr () ->                               -- object
    Ptr Gio.AppInfo ->
    Ptr () ->                               -- user_data
    IO ()

foreign import ccall "wrapper"
    mkAppChooserWidgetApplicationSelectedCallback :: AppChooserWidgetApplicationSelectedCallbackC -> IO (FunPtr AppChooserWidgetApplicationSelectedCallbackC)

appChooserWidgetApplicationSelectedClosure :: AppChooserWidgetApplicationSelectedCallback -> IO Closure
appChooserWidgetApplicationSelectedClosure cb = newCClosure =<< mkAppChooserWidgetApplicationSelectedCallback wrapped
    where wrapped = appChooserWidgetApplicationSelectedCallbackWrapper cb

appChooserWidgetApplicationSelectedCallbackWrapper ::
    AppChooserWidgetApplicationSelectedCallback ->
    Ptr () ->
    Ptr Gio.AppInfo ->
    Ptr () ->
    IO ()
appChooserWidgetApplicationSelectedCallbackWrapper _cb _ application _ = do
    application' <- (newObject Gio.AppInfo) application
    _cb  application'

onAppChooserWidgetApplicationSelected :: (GObject a, MonadIO m) => a -> AppChooserWidgetApplicationSelectedCallback -> m SignalHandlerId
onAppChooserWidgetApplicationSelected obj cb = liftIO $ connectAppChooserWidgetApplicationSelected obj cb SignalConnectBefore
afterAppChooserWidgetApplicationSelected :: (GObject a, MonadIO m) => a -> AppChooserWidgetApplicationSelectedCallback -> m SignalHandlerId
afterAppChooserWidgetApplicationSelected obj cb = connectAppChooserWidgetApplicationSelected obj cb SignalConnectAfter

connectAppChooserWidgetApplicationSelected :: (GObject a, MonadIO m) =>
                                              a -> AppChooserWidgetApplicationSelectedCallback -> SignalConnectMode -> m SignalHandlerId
connectAppChooserWidgetApplicationSelected obj cb after = liftIO $ do
    cb' <- mkAppChooserWidgetApplicationSelectedCallback (appChooserWidgetApplicationSelectedCallbackWrapper cb)
    connectSignalFunPtr obj "application-selected" cb' after

-- signal AppChooserWidget::populate-popup
type AppChooserWidgetPopulatePopupCallback =
    Menu ->
    Gio.AppInfo ->
    IO ()

noAppChooserWidgetPopulatePopupCallback :: Maybe AppChooserWidgetPopulatePopupCallback
noAppChooserWidgetPopulatePopupCallback = Nothing

type AppChooserWidgetPopulatePopupCallbackC =
    Ptr () ->                               -- object
    Ptr Menu ->
    Ptr Gio.AppInfo ->
    Ptr () ->                               -- user_data
    IO ()

foreign import ccall "wrapper"
    mkAppChooserWidgetPopulatePopupCallback :: AppChooserWidgetPopulatePopupCallbackC -> IO (FunPtr AppChooserWidgetPopulatePopupCallbackC)

appChooserWidgetPopulatePopupClosure :: AppChooserWidgetPopulatePopupCallback -> IO Closure
appChooserWidgetPopulatePopupClosure cb = newCClosure =<< mkAppChooserWidgetPopulatePopupCallback wrapped
    where wrapped = appChooserWidgetPopulatePopupCallbackWrapper cb

appChooserWidgetPopulatePopupCallbackWrapper ::
    AppChooserWidgetPopulatePopupCallback ->
    Ptr () ->
    Ptr Menu ->
    Ptr Gio.AppInfo ->
    Ptr () ->
    IO ()
appChooserWidgetPopulatePopupCallbackWrapper _cb _ menu application _ = do
    menu' <- (newObject Menu) menu
    application' <- (newObject Gio.AppInfo) application
    _cb  menu' application'

onAppChooserWidgetPopulatePopup :: (GObject a, MonadIO m) => a -> AppChooserWidgetPopulatePopupCallback -> m SignalHandlerId
onAppChooserWidgetPopulatePopup obj cb = liftIO $ connectAppChooserWidgetPopulatePopup obj cb SignalConnectBefore
afterAppChooserWidgetPopulatePopup :: (GObject a, MonadIO m) => a -> AppChooserWidgetPopulatePopupCallback -> m SignalHandlerId
afterAppChooserWidgetPopulatePopup obj cb = connectAppChooserWidgetPopulatePopup obj cb SignalConnectAfter

connectAppChooserWidgetPopulatePopup :: (GObject a, MonadIO m) =>
                                        a -> AppChooserWidgetPopulatePopupCallback -> SignalConnectMode -> m SignalHandlerId
connectAppChooserWidgetPopulatePopup obj cb after = liftIO $ do
    cb' <- mkAppChooserWidgetPopulatePopupCallback (appChooserWidgetPopulatePopupCallbackWrapper cb)
    connectSignalFunPtr obj "populate-popup" cb' after

-- VVV Prop "default-text"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getAppChooserWidgetDefaultText :: (MonadIO m, AppChooserWidgetK o) => o -> m T.Text
getAppChooserWidgetDefaultText obj = liftIO $ getObjectPropertyString obj "default-text"

setAppChooserWidgetDefaultText :: (MonadIO m, AppChooserWidgetK o) => o -> T.Text -> m ()
setAppChooserWidgetDefaultText obj val = liftIO $ setObjectPropertyString obj "default-text" val

constructAppChooserWidgetDefaultText :: T.Text -> IO ([Char], GValue)
constructAppChooserWidgetDefaultText val = constructObjectPropertyString "default-text" val

data AppChooserWidgetDefaultTextPropertyInfo
instance AttrInfo AppChooserWidgetDefaultTextPropertyInfo where
    type AttrAllowedOps AppChooserWidgetDefaultTextPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint AppChooserWidgetDefaultTextPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint AppChooserWidgetDefaultTextPropertyInfo = AppChooserWidgetK
    type AttrGetType AppChooserWidgetDefaultTextPropertyInfo = T.Text
    type AttrLabel AppChooserWidgetDefaultTextPropertyInfo = "AppChooserWidget::default-text"
    attrGet _ = getAppChooserWidgetDefaultText
    attrSet _ = setAppChooserWidgetDefaultText
    attrConstruct _ = constructAppChooserWidgetDefaultText

-- VVV Prop "show-all"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getAppChooserWidgetShowAll :: (MonadIO m, AppChooserWidgetK o) => o -> m Bool
getAppChooserWidgetShowAll obj = liftIO $ getObjectPropertyBool obj "show-all"

setAppChooserWidgetShowAll :: (MonadIO m, AppChooserWidgetK o) => o -> Bool -> m ()
setAppChooserWidgetShowAll obj val = liftIO $ setObjectPropertyBool obj "show-all" val

constructAppChooserWidgetShowAll :: Bool -> IO ([Char], GValue)
constructAppChooserWidgetShowAll val = constructObjectPropertyBool "show-all" val

data AppChooserWidgetShowAllPropertyInfo
instance AttrInfo AppChooserWidgetShowAllPropertyInfo where
    type AttrAllowedOps AppChooserWidgetShowAllPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint AppChooserWidgetShowAllPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint AppChooserWidgetShowAllPropertyInfo = AppChooserWidgetK
    type AttrGetType AppChooserWidgetShowAllPropertyInfo = Bool
    type AttrLabel AppChooserWidgetShowAllPropertyInfo = "AppChooserWidget::show-all"
    attrGet _ = getAppChooserWidgetShowAll
    attrSet _ = setAppChooserWidgetShowAll
    attrConstruct _ = constructAppChooserWidgetShowAll

-- VVV Prop "show-default"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getAppChooserWidgetShowDefault :: (MonadIO m, AppChooserWidgetK o) => o -> m Bool
getAppChooserWidgetShowDefault obj = liftIO $ getObjectPropertyBool obj "show-default"

setAppChooserWidgetShowDefault :: (MonadIO m, AppChooserWidgetK o) => o -> Bool -> m ()
setAppChooserWidgetShowDefault obj val = liftIO $ setObjectPropertyBool obj "show-default" val

constructAppChooserWidgetShowDefault :: Bool -> IO ([Char], GValue)
constructAppChooserWidgetShowDefault val = constructObjectPropertyBool "show-default" val

data AppChooserWidgetShowDefaultPropertyInfo
instance AttrInfo AppChooserWidgetShowDefaultPropertyInfo where
    type AttrAllowedOps AppChooserWidgetShowDefaultPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint AppChooserWidgetShowDefaultPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint AppChooserWidgetShowDefaultPropertyInfo = AppChooserWidgetK
    type AttrGetType AppChooserWidgetShowDefaultPropertyInfo = Bool
    type AttrLabel AppChooserWidgetShowDefaultPropertyInfo = "AppChooserWidget::show-default"
    attrGet _ = getAppChooserWidgetShowDefault
    attrSet _ = setAppChooserWidgetShowDefault
    attrConstruct _ = constructAppChooserWidgetShowDefault

-- VVV Prop "show-fallback"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getAppChooserWidgetShowFallback :: (MonadIO m, AppChooserWidgetK o) => o -> m Bool
getAppChooserWidgetShowFallback obj = liftIO $ getObjectPropertyBool obj "show-fallback"

setAppChooserWidgetShowFallback :: (MonadIO m, AppChooserWidgetK o) => o -> Bool -> m ()
setAppChooserWidgetShowFallback obj val = liftIO $ setObjectPropertyBool obj "show-fallback" val

constructAppChooserWidgetShowFallback :: Bool -> IO ([Char], GValue)
constructAppChooserWidgetShowFallback val = constructObjectPropertyBool "show-fallback" val

data AppChooserWidgetShowFallbackPropertyInfo
instance AttrInfo AppChooserWidgetShowFallbackPropertyInfo where
    type AttrAllowedOps AppChooserWidgetShowFallbackPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint AppChooserWidgetShowFallbackPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint AppChooserWidgetShowFallbackPropertyInfo = AppChooserWidgetK
    type AttrGetType AppChooserWidgetShowFallbackPropertyInfo = Bool
    type AttrLabel AppChooserWidgetShowFallbackPropertyInfo = "AppChooserWidget::show-fallback"
    attrGet _ = getAppChooserWidgetShowFallback
    attrSet _ = setAppChooserWidgetShowFallback
    attrConstruct _ = constructAppChooserWidgetShowFallback

-- VVV Prop "show-other"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getAppChooserWidgetShowOther :: (MonadIO m, AppChooserWidgetK o) => o -> m Bool
getAppChooserWidgetShowOther obj = liftIO $ getObjectPropertyBool obj "show-other"

setAppChooserWidgetShowOther :: (MonadIO m, AppChooserWidgetK o) => o -> Bool -> m ()
setAppChooserWidgetShowOther obj val = liftIO $ setObjectPropertyBool obj "show-other" val

constructAppChooserWidgetShowOther :: Bool -> IO ([Char], GValue)
constructAppChooserWidgetShowOther val = constructObjectPropertyBool "show-other" val

data AppChooserWidgetShowOtherPropertyInfo
instance AttrInfo AppChooserWidgetShowOtherPropertyInfo where
    type AttrAllowedOps AppChooserWidgetShowOtherPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint AppChooserWidgetShowOtherPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint AppChooserWidgetShowOtherPropertyInfo = AppChooserWidgetK
    type AttrGetType AppChooserWidgetShowOtherPropertyInfo = Bool
    type AttrLabel AppChooserWidgetShowOtherPropertyInfo = "AppChooserWidget::show-other"
    attrGet _ = getAppChooserWidgetShowOther
    attrSet _ = setAppChooserWidgetShowOther
    attrConstruct _ = constructAppChooserWidgetShowOther

-- VVV Prop "show-recommended"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getAppChooserWidgetShowRecommended :: (MonadIO m, AppChooserWidgetK o) => o -> m Bool
getAppChooserWidgetShowRecommended obj = liftIO $ getObjectPropertyBool obj "show-recommended"

setAppChooserWidgetShowRecommended :: (MonadIO m, AppChooserWidgetK o) => o -> Bool -> m ()
setAppChooserWidgetShowRecommended obj val = liftIO $ setObjectPropertyBool obj "show-recommended" val

constructAppChooserWidgetShowRecommended :: Bool -> IO ([Char], GValue)
constructAppChooserWidgetShowRecommended val = constructObjectPropertyBool "show-recommended" val

data AppChooserWidgetShowRecommendedPropertyInfo
instance AttrInfo AppChooserWidgetShowRecommendedPropertyInfo where
    type AttrAllowedOps AppChooserWidgetShowRecommendedPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint AppChooserWidgetShowRecommendedPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint AppChooserWidgetShowRecommendedPropertyInfo = AppChooserWidgetK
    type AttrGetType AppChooserWidgetShowRecommendedPropertyInfo = Bool
    type AttrLabel AppChooserWidgetShowRecommendedPropertyInfo = "AppChooserWidget::show-recommended"
    attrGet _ = getAppChooserWidgetShowRecommended
    attrSet _ = setAppChooserWidgetShowRecommended
    attrConstruct _ = constructAppChooserWidgetShowRecommended

type instance AttributeList AppChooserWidget = AppChooserWidgetAttributeList
type AppChooserWidgetAttributeList = ('[ '("app-paintable", WidgetAppPaintablePropertyInfo), '("baseline-position", BoxBaselinePositionPropertyInfo), '("border-width", ContainerBorderWidthPropertyInfo), '("can-default", WidgetCanDefaultPropertyInfo), '("can-focus", WidgetCanFocusPropertyInfo), '("child", ContainerChildPropertyInfo), '("composite-child", WidgetCompositeChildPropertyInfo), '("content-type", AppChooserContentTypePropertyInfo), '("default-text", AppChooserWidgetDefaultTextPropertyInfo), '("double-buffered", WidgetDoubleBufferedPropertyInfo), '("events", WidgetEventsPropertyInfo), '("expand", WidgetExpandPropertyInfo), '("halign", WidgetHalignPropertyInfo), '("has-default", WidgetHasDefaultPropertyInfo), '("has-focus", WidgetHasFocusPropertyInfo), '("has-tooltip", WidgetHasTooltipPropertyInfo), '("height-request", WidgetHeightRequestPropertyInfo), '("hexpand", WidgetHexpandPropertyInfo), '("hexpand-set", WidgetHexpandSetPropertyInfo), '("homogeneous", BoxHomogeneousPropertyInfo), '("is-focus", WidgetIsFocusPropertyInfo), '("margin", WidgetMarginPropertyInfo), '("margin-bottom", WidgetMarginBottomPropertyInfo), '("margin-end", WidgetMarginEndPropertyInfo), '("margin-left", WidgetMarginLeftPropertyInfo), '("margin-right", WidgetMarginRightPropertyInfo), '("margin-start", WidgetMarginStartPropertyInfo), '("margin-top", WidgetMarginTopPropertyInfo), '("name", WidgetNamePropertyInfo), '("no-show-all", WidgetNoShowAllPropertyInfo), '("opacity", WidgetOpacityPropertyInfo), '("orientation", OrientableOrientationPropertyInfo), '("parent", WidgetParentPropertyInfo), '("receives-default", WidgetReceivesDefaultPropertyInfo), '("resize-mode", ContainerResizeModePropertyInfo), '("scale-factor", WidgetScaleFactorPropertyInfo), '("sensitive", WidgetSensitivePropertyInfo), '("show-all", AppChooserWidgetShowAllPropertyInfo), '("show-default", AppChooserWidgetShowDefaultPropertyInfo), '("show-fallback", AppChooserWidgetShowFallbackPropertyInfo), '("show-other", AppChooserWidgetShowOtherPropertyInfo), '("show-recommended", AppChooserWidgetShowRecommendedPropertyInfo), '("spacing", BoxSpacingPropertyInfo), '("style", WidgetStylePropertyInfo), '("tooltip-markup", WidgetTooltipMarkupPropertyInfo), '("tooltip-text", WidgetTooltipTextPropertyInfo), '("valign", WidgetValignPropertyInfo), '("vexpand", WidgetVexpandPropertyInfo), '("vexpand-set", WidgetVexpandSetPropertyInfo), '("visible", WidgetVisiblePropertyInfo), '("width-request", WidgetWidthRequestPropertyInfo), '("window", WidgetWindowPropertyInfo)] :: [(Symbol, *)])

data AppChooserWidgetApplicationActivatedSignalInfo
instance SignalInfo AppChooserWidgetApplicationActivatedSignalInfo where
    type HaskellCallbackType AppChooserWidgetApplicationActivatedSignalInfo = AppChooserWidgetApplicationActivatedCallback
    connectSignal _ = connectAppChooserWidgetApplicationActivated

data AppChooserWidgetApplicationSelectedSignalInfo
instance SignalInfo AppChooserWidgetApplicationSelectedSignalInfo where
    type HaskellCallbackType AppChooserWidgetApplicationSelectedSignalInfo = AppChooserWidgetApplicationSelectedCallback
    connectSignal _ = connectAppChooserWidgetApplicationSelected

data AppChooserWidgetPopulatePopupSignalInfo
instance SignalInfo AppChooserWidgetPopulatePopupSignalInfo where
    type HaskellCallbackType AppChooserWidgetPopulatePopupSignalInfo = AppChooserWidgetPopulatePopupCallback
    connectSignal _ = connectAppChooserWidgetPopulatePopup

type instance SignalList AppChooserWidget = AppChooserWidgetSignalList
type AppChooserWidgetSignalList = ('[ '("accel-closures-changed", WidgetAccelClosuresChangedSignalInfo), '("add", ContainerAddSignalInfo), '("application-activated", AppChooserWidgetApplicationActivatedSignalInfo), '("application-selected", AppChooserWidgetApplicationSelectedSignalInfo), '("button-press-event", WidgetButtonPressEventSignalInfo), '("button-release-event", WidgetButtonReleaseEventSignalInfo), '("can-activate-accel", WidgetCanActivateAccelSignalInfo), '("check-resize", ContainerCheckResizeSignalInfo), '("child-notify", WidgetChildNotifySignalInfo), '("composited-changed", WidgetCompositedChangedSignalInfo), '("configure-event", WidgetConfigureEventSignalInfo), '("damage-event", WidgetDamageEventSignalInfo), '("delete-event", WidgetDeleteEventSignalInfo), '("destroy", WidgetDestroySignalInfo), '("destroy-event", WidgetDestroyEventSignalInfo), '("direction-changed", WidgetDirectionChangedSignalInfo), '("drag-begin", WidgetDragBeginSignalInfo), '("drag-data-delete", WidgetDragDataDeleteSignalInfo), '("drag-data-get", WidgetDragDataGetSignalInfo), '("drag-data-received", WidgetDragDataReceivedSignalInfo), '("drag-drop", WidgetDragDropSignalInfo), '("drag-end", WidgetDragEndSignalInfo), '("drag-failed", WidgetDragFailedSignalInfo), '("drag-leave", WidgetDragLeaveSignalInfo), '("drag-motion", WidgetDragMotionSignalInfo), '("draw", WidgetDrawSignalInfo), '("enter-notify-event", WidgetEnterNotifyEventSignalInfo), '("event", WidgetEventSignalInfo), '("event-after", WidgetEventAfterSignalInfo), '("focus", WidgetFocusSignalInfo), '("focus-in-event", WidgetFocusInEventSignalInfo), '("focus-out-event", WidgetFocusOutEventSignalInfo), '("grab-broken-event", WidgetGrabBrokenEventSignalInfo), '("grab-focus", WidgetGrabFocusSignalInfo), '("grab-notify", WidgetGrabNotifySignalInfo), '("hide", WidgetHideSignalInfo), '("hierarchy-changed", WidgetHierarchyChangedSignalInfo), '("key-press-event", WidgetKeyPressEventSignalInfo), '("key-release-event", WidgetKeyReleaseEventSignalInfo), '("keynav-failed", WidgetKeynavFailedSignalInfo), '("leave-notify-event", WidgetLeaveNotifyEventSignalInfo), '("map", WidgetMapSignalInfo), '("map-event", WidgetMapEventSignalInfo), '("mnemonic-activate", WidgetMnemonicActivateSignalInfo), '("motion-notify-event", WidgetMotionNotifyEventSignalInfo), '("move-focus", WidgetMoveFocusSignalInfo), '("notify", GObject.ObjectNotifySignalInfo), '("parent-set", WidgetParentSetSignalInfo), '("populate-popup", AppChooserWidgetPopulatePopupSignalInfo), '("popup-menu", WidgetPopupMenuSignalInfo), '("property-notify-event", WidgetPropertyNotifyEventSignalInfo), '("proximity-in-event", WidgetProximityInEventSignalInfo), '("proximity-out-event", WidgetProximityOutEventSignalInfo), '("query-tooltip", WidgetQueryTooltipSignalInfo), '("realize", WidgetRealizeSignalInfo), '("remove", ContainerRemoveSignalInfo), '("screen-changed", WidgetScreenChangedSignalInfo), '("scroll-event", WidgetScrollEventSignalInfo), '("selection-clear-event", WidgetSelectionClearEventSignalInfo), '("selection-get", WidgetSelectionGetSignalInfo), '("selection-notify-event", WidgetSelectionNotifyEventSignalInfo), '("selection-received", WidgetSelectionReceivedSignalInfo), '("selection-request-event", WidgetSelectionRequestEventSignalInfo), '("set-focus-child", ContainerSetFocusChildSignalInfo), '("show", WidgetShowSignalInfo), '("show-help", WidgetShowHelpSignalInfo), '("size-allocate", WidgetSizeAllocateSignalInfo), '("state-changed", WidgetStateChangedSignalInfo), '("state-flags-changed", WidgetStateFlagsChangedSignalInfo), '("style-set", WidgetStyleSetSignalInfo), '("style-updated", WidgetStyleUpdatedSignalInfo), '("touch-event", WidgetTouchEventSignalInfo), '("unmap", WidgetUnmapSignalInfo), '("unmap-event", WidgetUnmapEventSignalInfo), '("unrealize", WidgetUnrealizeSignalInfo), '("visibility-notify-event", WidgetVisibilityNotifyEventSignalInfo), '("window-state-event", WidgetWindowStateEventSignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method AppChooserWidget::new
-- method type : Constructor
-- Args : [Arg {argName = "content_type", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "content_type", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "Gtk" "AppChooserWidget"
-- throws : False
-- Skip return : False

foreign import ccall "gtk_app_chooser_widget_new" gtk_app_chooser_widget_new :: 
    CString ->                              -- content_type : TBasicType TUTF8
    IO (Ptr AppChooserWidget)


appChooserWidgetNew ::
    (MonadIO m) =>
    T.Text ->                               -- content_type
    m AppChooserWidget
appChooserWidgetNew content_type = liftIO $ do
    content_type' <- textToCString content_type
    result <- gtk_app_chooser_widget_new content_type'
    checkUnexpectedReturnNULL "gtk_app_chooser_widget_new" result
    result' <- (newObject AppChooserWidget) result
    freeMem content_type'
    return result'

-- method AppChooserWidget::get_default_text
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "AppChooserWidget", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "AppChooserWidget", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "gtk_app_chooser_widget_get_default_text" gtk_app_chooser_widget_get_default_text :: 
    Ptr AppChooserWidget ->                 -- _obj : TInterface "Gtk" "AppChooserWidget"
    IO CString


appChooserWidgetGetDefaultText ::
    (MonadIO m, AppChooserWidgetK a) =>
    a ->                                    -- _obj
    m T.Text
appChooserWidgetGetDefaultText _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- gtk_app_chooser_widget_get_default_text _obj'
    checkUnexpectedReturnNULL "gtk_app_chooser_widget_get_default_text" result
    result' <- cstringToText result
    touchManagedPtr _obj
    return result'

-- method AppChooserWidget::get_show_all
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "AppChooserWidget", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "AppChooserWidget", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "gtk_app_chooser_widget_get_show_all" gtk_app_chooser_widget_get_show_all :: 
    Ptr AppChooserWidget ->                 -- _obj : TInterface "Gtk" "AppChooserWidget"
    IO CInt


appChooserWidgetGetShowAll ::
    (MonadIO m, AppChooserWidgetK a) =>
    a ->                                    -- _obj
    m Bool
appChooserWidgetGetShowAll _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- gtk_app_chooser_widget_get_show_all _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method AppChooserWidget::get_show_default
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "AppChooserWidget", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "AppChooserWidget", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "gtk_app_chooser_widget_get_show_default" gtk_app_chooser_widget_get_show_default :: 
    Ptr AppChooserWidget ->                 -- _obj : TInterface "Gtk" "AppChooserWidget"
    IO CInt


appChooserWidgetGetShowDefault ::
    (MonadIO m, AppChooserWidgetK a) =>
    a ->                                    -- _obj
    m Bool
appChooserWidgetGetShowDefault _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- gtk_app_chooser_widget_get_show_default _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method AppChooserWidget::get_show_fallback
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "AppChooserWidget", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "AppChooserWidget", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "gtk_app_chooser_widget_get_show_fallback" gtk_app_chooser_widget_get_show_fallback :: 
    Ptr AppChooserWidget ->                 -- _obj : TInterface "Gtk" "AppChooserWidget"
    IO CInt


appChooserWidgetGetShowFallback ::
    (MonadIO m, AppChooserWidgetK a) =>
    a ->                                    -- _obj
    m Bool
appChooserWidgetGetShowFallback _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- gtk_app_chooser_widget_get_show_fallback _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method AppChooserWidget::get_show_other
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "AppChooserWidget", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "AppChooserWidget", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "gtk_app_chooser_widget_get_show_other" gtk_app_chooser_widget_get_show_other :: 
    Ptr AppChooserWidget ->                 -- _obj : TInterface "Gtk" "AppChooserWidget"
    IO CInt


appChooserWidgetGetShowOther ::
    (MonadIO m, AppChooserWidgetK a) =>
    a ->                                    -- _obj
    m Bool
appChooserWidgetGetShowOther _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- gtk_app_chooser_widget_get_show_other _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method AppChooserWidget::get_show_recommended
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "AppChooserWidget", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "AppChooserWidget", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "gtk_app_chooser_widget_get_show_recommended" gtk_app_chooser_widget_get_show_recommended :: 
    Ptr AppChooserWidget ->                 -- _obj : TInterface "Gtk" "AppChooserWidget"
    IO CInt


appChooserWidgetGetShowRecommended ::
    (MonadIO m, AppChooserWidgetK a) =>
    a ->                                    -- _obj
    m Bool
appChooserWidgetGetShowRecommended _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- gtk_app_chooser_widget_get_show_recommended _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method AppChooserWidget::set_default_text
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "AppChooserWidget", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "text", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "AppChooserWidget", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "text", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_app_chooser_widget_set_default_text" gtk_app_chooser_widget_set_default_text :: 
    Ptr AppChooserWidget ->                 -- _obj : TInterface "Gtk" "AppChooserWidget"
    CString ->                              -- text : TBasicType TUTF8
    IO ()


appChooserWidgetSetDefaultText ::
    (MonadIO m, AppChooserWidgetK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- text
    m ()
appChooserWidgetSetDefaultText _obj text = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    text' <- textToCString text
    gtk_app_chooser_widget_set_default_text _obj' text'
    touchManagedPtr _obj
    freeMem text'
    return ()

-- method AppChooserWidget::set_show_all
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "AppChooserWidget", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "setting", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "AppChooserWidget", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "setting", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_app_chooser_widget_set_show_all" gtk_app_chooser_widget_set_show_all :: 
    Ptr AppChooserWidget ->                 -- _obj : TInterface "Gtk" "AppChooserWidget"
    CInt ->                                 -- setting : TBasicType TBoolean
    IO ()


appChooserWidgetSetShowAll ::
    (MonadIO m, AppChooserWidgetK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- setting
    m ()
appChooserWidgetSetShowAll _obj setting = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let setting' = (fromIntegral . fromEnum) setting
    gtk_app_chooser_widget_set_show_all _obj' setting'
    touchManagedPtr _obj
    return ()

-- method AppChooserWidget::set_show_default
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "AppChooserWidget", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "setting", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "AppChooserWidget", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "setting", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_app_chooser_widget_set_show_default" gtk_app_chooser_widget_set_show_default :: 
    Ptr AppChooserWidget ->                 -- _obj : TInterface "Gtk" "AppChooserWidget"
    CInt ->                                 -- setting : TBasicType TBoolean
    IO ()


appChooserWidgetSetShowDefault ::
    (MonadIO m, AppChooserWidgetK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- setting
    m ()
appChooserWidgetSetShowDefault _obj setting = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let setting' = (fromIntegral . fromEnum) setting
    gtk_app_chooser_widget_set_show_default _obj' setting'
    touchManagedPtr _obj
    return ()

-- method AppChooserWidget::set_show_fallback
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "AppChooserWidget", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "setting", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "AppChooserWidget", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "setting", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_app_chooser_widget_set_show_fallback" gtk_app_chooser_widget_set_show_fallback :: 
    Ptr AppChooserWidget ->                 -- _obj : TInterface "Gtk" "AppChooserWidget"
    CInt ->                                 -- setting : TBasicType TBoolean
    IO ()


appChooserWidgetSetShowFallback ::
    (MonadIO m, AppChooserWidgetK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- setting
    m ()
appChooserWidgetSetShowFallback _obj setting = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let setting' = (fromIntegral . fromEnum) setting
    gtk_app_chooser_widget_set_show_fallback _obj' setting'
    touchManagedPtr _obj
    return ()

-- method AppChooserWidget::set_show_other
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "AppChooserWidget", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "setting", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "AppChooserWidget", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "setting", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_app_chooser_widget_set_show_other" gtk_app_chooser_widget_set_show_other :: 
    Ptr AppChooserWidget ->                 -- _obj : TInterface "Gtk" "AppChooserWidget"
    CInt ->                                 -- setting : TBasicType TBoolean
    IO ()


appChooserWidgetSetShowOther ::
    (MonadIO m, AppChooserWidgetK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- setting
    m ()
appChooserWidgetSetShowOther _obj setting = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let setting' = (fromIntegral . fromEnum) setting
    gtk_app_chooser_widget_set_show_other _obj' setting'
    touchManagedPtr _obj
    return ()

-- method AppChooserWidget::set_show_recommended
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "AppChooserWidget", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "setting", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "AppChooserWidget", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "setting", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_app_chooser_widget_set_show_recommended" gtk_app_chooser_widget_set_show_recommended :: 
    Ptr AppChooserWidget ->                 -- _obj : TInterface "Gtk" "AppChooserWidget"
    CInt ->                                 -- setting : TBasicType TBoolean
    IO ()


appChooserWidgetSetShowRecommended ::
    (MonadIO m, AppChooserWidgetK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- setting
    m ()
appChooserWidgetSetShowRecommended _obj setting = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let setting' = (fromIntegral . fromEnum) setting
    gtk_app_chooser_widget_set_show_recommended _obj' setting'
    touchManagedPtr _obj
    return ()


