
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Gtk.Objects.CellRendererPixbuf
    ( 

-- * Exported types
    CellRendererPixbuf(..)                  ,
    CellRendererPixbufK                     ,
    toCellRendererPixbuf                    ,
    noCellRendererPixbuf                    ,


 -- * Methods
-- ** cellRendererPixbufNew
    cellRendererPixbufNew                   ,




 -- * Properties
-- ** FollowState
    CellRendererPixbufFollowStatePropertyInfo,
    constructCellRendererPixbufFollowState  ,
    getCellRendererPixbufFollowState        ,
    setCellRendererPixbufFollowState        ,


-- ** Gicon
    CellRendererPixbufGiconPropertyInfo     ,
    constructCellRendererPixbufGicon        ,
    getCellRendererPixbufGicon              ,
    setCellRendererPixbufGicon              ,


-- ** IconName
    CellRendererPixbufIconNamePropertyInfo  ,
    constructCellRendererPixbufIconName     ,
    getCellRendererPixbufIconName           ,
    setCellRendererPixbufIconName           ,


-- ** Pixbuf
    CellRendererPixbufPixbufPropertyInfo    ,
    constructCellRendererPixbufPixbuf       ,
    getCellRendererPixbufPixbuf             ,
    setCellRendererPixbufPixbuf             ,


-- ** PixbufExpanderClosed
    CellRendererPixbufPixbufExpanderClosedPropertyInfo,
    constructCellRendererPixbufPixbufExpanderClosed,
    getCellRendererPixbufPixbufExpanderClosed,
    setCellRendererPixbufPixbufExpanderClosed,


-- ** PixbufExpanderOpen
    CellRendererPixbufPixbufExpanderOpenPropertyInfo,
    constructCellRendererPixbufPixbufExpanderOpen,
    getCellRendererPixbufPixbufExpanderOpen ,
    setCellRendererPixbufPixbufExpanderOpen ,


-- ** StockDetail
    CellRendererPixbufStockDetailPropertyInfo,
    constructCellRendererPixbufStockDetail  ,
    getCellRendererPixbufStockDetail        ,
    setCellRendererPixbufStockDetail        ,


-- ** StockId
    CellRendererPixbufStockIdPropertyInfo   ,
    constructCellRendererPixbufStockId      ,
    getCellRendererPixbufStockId            ,
    setCellRendererPixbufStockId            ,


-- ** StockSize
    CellRendererPixbufStockSizePropertyInfo ,
    constructCellRendererPixbufStockSize    ,
    getCellRendererPixbufStockSize          ,
    setCellRendererPixbufStockSize          ,


-- ** Surface
    CellRendererPixbufSurfacePropertyInfo   ,
    constructCellRendererPixbufSurface      ,
    getCellRendererPixbufSurface            ,
    setCellRendererPixbufSurface            ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Gtk.Types
import GI.Gtk.Callbacks
import qualified GI.GObject as GObject
import qualified GI.GdkPixbuf as GdkPixbuf
import qualified GI.Gio as Gio
import qualified GI.Cairo as Cairo

newtype CellRendererPixbuf = CellRendererPixbuf (ForeignPtr CellRendererPixbuf)
foreign import ccall "gtk_cell_renderer_pixbuf_get_type"
    c_gtk_cell_renderer_pixbuf_get_type :: IO GType

type instance ParentTypes CellRendererPixbuf = CellRendererPixbufParentTypes
type CellRendererPixbufParentTypes = '[CellRenderer, GObject.Object]

instance GObject CellRendererPixbuf where
    gobjectIsInitiallyUnowned _ = True
    gobjectType _ = c_gtk_cell_renderer_pixbuf_get_type
    

class GObject o => CellRendererPixbufK o
instance (GObject o, IsDescendantOf CellRendererPixbuf o) => CellRendererPixbufK o

toCellRendererPixbuf :: CellRendererPixbufK o => o -> IO CellRendererPixbuf
toCellRendererPixbuf = unsafeCastTo CellRendererPixbuf

noCellRendererPixbuf :: Maybe CellRendererPixbuf
noCellRendererPixbuf = Nothing

-- VVV Prop "follow-state"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getCellRendererPixbufFollowState :: (MonadIO m, CellRendererPixbufK o) => o -> m Bool
getCellRendererPixbufFollowState obj = liftIO $ getObjectPropertyBool obj "follow-state"

setCellRendererPixbufFollowState :: (MonadIO m, CellRendererPixbufK o) => o -> Bool -> m ()
setCellRendererPixbufFollowState obj val = liftIO $ setObjectPropertyBool obj "follow-state" val

constructCellRendererPixbufFollowState :: Bool -> IO ([Char], GValue)
constructCellRendererPixbufFollowState val = constructObjectPropertyBool "follow-state" val

data CellRendererPixbufFollowStatePropertyInfo
instance AttrInfo CellRendererPixbufFollowStatePropertyInfo where
    type AttrAllowedOps CellRendererPixbufFollowStatePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint CellRendererPixbufFollowStatePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint CellRendererPixbufFollowStatePropertyInfo = CellRendererPixbufK
    type AttrGetType CellRendererPixbufFollowStatePropertyInfo = Bool
    type AttrLabel CellRendererPixbufFollowStatePropertyInfo = "CellRendererPixbuf::follow-state"
    attrGet _ = getCellRendererPixbufFollowState
    attrSet _ = setCellRendererPixbufFollowState
    attrConstruct _ = constructCellRendererPixbufFollowState

-- VVV Prop "gicon"
   -- Type: TInterface "Gio" "Icon"
   -- Flags: [PropertyReadable,PropertyWritable]

getCellRendererPixbufGicon :: (MonadIO m, CellRendererPixbufK o) => o -> m Gio.Icon
getCellRendererPixbufGicon obj = liftIO $ getObjectPropertyObject obj "gicon" Gio.Icon

setCellRendererPixbufGicon :: (MonadIO m, CellRendererPixbufK o, Gio.IconK a) => o -> a -> m ()
setCellRendererPixbufGicon obj val = liftIO $ setObjectPropertyObject obj "gicon" val

constructCellRendererPixbufGicon :: (Gio.IconK a) => a -> IO ([Char], GValue)
constructCellRendererPixbufGicon val = constructObjectPropertyObject "gicon" val

data CellRendererPixbufGiconPropertyInfo
instance AttrInfo CellRendererPixbufGiconPropertyInfo where
    type AttrAllowedOps CellRendererPixbufGiconPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint CellRendererPixbufGiconPropertyInfo = Gio.IconK
    type AttrBaseTypeConstraint CellRendererPixbufGiconPropertyInfo = CellRendererPixbufK
    type AttrGetType CellRendererPixbufGiconPropertyInfo = Gio.Icon
    type AttrLabel CellRendererPixbufGiconPropertyInfo = "CellRendererPixbuf::gicon"
    attrGet _ = getCellRendererPixbufGicon
    attrSet _ = setCellRendererPixbufGicon
    attrConstruct _ = constructCellRendererPixbufGicon

-- VVV Prop "icon-name"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getCellRendererPixbufIconName :: (MonadIO m, CellRendererPixbufK o) => o -> m T.Text
getCellRendererPixbufIconName obj = liftIO $ getObjectPropertyString obj "icon-name"

setCellRendererPixbufIconName :: (MonadIO m, CellRendererPixbufK o) => o -> T.Text -> m ()
setCellRendererPixbufIconName obj val = liftIO $ setObjectPropertyString obj "icon-name" val

constructCellRendererPixbufIconName :: T.Text -> IO ([Char], GValue)
constructCellRendererPixbufIconName val = constructObjectPropertyString "icon-name" val

data CellRendererPixbufIconNamePropertyInfo
instance AttrInfo CellRendererPixbufIconNamePropertyInfo where
    type AttrAllowedOps CellRendererPixbufIconNamePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint CellRendererPixbufIconNamePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint CellRendererPixbufIconNamePropertyInfo = CellRendererPixbufK
    type AttrGetType CellRendererPixbufIconNamePropertyInfo = T.Text
    type AttrLabel CellRendererPixbufIconNamePropertyInfo = "CellRendererPixbuf::icon-name"
    attrGet _ = getCellRendererPixbufIconName
    attrSet _ = setCellRendererPixbufIconName
    attrConstruct _ = constructCellRendererPixbufIconName

-- VVV Prop "pixbuf"
   -- Type: TInterface "GdkPixbuf" "Pixbuf"
   -- Flags: [PropertyReadable,PropertyWritable]

getCellRendererPixbufPixbuf :: (MonadIO m, CellRendererPixbufK o) => o -> m GdkPixbuf.Pixbuf
getCellRendererPixbufPixbuf obj = liftIO $ getObjectPropertyObject obj "pixbuf" GdkPixbuf.Pixbuf

setCellRendererPixbufPixbuf :: (MonadIO m, CellRendererPixbufK o, GdkPixbuf.PixbufK a) => o -> a -> m ()
setCellRendererPixbufPixbuf obj val = liftIO $ setObjectPropertyObject obj "pixbuf" val

constructCellRendererPixbufPixbuf :: (GdkPixbuf.PixbufK a) => a -> IO ([Char], GValue)
constructCellRendererPixbufPixbuf val = constructObjectPropertyObject "pixbuf" val

data CellRendererPixbufPixbufPropertyInfo
instance AttrInfo CellRendererPixbufPixbufPropertyInfo where
    type AttrAllowedOps CellRendererPixbufPixbufPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint CellRendererPixbufPixbufPropertyInfo = GdkPixbuf.PixbufK
    type AttrBaseTypeConstraint CellRendererPixbufPixbufPropertyInfo = CellRendererPixbufK
    type AttrGetType CellRendererPixbufPixbufPropertyInfo = GdkPixbuf.Pixbuf
    type AttrLabel CellRendererPixbufPixbufPropertyInfo = "CellRendererPixbuf::pixbuf"
    attrGet _ = getCellRendererPixbufPixbuf
    attrSet _ = setCellRendererPixbufPixbuf
    attrConstruct _ = constructCellRendererPixbufPixbuf

-- VVV Prop "pixbuf-expander-closed"
   -- Type: TInterface "GdkPixbuf" "Pixbuf"
   -- Flags: [PropertyReadable,PropertyWritable]

getCellRendererPixbufPixbufExpanderClosed :: (MonadIO m, CellRendererPixbufK o) => o -> m GdkPixbuf.Pixbuf
getCellRendererPixbufPixbufExpanderClosed obj = liftIO $ getObjectPropertyObject obj "pixbuf-expander-closed" GdkPixbuf.Pixbuf

setCellRendererPixbufPixbufExpanderClosed :: (MonadIO m, CellRendererPixbufK o, GdkPixbuf.PixbufK a) => o -> a -> m ()
setCellRendererPixbufPixbufExpanderClosed obj val = liftIO $ setObjectPropertyObject obj "pixbuf-expander-closed" val

constructCellRendererPixbufPixbufExpanderClosed :: (GdkPixbuf.PixbufK a) => a -> IO ([Char], GValue)
constructCellRendererPixbufPixbufExpanderClosed val = constructObjectPropertyObject "pixbuf-expander-closed" val

data CellRendererPixbufPixbufExpanderClosedPropertyInfo
instance AttrInfo CellRendererPixbufPixbufExpanderClosedPropertyInfo where
    type AttrAllowedOps CellRendererPixbufPixbufExpanderClosedPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint CellRendererPixbufPixbufExpanderClosedPropertyInfo = GdkPixbuf.PixbufK
    type AttrBaseTypeConstraint CellRendererPixbufPixbufExpanderClosedPropertyInfo = CellRendererPixbufK
    type AttrGetType CellRendererPixbufPixbufExpanderClosedPropertyInfo = GdkPixbuf.Pixbuf
    type AttrLabel CellRendererPixbufPixbufExpanderClosedPropertyInfo = "CellRendererPixbuf::pixbuf-expander-closed"
    attrGet _ = getCellRendererPixbufPixbufExpanderClosed
    attrSet _ = setCellRendererPixbufPixbufExpanderClosed
    attrConstruct _ = constructCellRendererPixbufPixbufExpanderClosed

-- VVV Prop "pixbuf-expander-open"
   -- Type: TInterface "GdkPixbuf" "Pixbuf"
   -- Flags: [PropertyReadable,PropertyWritable]

getCellRendererPixbufPixbufExpanderOpen :: (MonadIO m, CellRendererPixbufK o) => o -> m GdkPixbuf.Pixbuf
getCellRendererPixbufPixbufExpanderOpen obj = liftIO $ getObjectPropertyObject obj "pixbuf-expander-open" GdkPixbuf.Pixbuf

setCellRendererPixbufPixbufExpanderOpen :: (MonadIO m, CellRendererPixbufK o, GdkPixbuf.PixbufK a) => o -> a -> m ()
setCellRendererPixbufPixbufExpanderOpen obj val = liftIO $ setObjectPropertyObject obj "pixbuf-expander-open" val

constructCellRendererPixbufPixbufExpanderOpen :: (GdkPixbuf.PixbufK a) => a -> IO ([Char], GValue)
constructCellRendererPixbufPixbufExpanderOpen val = constructObjectPropertyObject "pixbuf-expander-open" val

data CellRendererPixbufPixbufExpanderOpenPropertyInfo
instance AttrInfo CellRendererPixbufPixbufExpanderOpenPropertyInfo where
    type AttrAllowedOps CellRendererPixbufPixbufExpanderOpenPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint CellRendererPixbufPixbufExpanderOpenPropertyInfo = GdkPixbuf.PixbufK
    type AttrBaseTypeConstraint CellRendererPixbufPixbufExpanderOpenPropertyInfo = CellRendererPixbufK
    type AttrGetType CellRendererPixbufPixbufExpanderOpenPropertyInfo = GdkPixbuf.Pixbuf
    type AttrLabel CellRendererPixbufPixbufExpanderOpenPropertyInfo = "CellRendererPixbuf::pixbuf-expander-open"
    attrGet _ = getCellRendererPixbufPixbufExpanderOpen
    attrSet _ = setCellRendererPixbufPixbufExpanderOpen
    attrConstruct _ = constructCellRendererPixbufPixbufExpanderOpen

-- VVV Prop "stock-detail"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getCellRendererPixbufStockDetail :: (MonadIO m, CellRendererPixbufK o) => o -> m T.Text
getCellRendererPixbufStockDetail obj = liftIO $ getObjectPropertyString obj "stock-detail"

setCellRendererPixbufStockDetail :: (MonadIO m, CellRendererPixbufK o) => o -> T.Text -> m ()
setCellRendererPixbufStockDetail obj val = liftIO $ setObjectPropertyString obj "stock-detail" val

constructCellRendererPixbufStockDetail :: T.Text -> IO ([Char], GValue)
constructCellRendererPixbufStockDetail val = constructObjectPropertyString "stock-detail" val

data CellRendererPixbufStockDetailPropertyInfo
instance AttrInfo CellRendererPixbufStockDetailPropertyInfo where
    type AttrAllowedOps CellRendererPixbufStockDetailPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint CellRendererPixbufStockDetailPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint CellRendererPixbufStockDetailPropertyInfo = CellRendererPixbufK
    type AttrGetType CellRendererPixbufStockDetailPropertyInfo = T.Text
    type AttrLabel CellRendererPixbufStockDetailPropertyInfo = "CellRendererPixbuf::stock-detail"
    attrGet _ = getCellRendererPixbufStockDetail
    attrSet _ = setCellRendererPixbufStockDetail
    attrConstruct _ = constructCellRendererPixbufStockDetail

-- VVV Prop "stock-id"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getCellRendererPixbufStockId :: (MonadIO m, CellRendererPixbufK o) => o -> m T.Text
getCellRendererPixbufStockId obj = liftIO $ getObjectPropertyString obj "stock-id"

setCellRendererPixbufStockId :: (MonadIO m, CellRendererPixbufK o) => o -> T.Text -> m ()
setCellRendererPixbufStockId obj val = liftIO $ setObjectPropertyString obj "stock-id" val

constructCellRendererPixbufStockId :: T.Text -> IO ([Char], GValue)
constructCellRendererPixbufStockId val = constructObjectPropertyString "stock-id" val

data CellRendererPixbufStockIdPropertyInfo
instance AttrInfo CellRendererPixbufStockIdPropertyInfo where
    type AttrAllowedOps CellRendererPixbufStockIdPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint CellRendererPixbufStockIdPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint CellRendererPixbufStockIdPropertyInfo = CellRendererPixbufK
    type AttrGetType CellRendererPixbufStockIdPropertyInfo = T.Text
    type AttrLabel CellRendererPixbufStockIdPropertyInfo = "CellRendererPixbuf::stock-id"
    attrGet _ = getCellRendererPixbufStockId
    attrSet _ = setCellRendererPixbufStockId
    attrConstruct _ = constructCellRendererPixbufStockId

-- VVV Prop "stock-size"
   -- Type: TBasicType TUInt32
   -- Flags: [PropertyReadable,PropertyWritable]

getCellRendererPixbufStockSize :: (MonadIO m, CellRendererPixbufK o) => o -> m Word32
getCellRendererPixbufStockSize obj = liftIO $ getObjectPropertyCUInt obj "stock-size"

setCellRendererPixbufStockSize :: (MonadIO m, CellRendererPixbufK o) => o -> Word32 -> m ()
setCellRendererPixbufStockSize obj val = liftIO $ setObjectPropertyCUInt obj "stock-size" val

constructCellRendererPixbufStockSize :: Word32 -> IO ([Char], GValue)
constructCellRendererPixbufStockSize val = constructObjectPropertyCUInt "stock-size" val

data CellRendererPixbufStockSizePropertyInfo
instance AttrInfo CellRendererPixbufStockSizePropertyInfo where
    type AttrAllowedOps CellRendererPixbufStockSizePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint CellRendererPixbufStockSizePropertyInfo = (~) Word32
    type AttrBaseTypeConstraint CellRendererPixbufStockSizePropertyInfo = CellRendererPixbufK
    type AttrGetType CellRendererPixbufStockSizePropertyInfo = Word32
    type AttrLabel CellRendererPixbufStockSizePropertyInfo = "CellRendererPixbuf::stock-size"
    attrGet _ = getCellRendererPixbufStockSize
    attrSet _ = setCellRendererPixbufStockSize
    attrConstruct _ = constructCellRendererPixbufStockSize

-- VVV Prop "surface"
   -- Type: TInterface "cairo" "Surface"
   -- Flags: [PropertyReadable,PropertyWritable]

getCellRendererPixbufSurface :: (MonadIO m, CellRendererPixbufK o) => o -> m Cairo.Surface
getCellRendererPixbufSurface obj = liftIO $ getObjectPropertyBoxed obj "surface" Cairo.Surface

setCellRendererPixbufSurface :: (MonadIO m, CellRendererPixbufK o) => o -> Cairo.Surface -> m ()
setCellRendererPixbufSurface obj val = liftIO $ setObjectPropertyBoxed obj "surface" val

constructCellRendererPixbufSurface :: Cairo.Surface -> IO ([Char], GValue)
constructCellRendererPixbufSurface val = constructObjectPropertyBoxed "surface" val

data CellRendererPixbufSurfacePropertyInfo
instance AttrInfo CellRendererPixbufSurfacePropertyInfo where
    type AttrAllowedOps CellRendererPixbufSurfacePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint CellRendererPixbufSurfacePropertyInfo = (~) Cairo.Surface
    type AttrBaseTypeConstraint CellRendererPixbufSurfacePropertyInfo = CellRendererPixbufK
    type AttrGetType CellRendererPixbufSurfacePropertyInfo = Cairo.Surface
    type AttrLabel CellRendererPixbufSurfacePropertyInfo = "CellRendererPixbuf::surface"
    attrGet _ = getCellRendererPixbufSurface
    attrSet _ = setCellRendererPixbufSurface
    attrConstruct _ = constructCellRendererPixbufSurface

type instance AttributeList CellRendererPixbuf = CellRendererPixbufAttributeList
type CellRendererPixbufAttributeList = ('[ '("cell-background", CellRendererCellBackgroundPropertyInfo), '("cell-background-gdk", CellRendererCellBackgroundGdkPropertyInfo), '("cell-background-rgba", CellRendererCellBackgroundRgbaPropertyInfo), '("cell-background-set", CellRendererCellBackgroundSetPropertyInfo), '("editing", CellRendererEditingPropertyInfo), '("follow-state", CellRendererPixbufFollowStatePropertyInfo), '("gicon", CellRendererPixbufGiconPropertyInfo), '("height", CellRendererHeightPropertyInfo), '("icon-name", CellRendererPixbufIconNamePropertyInfo), '("is-expanded", CellRendererIsExpandedPropertyInfo), '("is-expander", CellRendererIsExpanderPropertyInfo), '("mode", CellRendererModePropertyInfo), '("pixbuf", CellRendererPixbufPixbufPropertyInfo), '("pixbuf-expander-closed", CellRendererPixbufPixbufExpanderClosedPropertyInfo), '("pixbuf-expander-open", CellRendererPixbufPixbufExpanderOpenPropertyInfo), '("sensitive", CellRendererSensitivePropertyInfo), '("stock-detail", CellRendererPixbufStockDetailPropertyInfo), '("stock-id", CellRendererPixbufStockIdPropertyInfo), '("stock-size", CellRendererPixbufStockSizePropertyInfo), '("surface", CellRendererPixbufSurfacePropertyInfo), '("visible", CellRendererVisiblePropertyInfo), '("width", CellRendererWidthPropertyInfo), '("xalign", CellRendererXalignPropertyInfo), '("xpad", CellRendererXpadPropertyInfo), '("yalign", CellRendererYalignPropertyInfo), '("ypad", CellRendererYpadPropertyInfo)] :: [(Symbol, *)])

type instance SignalList CellRendererPixbuf = CellRendererPixbufSignalList
type CellRendererPixbufSignalList = ('[ '("editing-canceled", CellRendererEditingCanceledSignalInfo), '("editing-started", CellRendererEditingStartedSignalInfo), '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method CellRendererPixbuf::new
-- method type : Constructor
-- Args : []
-- Lengths : []
-- hInArgs : []
-- returnType : TInterface "Gtk" "CellRendererPixbuf"
-- throws : False
-- Skip return : False

foreign import ccall "gtk_cell_renderer_pixbuf_new" gtk_cell_renderer_pixbuf_new :: 
    IO (Ptr CellRendererPixbuf)


cellRendererPixbufNew ::
    (MonadIO m) =>
    m CellRendererPixbuf
cellRendererPixbufNew  = liftIO $ do
    result <- gtk_cell_renderer_pixbuf_new
    checkUnexpectedReturnNULL "gtk_cell_renderer_pixbuf_new" result
    result' <- (newObject CellRendererPixbuf) result
    return result'


