
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Gtk.Objects.FlowBox
    ( 

-- * Exported types
    FlowBox(..)                             ,
    FlowBoxK                                ,
    toFlowBox                               ,
    noFlowBox                               ,


 -- * Methods
-- ** flowBoxGetActivateOnSingleClick
    flowBoxGetActivateOnSingleClick         ,


-- ** flowBoxGetChildAtIndex
    flowBoxGetChildAtIndex                  ,


-- ** flowBoxGetColumnSpacing
    flowBoxGetColumnSpacing                 ,


-- ** flowBoxGetHomogeneous
    flowBoxGetHomogeneous                   ,


-- ** flowBoxGetMaxChildrenPerLine
    flowBoxGetMaxChildrenPerLine            ,


-- ** flowBoxGetMinChildrenPerLine
    flowBoxGetMinChildrenPerLine            ,


-- ** flowBoxGetRowSpacing
    flowBoxGetRowSpacing                    ,


-- ** flowBoxGetSelectedChildren
    flowBoxGetSelectedChildren              ,


-- ** flowBoxGetSelectionMode
    flowBoxGetSelectionMode                 ,


-- ** flowBoxInsert
    flowBoxInsert                           ,


-- ** flowBoxInvalidateFilter
    flowBoxInvalidateFilter                 ,


-- ** flowBoxInvalidateSort
    flowBoxInvalidateSort                   ,


-- ** flowBoxNew
    flowBoxNew                              ,


-- ** flowBoxSelectAll
    flowBoxSelectAll                        ,


-- ** flowBoxSelectChild
    flowBoxSelectChild                      ,


-- ** flowBoxSelectedForeach
    flowBoxSelectedForeach                  ,


-- ** flowBoxSetActivateOnSingleClick
    flowBoxSetActivateOnSingleClick         ,


-- ** flowBoxSetColumnSpacing
    flowBoxSetColumnSpacing                 ,


-- ** flowBoxSetFilterFunc
    flowBoxSetFilterFunc                    ,


-- ** flowBoxSetHadjustment
    flowBoxSetHadjustment                   ,


-- ** flowBoxSetHomogeneous
    flowBoxSetHomogeneous                   ,


-- ** flowBoxSetMaxChildrenPerLine
    flowBoxSetMaxChildrenPerLine            ,


-- ** flowBoxSetMinChildrenPerLine
    flowBoxSetMinChildrenPerLine            ,


-- ** flowBoxSetRowSpacing
    flowBoxSetRowSpacing                    ,


-- ** flowBoxSetSelectionMode
    flowBoxSetSelectionMode                 ,


-- ** flowBoxSetSortFunc
    flowBoxSetSortFunc                      ,


-- ** flowBoxSetVadjustment
    flowBoxSetVadjustment                   ,


-- ** flowBoxUnselectAll
    flowBoxUnselectAll                      ,


-- ** flowBoxUnselectChild
    flowBoxUnselectChild                    ,




 -- * Properties
-- ** ActivateOnSingleClick
    FlowBoxActivateOnSingleClickPropertyInfo,
    constructFlowBoxActivateOnSingleClick   ,
    getFlowBoxActivateOnSingleClick         ,
    setFlowBoxActivateOnSingleClick         ,


-- ** ColumnSpacing
    FlowBoxColumnSpacingPropertyInfo        ,
    constructFlowBoxColumnSpacing           ,
    getFlowBoxColumnSpacing                 ,
    setFlowBoxColumnSpacing                 ,


-- ** Homogeneous
    FlowBoxHomogeneousPropertyInfo          ,
    constructFlowBoxHomogeneous             ,
    getFlowBoxHomogeneous                   ,
    setFlowBoxHomogeneous                   ,


-- ** MaxChildrenPerLine
    FlowBoxMaxChildrenPerLinePropertyInfo   ,
    constructFlowBoxMaxChildrenPerLine      ,
    getFlowBoxMaxChildrenPerLine            ,
    setFlowBoxMaxChildrenPerLine            ,


-- ** MinChildrenPerLine
    FlowBoxMinChildrenPerLinePropertyInfo   ,
    constructFlowBoxMinChildrenPerLine      ,
    getFlowBoxMinChildrenPerLine            ,
    setFlowBoxMinChildrenPerLine            ,


-- ** RowSpacing
    FlowBoxRowSpacingPropertyInfo           ,
    constructFlowBoxRowSpacing              ,
    getFlowBoxRowSpacing                    ,
    setFlowBoxRowSpacing                    ,


-- ** SelectionMode
    FlowBoxSelectionModePropertyInfo        ,
    constructFlowBoxSelectionMode           ,
    getFlowBoxSelectionMode                 ,
    setFlowBoxSelectionMode                 ,




 -- * Signals
-- ** ActivateCursorChild
    FlowBoxActivateCursorChildCallback      ,
    FlowBoxActivateCursorChildCallbackC     ,
    FlowBoxActivateCursorChildSignalInfo    ,
    afterFlowBoxActivateCursorChild         ,
    flowBoxActivateCursorChildCallbackWrapper,
    flowBoxActivateCursorChildClosure       ,
    mkFlowBoxActivateCursorChildCallback    ,
    noFlowBoxActivateCursorChildCallback    ,
    onFlowBoxActivateCursorChild            ,


-- ** ChildActivated
    FlowBoxChildActivatedCallback           ,
    FlowBoxChildActivatedCallbackC          ,
    FlowBoxChildActivatedSignalInfo         ,
    afterFlowBoxChildActivated              ,
    flowBoxChildActivatedCallbackWrapper    ,
    flowBoxChildActivatedClosure            ,
    mkFlowBoxChildActivatedCallback         ,
    noFlowBoxChildActivatedCallback         ,
    onFlowBoxChildActivated                 ,


-- ** MoveCursor
    FlowBoxMoveCursorCallback               ,
    FlowBoxMoveCursorCallbackC              ,
    FlowBoxMoveCursorSignalInfo             ,
    afterFlowBoxMoveCursor                  ,
    flowBoxMoveCursorCallbackWrapper        ,
    flowBoxMoveCursorClosure                ,
    mkFlowBoxMoveCursorCallback             ,
    noFlowBoxMoveCursorCallback             ,
    onFlowBoxMoveCursor                     ,


-- ** SelectAll
    FlowBoxSelectAllCallback                ,
    FlowBoxSelectAllCallbackC               ,
    FlowBoxSelectAllSignalInfo              ,
    afterFlowBoxSelectAll                   ,
    flowBoxSelectAllCallbackWrapper         ,
    flowBoxSelectAllClosure                 ,
    mkFlowBoxSelectAllCallback              ,
    noFlowBoxSelectAllCallback              ,
    onFlowBoxSelectAll                      ,


-- ** SelectedChildrenChanged
    FlowBoxSelectedChildrenChangedCallback  ,
    FlowBoxSelectedChildrenChangedCallbackC ,
    FlowBoxSelectedChildrenChangedSignalInfo,
    afterFlowBoxSelectedChildrenChanged     ,
    flowBoxSelectedChildrenChangedCallbackWrapper,
    flowBoxSelectedChildrenChangedClosure   ,
    mkFlowBoxSelectedChildrenChangedCallback,
    noFlowBoxSelectedChildrenChangedCallback,
    onFlowBoxSelectedChildrenChanged        ,


-- ** ToggleCursorChild
    FlowBoxToggleCursorChildCallback        ,
    FlowBoxToggleCursorChildCallbackC       ,
    FlowBoxToggleCursorChildSignalInfo      ,
    afterFlowBoxToggleCursorChild           ,
    flowBoxToggleCursorChildCallbackWrapper ,
    flowBoxToggleCursorChildClosure         ,
    mkFlowBoxToggleCursorChildCallback      ,
    noFlowBoxToggleCursorChildCallback      ,
    onFlowBoxToggleCursorChild              ,


-- ** UnselectAll
    FlowBoxUnselectAllCallback              ,
    FlowBoxUnselectAllCallbackC             ,
    FlowBoxUnselectAllSignalInfo            ,
    afterFlowBoxUnselectAll                 ,
    flowBoxUnselectAllCallbackWrapper       ,
    flowBoxUnselectAllClosure               ,
    mkFlowBoxUnselectAllCallback            ,
    noFlowBoxUnselectAllCallback            ,
    onFlowBoxUnselectAll                    ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Gtk.Types
import GI.Gtk.Callbacks
import qualified GI.Atk as Atk
import qualified GI.GLib as GLib
import qualified GI.GObject as GObject

newtype FlowBox = FlowBox (ForeignPtr FlowBox)
foreign import ccall "gtk_flow_box_get_type"
    c_gtk_flow_box_get_type :: IO GType

type instance ParentTypes FlowBox = FlowBoxParentTypes
type FlowBoxParentTypes = '[Container, Widget, GObject.Object, Atk.ImplementorIface, Buildable, Orientable]

instance GObject FlowBox where
    gobjectIsInitiallyUnowned _ = True
    gobjectType _ = c_gtk_flow_box_get_type
    

class GObject o => FlowBoxK o
instance (GObject o, IsDescendantOf FlowBox o) => FlowBoxK o

toFlowBox :: FlowBoxK o => o -> IO FlowBox
toFlowBox = unsafeCastTo FlowBox

noFlowBox :: Maybe FlowBox
noFlowBox = Nothing

-- signal FlowBox::activate-cursor-child
type FlowBoxActivateCursorChildCallback =
    IO ()

noFlowBoxActivateCursorChildCallback :: Maybe FlowBoxActivateCursorChildCallback
noFlowBoxActivateCursorChildCallback = Nothing

type FlowBoxActivateCursorChildCallbackC =
    Ptr () ->                               -- object
    Ptr () ->                               -- user_data
    IO ()

foreign import ccall "wrapper"
    mkFlowBoxActivateCursorChildCallback :: FlowBoxActivateCursorChildCallbackC -> IO (FunPtr FlowBoxActivateCursorChildCallbackC)

flowBoxActivateCursorChildClosure :: FlowBoxActivateCursorChildCallback -> IO Closure
flowBoxActivateCursorChildClosure cb = newCClosure =<< mkFlowBoxActivateCursorChildCallback wrapped
    where wrapped = flowBoxActivateCursorChildCallbackWrapper cb

flowBoxActivateCursorChildCallbackWrapper ::
    FlowBoxActivateCursorChildCallback ->
    Ptr () ->
    Ptr () ->
    IO ()
flowBoxActivateCursorChildCallbackWrapper _cb _ _ = do
    _cb 

onFlowBoxActivateCursorChild :: (GObject a, MonadIO m) => a -> FlowBoxActivateCursorChildCallback -> m SignalHandlerId
onFlowBoxActivateCursorChild obj cb = liftIO $ connectFlowBoxActivateCursorChild obj cb SignalConnectBefore
afterFlowBoxActivateCursorChild :: (GObject a, MonadIO m) => a -> FlowBoxActivateCursorChildCallback -> m SignalHandlerId
afterFlowBoxActivateCursorChild obj cb = connectFlowBoxActivateCursorChild obj cb SignalConnectAfter

connectFlowBoxActivateCursorChild :: (GObject a, MonadIO m) =>
                                     a -> FlowBoxActivateCursorChildCallback -> SignalConnectMode -> m SignalHandlerId
connectFlowBoxActivateCursorChild obj cb after = liftIO $ do
    cb' <- mkFlowBoxActivateCursorChildCallback (flowBoxActivateCursorChildCallbackWrapper cb)
    connectSignalFunPtr obj "activate-cursor-child" cb' after

-- signal FlowBox::child-activated
type FlowBoxChildActivatedCallback =
    FlowBoxChild ->
    IO ()

noFlowBoxChildActivatedCallback :: Maybe FlowBoxChildActivatedCallback
noFlowBoxChildActivatedCallback = Nothing

type FlowBoxChildActivatedCallbackC =
    Ptr () ->                               -- object
    Ptr FlowBoxChild ->
    Ptr () ->                               -- user_data
    IO ()

foreign import ccall "wrapper"
    mkFlowBoxChildActivatedCallback :: FlowBoxChildActivatedCallbackC -> IO (FunPtr FlowBoxChildActivatedCallbackC)

flowBoxChildActivatedClosure :: FlowBoxChildActivatedCallback -> IO Closure
flowBoxChildActivatedClosure cb = newCClosure =<< mkFlowBoxChildActivatedCallback wrapped
    where wrapped = flowBoxChildActivatedCallbackWrapper cb

flowBoxChildActivatedCallbackWrapper ::
    FlowBoxChildActivatedCallback ->
    Ptr () ->
    Ptr FlowBoxChild ->
    Ptr () ->
    IO ()
flowBoxChildActivatedCallbackWrapper _cb _ child _ = do
    child' <- (newObject FlowBoxChild) child
    _cb  child'

onFlowBoxChildActivated :: (GObject a, MonadIO m) => a -> FlowBoxChildActivatedCallback -> m SignalHandlerId
onFlowBoxChildActivated obj cb = liftIO $ connectFlowBoxChildActivated obj cb SignalConnectBefore
afterFlowBoxChildActivated :: (GObject a, MonadIO m) => a -> FlowBoxChildActivatedCallback -> m SignalHandlerId
afterFlowBoxChildActivated obj cb = connectFlowBoxChildActivated obj cb SignalConnectAfter

connectFlowBoxChildActivated :: (GObject a, MonadIO m) =>
                                a -> FlowBoxChildActivatedCallback -> SignalConnectMode -> m SignalHandlerId
connectFlowBoxChildActivated obj cb after = liftIO $ do
    cb' <- mkFlowBoxChildActivatedCallback (flowBoxChildActivatedCallbackWrapper cb)
    connectSignalFunPtr obj "child-activated" cb' after

-- signal FlowBox::move-cursor
type FlowBoxMoveCursorCallback =
    MovementStep ->
    Int32 ->
    IO Bool

noFlowBoxMoveCursorCallback :: Maybe FlowBoxMoveCursorCallback
noFlowBoxMoveCursorCallback = Nothing

type FlowBoxMoveCursorCallbackC =
    Ptr () ->                               -- object
    CUInt ->
    Int32 ->
    Ptr () ->                               -- user_data
    IO CInt

foreign import ccall "wrapper"
    mkFlowBoxMoveCursorCallback :: FlowBoxMoveCursorCallbackC -> IO (FunPtr FlowBoxMoveCursorCallbackC)

flowBoxMoveCursorClosure :: FlowBoxMoveCursorCallback -> IO Closure
flowBoxMoveCursorClosure cb = newCClosure =<< mkFlowBoxMoveCursorCallback wrapped
    where wrapped = flowBoxMoveCursorCallbackWrapper cb

flowBoxMoveCursorCallbackWrapper ::
    FlowBoxMoveCursorCallback ->
    Ptr () ->
    CUInt ->
    Int32 ->
    Ptr () ->
    IO CInt
flowBoxMoveCursorCallbackWrapper _cb _ step count _ = do
    let step' = (toEnum . fromIntegral) step
    result <- _cb  step' count
    let result' = (fromIntegral . fromEnum) result
    return result'

onFlowBoxMoveCursor :: (GObject a, MonadIO m) => a -> FlowBoxMoveCursorCallback -> m SignalHandlerId
onFlowBoxMoveCursor obj cb = liftIO $ connectFlowBoxMoveCursor obj cb SignalConnectBefore
afterFlowBoxMoveCursor :: (GObject a, MonadIO m) => a -> FlowBoxMoveCursorCallback -> m SignalHandlerId
afterFlowBoxMoveCursor obj cb = connectFlowBoxMoveCursor obj cb SignalConnectAfter

connectFlowBoxMoveCursor :: (GObject a, MonadIO m) =>
                            a -> FlowBoxMoveCursorCallback -> SignalConnectMode -> m SignalHandlerId
connectFlowBoxMoveCursor obj cb after = liftIO $ do
    cb' <- mkFlowBoxMoveCursorCallback (flowBoxMoveCursorCallbackWrapper cb)
    connectSignalFunPtr obj "move-cursor" cb' after

-- signal FlowBox::select-all
type FlowBoxSelectAllCallback =
    IO ()

noFlowBoxSelectAllCallback :: Maybe FlowBoxSelectAllCallback
noFlowBoxSelectAllCallback = Nothing

type FlowBoxSelectAllCallbackC =
    Ptr () ->                               -- object
    Ptr () ->                               -- user_data
    IO ()

foreign import ccall "wrapper"
    mkFlowBoxSelectAllCallback :: FlowBoxSelectAllCallbackC -> IO (FunPtr FlowBoxSelectAllCallbackC)

flowBoxSelectAllClosure :: FlowBoxSelectAllCallback -> IO Closure
flowBoxSelectAllClosure cb = newCClosure =<< mkFlowBoxSelectAllCallback wrapped
    where wrapped = flowBoxSelectAllCallbackWrapper cb

flowBoxSelectAllCallbackWrapper ::
    FlowBoxSelectAllCallback ->
    Ptr () ->
    Ptr () ->
    IO ()
flowBoxSelectAllCallbackWrapper _cb _ _ = do
    _cb 

onFlowBoxSelectAll :: (GObject a, MonadIO m) => a -> FlowBoxSelectAllCallback -> m SignalHandlerId
onFlowBoxSelectAll obj cb = liftIO $ connectFlowBoxSelectAll obj cb SignalConnectBefore
afterFlowBoxSelectAll :: (GObject a, MonadIO m) => a -> FlowBoxSelectAllCallback -> m SignalHandlerId
afterFlowBoxSelectAll obj cb = connectFlowBoxSelectAll obj cb SignalConnectAfter

connectFlowBoxSelectAll :: (GObject a, MonadIO m) =>
                           a -> FlowBoxSelectAllCallback -> SignalConnectMode -> m SignalHandlerId
connectFlowBoxSelectAll obj cb after = liftIO $ do
    cb' <- mkFlowBoxSelectAllCallback (flowBoxSelectAllCallbackWrapper cb)
    connectSignalFunPtr obj "select-all" cb' after

-- signal FlowBox::selected-children-changed
type FlowBoxSelectedChildrenChangedCallback =
    IO ()

noFlowBoxSelectedChildrenChangedCallback :: Maybe FlowBoxSelectedChildrenChangedCallback
noFlowBoxSelectedChildrenChangedCallback = Nothing

type FlowBoxSelectedChildrenChangedCallbackC =
    Ptr () ->                               -- object
    Ptr () ->                               -- user_data
    IO ()

foreign import ccall "wrapper"
    mkFlowBoxSelectedChildrenChangedCallback :: FlowBoxSelectedChildrenChangedCallbackC -> IO (FunPtr FlowBoxSelectedChildrenChangedCallbackC)

flowBoxSelectedChildrenChangedClosure :: FlowBoxSelectedChildrenChangedCallback -> IO Closure
flowBoxSelectedChildrenChangedClosure cb = newCClosure =<< mkFlowBoxSelectedChildrenChangedCallback wrapped
    where wrapped = flowBoxSelectedChildrenChangedCallbackWrapper cb

flowBoxSelectedChildrenChangedCallbackWrapper ::
    FlowBoxSelectedChildrenChangedCallback ->
    Ptr () ->
    Ptr () ->
    IO ()
flowBoxSelectedChildrenChangedCallbackWrapper _cb _ _ = do
    _cb 

onFlowBoxSelectedChildrenChanged :: (GObject a, MonadIO m) => a -> FlowBoxSelectedChildrenChangedCallback -> m SignalHandlerId
onFlowBoxSelectedChildrenChanged obj cb = liftIO $ connectFlowBoxSelectedChildrenChanged obj cb SignalConnectBefore
afterFlowBoxSelectedChildrenChanged :: (GObject a, MonadIO m) => a -> FlowBoxSelectedChildrenChangedCallback -> m SignalHandlerId
afterFlowBoxSelectedChildrenChanged obj cb = connectFlowBoxSelectedChildrenChanged obj cb SignalConnectAfter

connectFlowBoxSelectedChildrenChanged :: (GObject a, MonadIO m) =>
                                         a -> FlowBoxSelectedChildrenChangedCallback -> SignalConnectMode -> m SignalHandlerId
connectFlowBoxSelectedChildrenChanged obj cb after = liftIO $ do
    cb' <- mkFlowBoxSelectedChildrenChangedCallback (flowBoxSelectedChildrenChangedCallbackWrapper cb)
    connectSignalFunPtr obj "selected-children-changed" cb' after

-- signal FlowBox::toggle-cursor-child
type FlowBoxToggleCursorChildCallback =
    IO ()

noFlowBoxToggleCursorChildCallback :: Maybe FlowBoxToggleCursorChildCallback
noFlowBoxToggleCursorChildCallback = Nothing

type FlowBoxToggleCursorChildCallbackC =
    Ptr () ->                               -- object
    Ptr () ->                               -- user_data
    IO ()

foreign import ccall "wrapper"
    mkFlowBoxToggleCursorChildCallback :: FlowBoxToggleCursorChildCallbackC -> IO (FunPtr FlowBoxToggleCursorChildCallbackC)

flowBoxToggleCursorChildClosure :: FlowBoxToggleCursorChildCallback -> IO Closure
flowBoxToggleCursorChildClosure cb = newCClosure =<< mkFlowBoxToggleCursorChildCallback wrapped
    where wrapped = flowBoxToggleCursorChildCallbackWrapper cb

flowBoxToggleCursorChildCallbackWrapper ::
    FlowBoxToggleCursorChildCallback ->
    Ptr () ->
    Ptr () ->
    IO ()
flowBoxToggleCursorChildCallbackWrapper _cb _ _ = do
    _cb 

onFlowBoxToggleCursorChild :: (GObject a, MonadIO m) => a -> FlowBoxToggleCursorChildCallback -> m SignalHandlerId
onFlowBoxToggleCursorChild obj cb = liftIO $ connectFlowBoxToggleCursorChild obj cb SignalConnectBefore
afterFlowBoxToggleCursorChild :: (GObject a, MonadIO m) => a -> FlowBoxToggleCursorChildCallback -> m SignalHandlerId
afterFlowBoxToggleCursorChild obj cb = connectFlowBoxToggleCursorChild obj cb SignalConnectAfter

connectFlowBoxToggleCursorChild :: (GObject a, MonadIO m) =>
                                   a -> FlowBoxToggleCursorChildCallback -> SignalConnectMode -> m SignalHandlerId
connectFlowBoxToggleCursorChild obj cb after = liftIO $ do
    cb' <- mkFlowBoxToggleCursorChildCallback (flowBoxToggleCursorChildCallbackWrapper cb)
    connectSignalFunPtr obj "toggle-cursor-child" cb' after

-- signal FlowBox::unselect-all
type FlowBoxUnselectAllCallback =
    IO ()

noFlowBoxUnselectAllCallback :: Maybe FlowBoxUnselectAllCallback
noFlowBoxUnselectAllCallback = Nothing

type FlowBoxUnselectAllCallbackC =
    Ptr () ->                               -- object
    Ptr () ->                               -- user_data
    IO ()

foreign import ccall "wrapper"
    mkFlowBoxUnselectAllCallback :: FlowBoxUnselectAllCallbackC -> IO (FunPtr FlowBoxUnselectAllCallbackC)

flowBoxUnselectAllClosure :: FlowBoxUnselectAllCallback -> IO Closure
flowBoxUnselectAllClosure cb = newCClosure =<< mkFlowBoxUnselectAllCallback wrapped
    where wrapped = flowBoxUnselectAllCallbackWrapper cb

flowBoxUnselectAllCallbackWrapper ::
    FlowBoxUnselectAllCallback ->
    Ptr () ->
    Ptr () ->
    IO ()
flowBoxUnselectAllCallbackWrapper _cb _ _ = do
    _cb 

onFlowBoxUnselectAll :: (GObject a, MonadIO m) => a -> FlowBoxUnselectAllCallback -> m SignalHandlerId
onFlowBoxUnselectAll obj cb = liftIO $ connectFlowBoxUnselectAll obj cb SignalConnectBefore
afterFlowBoxUnselectAll :: (GObject a, MonadIO m) => a -> FlowBoxUnselectAllCallback -> m SignalHandlerId
afterFlowBoxUnselectAll obj cb = connectFlowBoxUnselectAll obj cb SignalConnectAfter

connectFlowBoxUnselectAll :: (GObject a, MonadIO m) =>
                             a -> FlowBoxUnselectAllCallback -> SignalConnectMode -> m SignalHandlerId
connectFlowBoxUnselectAll obj cb after = liftIO $ do
    cb' <- mkFlowBoxUnselectAllCallback (flowBoxUnselectAllCallbackWrapper cb)
    connectSignalFunPtr obj "unselect-all" cb' after

-- VVV Prop "activate-on-single-click"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getFlowBoxActivateOnSingleClick :: (MonadIO m, FlowBoxK o) => o -> m Bool
getFlowBoxActivateOnSingleClick obj = liftIO $ getObjectPropertyBool obj "activate-on-single-click"

setFlowBoxActivateOnSingleClick :: (MonadIO m, FlowBoxK o) => o -> Bool -> m ()
setFlowBoxActivateOnSingleClick obj val = liftIO $ setObjectPropertyBool obj "activate-on-single-click" val

constructFlowBoxActivateOnSingleClick :: Bool -> IO ([Char], GValue)
constructFlowBoxActivateOnSingleClick val = constructObjectPropertyBool "activate-on-single-click" val

data FlowBoxActivateOnSingleClickPropertyInfo
instance AttrInfo FlowBoxActivateOnSingleClickPropertyInfo where
    type AttrAllowedOps FlowBoxActivateOnSingleClickPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint FlowBoxActivateOnSingleClickPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint FlowBoxActivateOnSingleClickPropertyInfo = FlowBoxK
    type AttrGetType FlowBoxActivateOnSingleClickPropertyInfo = Bool
    type AttrLabel FlowBoxActivateOnSingleClickPropertyInfo = "FlowBox::activate-on-single-click"
    attrGet _ = getFlowBoxActivateOnSingleClick
    attrSet _ = setFlowBoxActivateOnSingleClick
    attrConstruct _ = constructFlowBoxActivateOnSingleClick

-- VVV Prop "column-spacing"
   -- Type: TBasicType TUInt32
   -- Flags: [PropertyReadable,PropertyWritable]

getFlowBoxColumnSpacing :: (MonadIO m, FlowBoxK o) => o -> m Word32
getFlowBoxColumnSpacing obj = liftIO $ getObjectPropertyCUInt obj "column-spacing"

setFlowBoxColumnSpacing :: (MonadIO m, FlowBoxK o) => o -> Word32 -> m ()
setFlowBoxColumnSpacing obj val = liftIO $ setObjectPropertyCUInt obj "column-spacing" val

constructFlowBoxColumnSpacing :: Word32 -> IO ([Char], GValue)
constructFlowBoxColumnSpacing val = constructObjectPropertyCUInt "column-spacing" val

data FlowBoxColumnSpacingPropertyInfo
instance AttrInfo FlowBoxColumnSpacingPropertyInfo where
    type AttrAllowedOps FlowBoxColumnSpacingPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint FlowBoxColumnSpacingPropertyInfo = (~) Word32
    type AttrBaseTypeConstraint FlowBoxColumnSpacingPropertyInfo = FlowBoxK
    type AttrGetType FlowBoxColumnSpacingPropertyInfo = Word32
    type AttrLabel FlowBoxColumnSpacingPropertyInfo = "FlowBox::column-spacing"
    attrGet _ = getFlowBoxColumnSpacing
    attrSet _ = setFlowBoxColumnSpacing
    attrConstruct _ = constructFlowBoxColumnSpacing

-- VVV Prop "homogeneous"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getFlowBoxHomogeneous :: (MonadIO m, FlowBoxK o) => o -> m Bool
getFlowBoxHomogeneous obj = liftIO $ getObjectPropertyBool obj "homogeneous"

setFlowBoxHomogeneous :: (MonadIO m, FlowBoxK o) => o -> Bool -> m ()
setFlowBoxHomogeneous obj val = liftIO $ setObjectPropertyBool obj "homogeneous" val

constructFlowBoxHomogeneous :: Bool -> IO ([Char], GValue)
constructFlowBoxHomogeneous val = constructObjectPropertyBool "homogeneous" val

data FlowBoxHomogeneousPropertyInfo
instance AttrInfo FlowBoxHomogeneousPropertyInfo where
    type AttrAllowedOps FlowBoxHomogeneousPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint FlowBoxHomogeneousPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint FlowBoxHomogeneousPropertyInfo = FlowBoxK
    type AttrGetType FlowBoxHomogeneousPropertyInfo = Bool
    type AttrLabel FlowBoxHomogeneousPropertyInfo = "FlowBox::homogeneous"
    attrGet _ = getFlowBoxHomogeneous
    attrSet _ = setFlowBoxHomogeneous
    attrConstruct _ = constructFlowBoxHomogeneous

-- VVV Prop "max-children-per-line"
   -- Type: TBasicType TUInt32
   -- Flags: [PropertyReadable,PropertyWritable]

getFlowBoxMaxChildrenPerLine :: (MonadIO m, FlowBoxK o) => o -> m Word32
getFlowBoxMaxChildrenPerLine obj = liftIO $ getObjectPropertyCUInt obj "max-children-per-line"

setFlowBoxMaxChildrenPerLine :: (MonadIO m, FlowBoxK o) => o -> Word32 -> m ()
setFlowBoxMaxChildrenPerLine obj val = liftIO $ setObjectPropertyCUInt obj "max-children-per-line" val

constructFlowBoxMaxChildrenPerLine :: Word32 -> IO ([Char], GValue)
constructFlowBoxMaxChildrenPerLine val = constructObjectPropertyCUInt "max-children-per-line" val

data FlowBoxMaxChildrenPerLinePropertyInfo
instance AttrInfo FlowBoxMaxChildrenPerLinePropertyInfo where
    type AttrAllowedOps FlowBoxMaxChildrenPerLinePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint FlowBoxMaxChildrenPerLinePropertyInfo = (~) Word32
    type AttrBaseTypeConstraint FlowBoxMaxChildrenPerLinePropertyInfo = FlowBoxK
    type AttrGetType FlowBoxMaxChildrenPerLinePropertyInfo = Word32
    type AttrLabel FlowBoxMaxChildrenPerLinePropertyInfo = "FlowBox::max-children-per-line"
    attrGet _ = getFlowBoxMaxChildrenPerLine
    attrSet _ = setFlowBoxMaxChildrenPerLine
    attrConstruct _ = constructFlowBoxMaxChildrenPerLine

-- VVV Prop "min-children-per-line"
   -- Type: TBasicType TUInt32
   -- Flags: [PropertyReadable,PropertyWritable]

getFlowBoxMinChildrenPerLine :: (MonadIO m, FlowBoxK o) => o -> m Word32
getFlowBoxMinChildrenPerLine obj = liftIO $ getObjectPropertyCUInt obj "min-children-per-line"

setFlowBoxMinChildrenPerLine :: (MonadIO m, FlowBoxK o) => o -> Word32 -> m ()
setFlowBoxMinChildrenPerLine obj val = liftIO $ setObjectPropertyCUInt obj "min-children-per-line" val

constructFlowBoxMinChildrenPerLine :: Word32 -> IO ([Char], GValue)
constructFlowBoxMinChildrenPerLine val = constructObjectPropertyCUInt "min-children-per-line" val

data FlowBoxMinChildrenPerLinePropertyInfo
instance AttrInfo FlowBoxMinChildrenPerLinePropertyInfo where
    type AttrAllowedOps FlowBoxMinChildrenPerLinePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint FlowBoxMinChildrenPerLinePropertyInfo = (~) Word32
    type AttrBaseTypeConstraint FlowBoxMinChildrenPerLinePropertyInfo = FlowBoxK
    type AttrGetType FlowBoxMinChildrenPerLinePropertyInfo = Word32
    type AttrLabel FlowBoxMinChildrenPerLinePropertyInfo = "FlowBox::min-children-per-line"
    attrGet _ = getFlowBoxMinChildrenPerLine
    attrSet _ = setFlowBoxMinChildrenPerLine
    attrConstruct _ = constructFlowBoxMinChildrenPerLine

-- VVV Prop "row-spacing"
   -- Type: TBasicType TUInt32
   -- Flags: [PropertyReadable,PropertyWritable]

getFlowBoxRowSpacing :: (MonadIO m, FlowBoxK o) => o -> m Word32
getFlowBoxRowSpacing obj = liftIO $ getObjectPropertyCUInt obj "row-spacing"

setFlowBoxRowSpacing :: (MonadIO m, FlowBoxK o) => o -> Word32 -> m ()
setFlowBoxRowSpacing obj val = liftIO $ setObjectPropertyCUInt obj "row-spacing" val

constructFlowBoxRowSpacing :: Word32 -> IO ([Char], GValue)
constructFlowBoxRowSpacing val = constructObjectPropertyCUInt "row-spacing" val

data FlowBoxRowSpacingPropertyInfo
instance AttrInfo FlowBoxRowSpacingPropertyInfo where
    type AttrAllowedOps FlowBoxRowSpacingPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint FlowBoxRowSpacingPropertyInfo = (~) Word32
    type AttrBaseTypeConstraint FlowBoxRowSpacingPropertyInfo = FlowBoxK
    type AttrGetType FlowBoxRowSpacingPropertyInfo = Word32
    type AttrLabel FlowBoxRowSpacingPropertyInfo = "FlowBox::row-spacing"
    attrGet _ = getFlowBoxRowSpacing
    attrSet _ = setFlowBoxRowSpacing
    attrConstruct _ = constructFlowBoxRowSpacing

-- VVV Prop "selection-mode"
   -- Type: TInterface "Gtk" "SelectionMode"
   -- Flags: [PropertyReadable,PropertyWritable]

getFlowBoxSelectionMode :: (MonadIO m, FlowBoxK o) => o -> m SelectionMode
getFlowBoxSelectionMode obj = liftIO $ getObjectPropertyEnum obj "selection-mode"

setFlowBoxSelectionMode :: (MonadIO m, FlowBoxK o) => o -> SelectionMode -> m ()
setFlowBoxSelectionMode obj val = liftIO $ setObjectPropertyEnum obj "selection-mode" val

constructFlowBoxSelectionMode :: SelectionMode -> IO ([Char], GValue)
constructFlowBoxSelectionMode val = constructObjectPropertyEnum "selection-mode" val

data FlowBoxSelectionModePropertyInfo
instance AttrInfo FlowBoxSelectionModePropertyInfo where
    type AttrAllowedOps FlowBoxSelectionModePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint FlowBoxSelectionModePropertyInfo = (~) SelectionMode
    type AttrBaseTypeConstraint FlowBoxSelectionModePropertyInfo = FlowBoxK
    type AttrGetType FlowBoxSelectionModePropertyInfo = SelectionMode
    type AttrLabel FlowBoxSelectionModePropertyInfo = "FlowBox::selection-mode"
    attrGet _ = getFlowBoxSelectionMode
    attrSet _ = setFlowBoxSelectionMode
    attrConstruct _ = constructFlowBoxSelectionMode

type instance AttributeList FlowBox = FlowBoxAttributeList
type FlowBoxAttributeList = ('[ '("activate-on-single-click", FlowBoxActivateOnSingleClickPropertyInfo), '("app-paintable", WidgetAppPaintablePropertyInfo), '("border-width", ContainerBorderWidthPropertyInfo), '("can-default", WidgetCanDefaultPropertyInfo), '("can-focus", WidgetCanFocusPropertyInfo), '("child", ContainerChildPropertyInfo), '("column-spacing", FlowBoxColumnSpacingPropertyInfo), '("composite-child", WidgetCompositeChildPropertyInfo), '("double-buffered", WidgetDoubleBufferedPropertyInfo), '("events", WidgetEventsPropertyInfo), '("expand", WidgetExpandPropertyInfo), '("halign", WidgetHalignPropertyInfo), '("has-default", WidgetHasDefaultPropertyInfo), '("has-focus", WidgetHasFocusPropertyInfo), '("has-tooltip", WidgetHasTooltipPropertyInfo), '("height-request", WidgetHeightRequestPropertyInfo), '("hexpand", WidgetHexpandPropertyInfo), '("hexpand-set", WidgetHexpandSetPropertyInfo), '("homogeneous", FlowBoxHomogeneousPropertyInfo), '("is-focus", WidgetIsFocusPropertyInfo), '("margin", WidgetMarginPropertyInfo), '("margin-bottom", WidgetMarginBottomPropertyInfo), '("margin-end", WidgetMarginEndPropertyInfo), '("margin-left", WidgetMarginLeftPropertyInfo), '("margin-right", WidgetMarginRightPropertyInfo), '("margin-start", WidgetMarginStartPropertyInfo), '("margin-top", WidgetMarginTopPropertyInfo), '("max-children-per-line", FlowBoxMaxChildrenPerLinePropertyInfo), '("min-children-per-line", FlowBoxMinChildrenPerLinePropertyInfo), '("name", WidgetNamePropertyInfo), '("no-show-all", WidgetNoShowAllPropertyInfo), '("opacity", WidgetOpacityPropertyInfo), '("orientation", OrientableOrientationPropertyInfo), '("parent", WidgetParentPropertyInfo), '("receives-default", WidgetReceivesDefaultPropertyInfo), '("resize-mode", ContainerResizeModePropertyInfo), '("row-spacing", FlowBoxRowSpacingPropertyInfo), '("scale-factor", WidgetScaleFactorPropertyInfo), '("selection-mode", FlowBoxSelectionModePropertyInfo), '("sensitive", WidgetSensitivePropertyInfo), '("style", WidgetStylePropertyInfo), '("tooltip-markup", WidgetTooltipMarkupPropertyInfo), '("tooltip-text", WidgetTooltipTextPropertyInfo), '("valign", WidgetValignPropertyInfo), '("vexpand", WidgetVexpandPropertyInfo), '("vexpand-set", WidgetVexpandSetPropertyInfo), '("visible", WidgetVisiblePropertyInfo), '("width-request", WidgetWidthRequestPropertyInfo), '("window", WidgetWindowPropertyInfo)] :: [(Symbol, *)])

data FlowBoxActivateCursorChildSignalInfo
instance SignalInfo FlowBoxActivateCursorChildSignalInfo where
    type HaskellCallbackType FlowBoxActivateCursorChildSignalInfo = FlowBoxActivateCursorChildCallback
    connectSignal _ = connectFlowBoxActivateCursorChild

data FlowBoxChildActivatedSignalInfo
instance SignalInfo FlowBoxChildActivatedSignalInfo where
    type HaskellCallbackType FlowBoxChildActivatedSignalInfo = FlowBoxChildActivatedCallback
    connectSignal _ = connectFlowBoxChildActivated

data FlowBoxMoveCursorSignalInfo
instance SignalInfo FlowBoxMoveCursorSignalInfo where
    type HaskellCallbackType FlowBoxMoveCursorSignalInfo = FlowBoxMoveCursorCallback
    connectSignal _ = connectFlowBoxMoveCursor

data FlowBoxSelectAllSignalInfo
instance SignalInfo FlowBoxSelectAllSignalInfo where
    type HaskellCallbackType FlowBoxSelectAllSignalInfo = FlowBoxSelectAllCallback
    connectSignal _ = connectFlowBoxSelectAll

data FlowBoxSelectedChildrenChangedSignalInfo
instance SignalInfo FlowBoxSelectedChildrenChangedSignalInfo where
    type HaskellCallbackType FlowBoxSelectedChildrenChangedSignalInfo = FlowBoxSelectedChildrenChangedCallback
    connectSignal _ = connectFlowBoxSelectedChildrenChanged

data FlowBoxToggleCursorChildSignalInfo
instance SignalInfo FlowBoxToggleCursorChildSignalInfo where
    type HaskellCallbackType FlowBoxToggleCursorChildSignalInfo = FlowBoxToggleCursorChildCallback
    connectSignal _ = connectFlowBoxToggleCursorChild

data FlowBoxUnselectAllSignalInfo
instance SignalInfo FlowBoxUnselectAllSignalInfo where
    type HaskellCallbackType FlowBoxUnselectAllSignalInfo = FlowBoxUnselectAllCallback
    connectSignal _ = connectFlowBoxUnselectAll

type instance SignalList FlowBox = FlowBoxSignalList
type FlowBoxSignalList = ('[ '("accel-closures-changed", WidgetAccelClosuresChangedSignalInfo), '("activate-cursor-child", FlowBoxActivateCursorChildSignalInfo), '("add", ContainerAddSignalInfo), '("button-press-event", WidgetButtonPressEventSignalInfo), '("button-release-event", WidgetButtonReleaseEventSignalInfo), '("can-activate-accel", WidgetCanActivateAccelSignalInfo), '("check-resize", ContainerCheckResizeSignalInfo), '("child-activated", FlowBoxChildActivatedSignalInfo), '("child-notify", WidgetChildNotifySignalInfo), '("composited-changed", WidgetCompositedChangedSignalInfo), '("configure-event", WidgetConfigureEventSignalInfo), '("damage-event", WidgetDamageEventSignalInfo), '("delete-event", WidgetDeleteEventSignalInfo), '("destroy", WidgetDestroySignalInfo), '("destroy-event", WidgetDestroyEventSignalInfo), '("direction-changed", WidgetDirectionChangedSignalInfo), '("drag-begin", WidgetDragBeginSignalInfo), '("drag-data-delete", WidgetDragDataDeleteSignalInfo), '("drag-data-get", WidgetDragDataGetSignalInfo), '("drag-data-received", WidgetDragDataReceivedSignalInfo), '("drag-drop", WidgetDragDropSignalInfo), '("drag-end", WidgetDragEndSignalInfo), '("drag-failed", WidgetDragFailedSignalInfo), '("drag-leave", WidgetDragLeaveSignalInfo), '("drag-motion", WidgetDragMotionSignalInfo), '("draw", WidgetDrawSignalInfo), '("enter-notify-event", WidgetEnterNotifyEventSignalInfo), '("event", WidgetEventSignalInfo), '("event-after", WidgetEventAfterSignalInfo), '("focus", WidgetFocusSignalInfo), '("focus-in-event", WidgetFocusInEventSignalInfo), '("focus-out-event", WidgetFocusOutEventSignalInfo), '("grab-broken-event", WidgetGrabBrokenEventSignalInfo), '("grab-focus", WidgetGrabFocusSignalInfo), '("grab-notify", WidgetGrabNotifySignalInfo), '("hide", WidgetHideSignalInfo), '("hierarchy-changed", WidgetHierarchyChangedSignalInfo), '("key-press-event", WidgetKeyPressEventSignalInfo), '("key-release-event", WidgetKeyReleaseEventSignalInfo), '("keynav-failed", WidgetKeynavFailedSignalInfo), '("leave-notify-event", WidgetLeaveNotifyEventSignalInfo), '("map", WidgetMapSignalInfo), '("map-event", WidgetMapEventSignalInfo), '("mnemonic-activate", WidgetMnemonicActivateSignalInfo), '("motion-notify-event", WidgetMotionNotifyEventSignalInfo), '("move-cursor", FlowBoxMoveCursorSignalInfo), '("move-focus", WidgetMoveFocusSignalInfo), '("notify", GObject.ObjectNotifySignalInfo), '("parent-set", WidgetParentSetSignalInfo), '("popup-menu", WidgetPopupMenuSignalInfo), '("property-notify-event", WidgetPropertyNotifyEventSignalInfo), '("proximity-in-event", WidgetProximityInEventSignalInfo), '("proximity-out-event", WidgetProximityOutEventSignalInfo), '("query-tooltip", WidgetQueryTooltipSignalInfo), '("realize", WidgetRealizeSignalInfo), '("remove", ContainerRemoveSignalInfo), '("screen-changed", WidgetScreenChangedSignalInfo), '("scroll-event", WidgetScrollEventSignalInfo), '("select-all", FlowBoxSelectAllSignalInfo), '("selected-children-changed", FlowBoxSelectedChildrenChangedSignalInfo), '("selection-clear-event", WidgetSelectionClearEventSignalInfo), '("selection-get", WidgetSelectionGetSignalInfo), '("selection-notify-event", WidgetSelectionNotifyEventSignalInfo), '("selection-received", WidgetSelectionReceivedSignalInfo), '("selection-request-event", WidgetSelectionRequestEventSignalInfo), '("set-focus-child", ContainerSetFocusChildSignalInfo), '("show", WidgetShowSignalInfo), '("show-help", WidgetShowHelpSignalInfo), '("size-allocate", WidgetSizeAllocateSignalInfo), '("state-changed", WidgetStateChangedSignalInfo), '("state-flags-changed", WidgetStateFlagsChangedSignalInfo), '("style-set", WidgetStyleSetSignalInfo), '("style-updated", WidgetStyleUpdatedSignalInfo), '("toggle-cursor-child", FlowBoxToggleCursorChildSignalInfo), '("touch-event", WidgetTouchEventSignalInfo), '("unmap", WidgetUnmapSignalInfo), '("unmap-event", WidgetUnmapEventSignalInfo), '("unrealize", WidgetUnrealizeSignalInfo), '("unselect-all", FlowBoxUnselectAllSignalInfo), '("visibility-notify-event", WidgetVisibilityNotifyEventSignalInfo), '("window-state-event", WidgetWindowStateEventSignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method FlowBox::new
-- method type : Constructor
-- Args : []
-- Lengths : []
-- hInArgs : []
-- returnType : TInterface "Gtk" "FlowBox"
-- throws : False
-- Skip return : False

foreign import ccall "gtk_flow_box_new" gtk_flow_box_new :: 
    IO (Ptr FlowBox)


flowBoxNew ::
    (MonadIO m) =>
    m FlowBox
flowBoxNew  = liftIO $ do
    result <- gtk_flow_box_new
    checkUnexpectedReturnNULL "gtk_flow_box_new" result
    result' <- (newObject FlowBox) result
    return result'

-- method FlowBox::get_activate_on_single_click
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "gtk_flow_box_get_activate_on_single_click" gtk_flow_box_get_activate_on_single_click :: 
    Ptr FlowBox ->                          -- _obj : TInterface "Gtk" "FlowBox"
    IO CInt


flowBoxGetActivateOnSingleClick ::
    (MonadIO m, FlowBoxK a) =>
    a ->                                    -- _obj
    m Bool
flowBoxGetActivateOnSingleClick _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- gtk_flow_box_get_activate_on_single_click _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method FlowBox::get_child_at_index
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "idx", argType = TBasicType TInt32, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "idx", argType = TBasicType TInt32, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "Gtk" "FlowBoxChild"
-- throws : False
-- Skip return : False

foreign import ccall "gtk_flow_box_get_child_at_index" gtk_flow_box_get_child_at_index :: 
    Ptr FlowBox ->                          -- _obj : TInterface "Gtk" "FlowBox"
    Int32 ->                                -- idx : TBasicType TInt32
    IO (Ptr FlowBoxChild)


flowBoxGetChildAtIndex ::
    (MonadIO m, FlowBoxK a) =>
    a ->                                    -- _obj
    Int32 ->                                -- idx
    m FlowBoxChild
flowBoxGetChildAtIndex _obj idx = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- gtk_flow_box_get_child_at_index _obj' idx
    checkUnexpectedReturnNULL "gtk_flow_box_get_child_at_index" result
    result' <- (newObject FlowBoxChild) result
    touchManagedPtr _obj
    return result'

-- method FlowBox::get_column_spacing
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUInt32
-- throws : False
-- Skip return : False

foreign import ccall "gtk_flow_box_get_column_spacing" gtk_flow_box_get_column_spacing :: 
    Ptr FlowBox ->                          -- _obj : TInterface "Gtk" "FlowBox"
    IO Word32


flowBoxGetColumnSpacing ::
    (MonadIO m, FlowBoxK a) =>
    a ->                                    -- _obj
    m Word32
flowBoxGetColumnSpacing _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- gtk_flow_box_get_column_spacing _obj'
    touchManagedPtr _obj
    return result

-- method FlowBox::get_homogeneous
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "gtk_flow_box_get_homogeneous" gtk_flow_box_get_homogeneous :: 
    Ptr FlowBox ->                          -- _obj : TInterface "Gtk" "FlowBox"
    IO CInt


flowBoxGetHomogeneous ::
    (MonadIO m, FlowBoxK a) =>
    a ->                                    -- _obj
    m Bool
flowBoxGetHomogeneous _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- gtk_flow_box_get_homogeneous _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method FlowBox::get_max_children_per_line
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUInt32
-- throws : False
-- Skip return : False

foreign import ccall "gtk_flow_box_get_max_children_per_line" gtk_flow_box_get_max_children_per_line :: 
    Ptr FlowBox ->                          -- _obj : TInterface "Gtk" "FlowBox"
    IO Word32


flowBoxGetMaxChildrenPerLine ::
    (MonadIO m, FlowBoxK a) =>
    a ->                                    -- _obj
    m Word32
flowBoxGetMaxChildrenPerLine _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- gtk_flow_box_get_max_children_per_line _obj'
    touchManagedPtr _obj
    return result

-- method FlowBox::get_min_children_per_line
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUInt32
-- throws : False
-- Skip return : False

foreign import ccall "gtk_flow_box_get_min_children_per_line" gtk_flow_box_get_min_children_per_line :: 
    Ptr FlowBox ->                          -- _obj : TInterface "Gtk" "FlowBox"
    IO Word32


flowBoxGetMinChildrenPerLine ::
    (MonadIO m, FlowBoxK a) =>
    a ->                                    -- _obj
    m Word32
flowBoxGetMinChildrenPerLine _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- gtk_flow_box_get_min_children_per_line _obj'
    touchManagedPtr _obj
    return result

-- method FlowBox::get_row_spacing
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUInt32
-- throws : False
-- Skip return : False

foreign import ccall "gtk_flow_box_get_row_spacing" gtk_flow_box_get_row_spacing :: 
    Ptr FlowBox ->                          -- _obj : TInterface "Gtk" "FlowBox"
    IO Word32


flowBoxGetRowSpacing ::
    (MonadIO m, FlowBoxK a) =>
    a ->                                    -- _obj
    m Word32
flowBoxGetRowSpacing _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- gtk_flow_box_get_row_spacing _obj'
    touchManagedPtr _obj
    return result

-- method FlowBox::get_selected_children
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TGList (TInterface "Gtk" "FlowBoxChild")
-- throws : False
-- Skip return : False

foreign import ccall "gtk_flow_box_get_selected_children" gtk_flow_box_get_selected_children :: 
    Ptr FlowBox ->                          -- _obj : TInterface "Gtk" "FlowBox"
    IO (Ptr (GList (Ptr FlowBoxChild)))


flowBoxGetSelectedChildren ::
    (MonadIO m, FlowBoxK a) =>
    a ->                                    -- _obj
    m [FlowBoxChild]
flowBoxGetSelectedChildren _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- gtk_flow_box_get_selected_children _obj'
    checkUnexpectedReturnNULL "gtk_flow_box_get_selected_children" result
    result' <- unpackGList result
    result'' <- mapM (newObject FlowBoxChild) result'
    g_list_free result
    touchManagedPtr _obj
    return result''

-- method FlowBox::get_selection_mode
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "Gtk" "SelectionMode"
-- throws : False
-- Skip return : False

foreign import ccall "gtk_flow_box_get_selection_mode" gtk_flow_box_get_selection_mode :: 
    Ptr FlowBox ->                          -- _obj : TInterface "Gtk" "FlowBox"
    IO CUInt


flowBoxGetSelectionMode ::
    (MonadIO m, FlowBoxK a) =>
    a ->                                    -- _obj
    m SelectionMode
flowBoxGetSelectionMode _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- gtk_flow_box_get_selection_mode _obj'
    let result' = (toEnum . fromIntegral) result
    touchManagedPtr _obj
    return result'

-- method FlowBox::insert
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "widget", argType = TInterface "Gtk" "Widget", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "position", argType = TBasicType TInt32, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "widget", argType = TInterface "Gtk" "Widget", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "position", argType = TBasicType TInt32, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_flow_box_insert" gtk_flow_box_insert :: 
    Ptr FlowBox ->                          -- _obj : TInterface "Gtk" "FlowBox"
    Ptr Widget ->                           -- widget : TInterface "Gtk" "Widget"
    Int32 ->                                -- position : TBasicType TInt32
    IO ()


flowBoxInsert ::
    (MonadIO m, FlowBoxK a, WidgetK b) =>
    a ->                                    -- _obj
    b ->                                    -- widget
    Int32 ->                                -- position
    m ()
flowBoxInsert _obj widget position = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let widget' = unsafeManagedPtrCastPtr widget
    gtk_flow_box_insert _obj' widget' position
    touchManagedPtr _obj
    touchManagedPtr widget
    return ()

-- method FlowBox::invalidate_filter
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_flow_box_invalidate_filter" gtk_flow_box_invalidate_filter :: 
    Ptr FlowBox ->                          -- _obj : TInterface "Gtk" "FlowBox"
    IO ()


flowBoxInvalidateFilter ::
    (MonadIO m, FlowBoxK a) =>
    a ->                                    -- _obj
    m ()
flowBoxInvalidateFilter _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    gtk_flow_box_invalidate_filter _obj'
    touchManagedPtr _obj
    return ()

-- method FlowBox::invalidate_sort
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_flow_box_invalidate_sort" gtk_flow_box_invalidate_sort :: 
    Ptr FlowBox ->                          -- _obj : TInterface "Gtk" "FlowBox"
    IO ()


flowBoxInvalidateSort ::
    (MonadIO m, FlowBoxK a) =>
    a ->                                    -- _obj
    m ()
flowBoxInvalidateSort _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    gtk_flow_box_invalidate_sort _obj'
    touchManagedPtr _obj
    return ()

-- method FlowBox::select_all
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_flow_box_select_all" gtk_flow_box_select_all :: 
    Ptr FlowBox ->                          -- _obj : TInterface "Gtk" "FlowBox"
    IO ()


flowBoxSelectAll ::
    (MonadIO m, FlowBoxK a) =>
    a ->                                    -- _obj
    m ()
flowBoxSelectAll _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    gtk_flow_box_select_all _obj'
    touchManagedPtr _obj
    return ()

-- method FlowBox::select_child
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "child", argType = TInterface "Gtk" "FlowBoxChild", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "child", argType = TInterface "Gtk" "FlowBoxChild", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_flow_box_select_child" gtk_flow_box_select_child :: 
    Ptr FlowBox ->                          -- _obj : TInterface "Gtk" "FlowBox"
    Ptr FlowBoxChild ->                     -- child : TInterface "Gtk" "FlowBoxChild"
    IO ()


flowBoxSelectChild ::
    (MonadIO m, FlowBoxK a, FlowBoxChildK b) =>
    a ->                                    -- _obj
    b ->                                    -- child
    m ()
flowBoxSelectChild _obj child = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let child' = unsafeManagedPtrCastPtr child
    gtk_flow_box_select_child _obj' child'
    touchManagedPtr _obj
    touchManagedPtr child
    return ()

-- method FlowBox::selected_foreach
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "func", argType = TInterface "Gtk" "FlowBoxForeachFunc", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeCall, argClosure = 2, argDestroy = -1, transfer = TransferNothing},Arg {argName = "data", argType = TBasicType TVoid, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "func", argType = TInterface "Gtk" "FlowBoxForeachFunc", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeCall, argClosure = 2, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_flow_box_selected_foreach" gtk_flow_box_selected_foreach :: 
    Ptr FlowBox ->                          -- _obj : TInterface "Gtk" "FlowBox"
    FunPtr FlowBoxForeachFuncC ->           -- func : TInterface "Gtk" "FlowBoxForeachFunc"
    Ptr () ->                               -- data : TBasicType TVoid
    IO ()


flowBoxSelectedForeach ::
    (MonadIO m, FlowBoxK a) =>
    a ->                                    -- _obj
    FlowBoxForeachFunc ->                   -- func
    m ()
flowBoxSelectedForeach _obj func = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    func' <- mkFlowBoxForeachFunc (flowBoxForeachFuncWrapper Nothing func)
    let data_ = nullPtr
    gtk_flow_box_selected_foreach _obj' func' data_
    safeFreeFunPtr $ castFunPtrToPtr func'
    touchManagedPtr _obj
    return ()

-- method FlowBox::set_activate_on_single_click
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "single", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "single", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_flow_box_set_activate_on_single_click" gtk_flow_box_set_activate_on_single_click :: 
    Ptr FlowBox ->                          -- _obj : TInterface "Gtk" "FlowBox"
    CInt ->                                 -- single : TBasicType TBoolean
    IO ()


flowBoxSetActivateOnSingleClick ::
    (MonadIO m, FlowBoxK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- single
    m ()
flowBoxSetActivateOnSingleClick _obj single = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let single' = (fromIntegral . fromEnum) single
    gtk_flow_box_set_activate_on_single_click _obj' single'
    touchManagedPtr _obj
    return ()

-- method FlowBox::set_column_spacing
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "spacing", argType = TBasicType TUInt32, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "spacing", argType = TBasicType TUInt32, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_flow_box_set_column_spacing" gtk_flow_box_set_column_spacing :: 
    Ptr FlowBox ->                          -- _obj : TInterface "Gtk" "FlowBox"
    Word32 ->                               -- spacing : TBasicType TUInt32
    IO ()


flowBoxSetColumnSpacing ::
    (MonadIO m, FlowBoxK a) =>
    a ->                                    -- _obj
    Word32 ->                               -- spacing
    m ()
flowBoxSetColumnSpacing _obj spacing = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    gtk_flow_box_set_column_spacing _obj' spacing
    touchManagedPtr _obj
    return ()

-- method FlowBox::set_filter_func
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "filter_func", argType = TInterface "Gtk" "FlowBoxFilterFunc", direction = DirectionIn, mayBeNull = True, argScope = ScopeTypeNotified, argClosure = 2, argDestroy = 3, transfer = TransferNothing},Arg {argName = "user_data", argType = TBasicType TVoid, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "destroy", argType = TInterface "GLib" "DestroyNotify", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeAsync, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "filter_func", argType = TInterface "Gtk" "FlowBoxFilterFunc", direction = DirectionIn, mayBeNull = True, argScope = ScopeTypeNotified, argClosure = 2, argDestroy = 3, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_flow_box_set_filter_func" gtk_flow_box_set_filter_func :: 
    Ptr FlowBox ->                          -- _obj : TInterface "Gtk" "FlowBox"
    FunPtr FlowBoxFilterFuncC ->            -- filter_func : TInterface "Gtk" "FlowBoxFilterFunc"
    Ptr () ->                               -- user_data : TBasicType TVoid
    FunPtr GLib.DestroyNotifyC ->           -- destroy : TInterface "GLib" "DestroyNotify"
    IO ()


flowBoxSetFilterFunc ::
    (MonadIO m, FlowBoxK a) =>
    a ->                                    -- _obj
    Maybe (FlowBoxFilterFunc) ->            -- filter_func
    m ()
flowBoxSetFilterFunc _obj filter_func = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    maybeFilter_func <- case filter_func of
        Nothing -> return (castPtrToFunPtr nullPtr)
        Just jFilter_func -> do
            jFilter_func' <- mkFlowBoxFilterFunc (flowBoxFilterFuncWrapper Nothing jFilter_func)
            return jFilter_func'
    let user_data = castFunPtrToPtr maybeFilter_func
    let destroy = safeFreeFunPtrPtr
    gtk_flow_box_set_filter_func _obj' maybeFilter_func user_data destroy
    touchManagedPtr _obj
    return ()

-- method FlowBox::set_hadjustment
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "adjustment", argType = TInterface "Gtk" "Adjustment", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "adjustment", argType = TInterface "Gtk" "Adjustment", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_flow_box_set_hadjustment" gtk_flow_box_set_hadjustment :: 
    Ptr FlowBox ->                          -- _obj : TInterface "Gtk" "FlowBox"
    Ptr Adjustment ->                       -- adjustment : TInterface "Gtk" "Adjustment"
    IO ()


flowBoxSetHadjustment ::
    (MonadIO m, FlowBoxK a, AdjustmentK b) =>
    a ->                                    -- _obj
    b ->                                    -- adjustment
    m ()
flowBoxSetHadjustment _obj adjustment = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let adjustment' = unsafeManagedPtrCastPtr adjustment
    gtk_flow_box_set_hadjustment _obj' adjustment'
    touchManagedPtr _obj
    touchManagedPtr adjustment
    return ()

-- method FlowBox::set_homogeneous
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "homogeneous", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "homogeneous", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_flow_box_set_homogeneous" gtk_flow_box_set_homogeneous :: 
    Ptr FlowBox ->                          -- _obj : TInterface "Gtk" "FlowBox"
    CInt ->                                 -- homogeneous : TBasicType TBoolean
    IO ()


flowBoxSetHomogeneous ::
    (MonadIO m, FlowBoxK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- homogeneous
    m ()
flowBoxSetHomogeneous _obj homogeneous = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let homogeneous' = (fromIntegral . fromEnum) homogeneous
    gtk_flow_box_set_homogeneous _obj' homogeneous'
    touchManagedPtr _obj
    return ()

-- method FlowBox::set_max_children_per_line
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "n_children", argType = TBasicType TUInt32, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "n_children", argType = TBasicType TUInt32, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_flow_box_set_max_children_per_line" gtk_flow_box_set_max_children_per_line :: 
    Ptr FlowBox ->                          -- _obj : TInterface "Gtk" "FlowBox"
    Word32 ->                               -- n_children : TBasicType TUInt32
    IO ()


flowBoxSetMaxChildrenPerLine ::
    (MonadIO m, FlowBoxK a) =>
    a ->                                    -- _obj
    Word32 ->                               -- n_children
    m ()
flowBoxSetMaxChildrenPerLine _obj n_children = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    gtk_flow_box_set_max_children_per_line _obj' n_children
    touchManagedPtr _obj
    return ()

-- method FlowBox::set_min_children_per_line
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "n_children", argType = TBasicType TUInt32, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "n_children", argType = TBasicType TUInt32, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_flow_box_set_min_children_per_line" gtk_flow_box_set_min_children_per_line :: 
    Ptr FlowBox ->                          -- _obj : TInterface "Gtk" "FlowBox"
    Word32 ->                               -- n_children : TBasicType TUInt32
    IO ()


flowBoxSetMinChildrenPerLine ::
    (MonadIO m, FlowBoxK a) =>
    a ->                                    -- _obj
    Word32 ->                               -- n_children
    m ()
flowBoxSetMinChildrenPerLine _obj n_children = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    gtk_flow_box_set_min_children_per_line _obj' n_children
    touchManagedPtr _obj
    return ()

-- method FlowBox::set_row_spacing
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "spacing", argType = TBasicType TUInt32, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "spacing", argType = TBasicType TUInt32, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_flow_box_set_row_spacing" gtk_flow_box_set_row_spacing :: 
    Ptr FlowBox ->                          -- _obj : TInterface "Gtk" "FlowBox"
    Word32 ->                               -- spacing : TBasicType TUInt32
    IO ()


flowBoxSetRowSpacing ::
    (MonadIO m, FlowBoxK a) =>
    a ->                                    -- _obj
    Word32 ->                               -- spacing
    m ()
flowBoxSetRowSpacing _obj spacing = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    gtk_flow_box_set_row_spacing _obj' spacing
    touchManagedPtr _obj
    return ()

-- method FlowBox::set_selection_mode
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "mode", argType = TInterface "Gtk" "SelectionMode", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "mode", argType = TInterface "Gtk" "SelectionMode", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_flow_box_set_selection_mode" gtk_flow_box_set_selection_mode :: 
    Ptr FlowBox ->                          -- _obj : TInterface "Gtk" "FlowBox"
    CUInt ->                                -- mode : TInterface "Gtk" "SelectionMode"
    IO ()


flowBoxSetSelectionMode ::
    (MonadIO m, FlowBoxK a) =>
    a ->                                    -- _obj
    SelectionMode ->                        -- mode
    m ()
flowBoxSetSelectionMode _obj mode = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let mode' = (fromIntegral . fromEnum) mode
    gtk_flow_box_set_selection_mode _obj' mode'
    touchManagedPtr _obj
    return ()

-- method FlowBox::set_sort_func
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "sort_func", argType = TInterface "Gtk" "FlowBoxSortFunc", direction = DirectionIn, mayBeNull = True, argScope = ScopeTypeNotified, argClosure = 2, argDestroy = 3, transfer = TransferNothing},Arg {argName = "user_data", argType = TBasicType TVoid, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "destroy", argType = TInterface "GLib" "DestroyNotify", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeAsync, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "sort_func", argType = TInterface "Gtk" "FlowBoxSortFunc", direction = DirectionIn, mayBeNull = True, argScope = ScopeTypeNotified, argClosure = 2, argDestroy = 3, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_flow_box_set_sort_func" gtk_flow_box_set_sort_func :: 
    Ptr FlowBox ->                          -- _obj : TInterface "Gtk" "FlowBox"
    FunPtr FlowBoxSortFuncC ->              -- sort_func : TInterface "Gtk" "FlowBoxSortFunc"
    Ptr () ->                               -- user_data : TBasicType TVoid
    FunPtr GLib.DestroyNotifyC ->           -- destroy : TInterface "GLib" "DestroyNotify"
    IO ()


flowBoxSetSortFunc ::
    (MonadIO m, FlowBoxK a) =>
    a ->                                    -- _obj
    Maybe (FlowBoxSortFunc) ->              -- sort_func
    m ()
flowBoxSetSortFunc _obj sort_func = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    maybeSort_func <- case sort_func of
        Nothing -> return (castPtrToFunPtr nullPtr)
        Just jSort_func -> do
            jSort_func' <- mkFlowBoxSortFunc (flowBoxSortFuncWrapper Nothing jSort_func)
            return jSort_func'
    let user_data = castFunPtrToPtr maybeSort_func
    let destroy = safeFreeFunPtrPtr
    gtk_flow_box_set_sort_func _obj' maybeSort_func user_data destroy
    touchManagedPtr _obj
    return ()

-- method FlowBox::set_vadjustment
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "adjustment", argType = TInterface "Gtk" "Adjustment", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "adjustment", argType = TInterface "Gtk" "Adjustment", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_flow_box_set_vadjustment" gtk_flow_box_set_vadjustment :: 
    Ptr FlowBox ->                          -- _obj : TInterface "Gtk" "FlowBox"
    Ptr Adjustment ->                       -- adjustment : TInterface "Gtk" "Adjustment"
    IO ()


flowBoxSetVadjustment ::
    (MonadIO m, FlowBoxK a, AdjustmentK b) =>
    a ->                                    -- _obj
    b ->                                    -- adjustment
    m ()
flowBoxSetVadjustment _obj adjustment = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let adjustment' = unsafeManagedPtrCastPtr adjustment
    gtk_flow_box_set_vadjustment _obj' adjustment'
    touchManagedPtr _obj
    touchManagedPtr adjustment
    return ()

-- method FlowBox::unselect_all
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_flow_box_unselect_all" gtk_flow_box_unselect_all :: 
    Ptr FlowBox ->                          -- _obj : TInterface "Gtk" "FlowBox"
    IO ()


flowBoxUnselectAll ::
    (MonadIO m, FlowBoxK a) =>
    a ->                                    -- _obj
    m ()
flowBoxUnselectAll _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    gtk_flow_box_unselect_all _obj'
    touchManagedPtr _obj
    return ()

-- method FlowBox::unselect_child
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "child", argType = TInterface "Gtk" "FlowBoxChild", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "FlowBox", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "child", argType = TInterface "Gtk" "FlowBoxChild", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_flow_box_unselect_child" gtk_flow_box_unselect_child :: 
    Ptr FlowBox ->                          -- _obj : TInterface "Gtk" "FlowBox"
    Ptr FlowBoxChild ->                     -- child : TInterface "Gtk" "FlowBoxChild"
    IO ()


flowBoxUnselectChild ::
    (MonadIO m, FlowBoxK a, FlowBoxChildK b) =>
    a ->                                    -- _obj
    b ->                                    -- child
    m ()
flowBoxUnselectChild _obj child = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let child' = unsafeManagedPtrCastPtr child
    gtk_flow_box_unselect_child _obj' child'
    touchManagedPtr _obj
    touchManagedPtr child
    return ()


