
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Gtk.Objects.GestureRotate
    ( 

-- * Exported types
    GestureRotate(..)                       ,
    GestureRotateK                          ,
    toGestureRotate                         ,
    noGestureRotate                         ,


 -- * Methods
-- ** gestureRotateGetAngleDelta
    gestureRotateGetAngleDelta              ,


-- ** gestureRotateNew
    gestureRotateNew                        ,




 -- * Signals
-- ** AngleChanged
    GestureRotateAngleChangedCallback       ,
    GestureRotateAngleChangedCallbackC      ,
    GestureRotateAngleChangedSignalInfo     ,
    afterGestureRotateAngleChanged          ,
    gestureRotateAngleChangedCallbackWrapper,
    gestureRotateAngleChangedClosure        ,
    mkGestureRotateAngleChangedCallback     ,
    noGestureRotateAngleChangedCallback     ,
    onGestureRotateAngleChanged             ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Gtk.Types
import GI.Gtk.Callbacks
import qualified GI.GObject as GObject

newtype GestureRotate = GestureRotate (ForeignPtr GestureRotate)
foreign import ccall "gtk_gesture_rotate_get_type"
    c_gtk_gesture_rotate_get_type :: IO GType

type instance ParentTypes GestureRotate = GestureRotateParentTypes
type GestureRotateParentTypes = '[Gesture, EventController, GObject.Object]

instance GObject GestureRotate where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_gtk_gesture_rotate_get_type
    

class GObject o => GestureRotateK o
instance (GObject o, IsDescendantOf GestureRotate o) => GestureRotateK o

toGestureRotate :: GestureRotateK o => o -> IO GestureRotate
toGestureRotate = unsafeCastTo GestureRotate

noGestureRotate :: Maybe GestureRotate
noGestureRotate = Nothing

-- signal GestureRotate::angle-changed
type GestureRotateAngleChangedCallback =
    Double ->
    Double ->
    IO ()

noGestureRotateAngleChangedCallback :: Maybe GestureRotateAngleChangedCallback
noGestureRotateAngleChangedCallback = Nothing

type GestureRotateAngleChangedCallbackC =
    Ptr () ->                               -- object
    CDouble ->
    CDouble ->
    Ptr () ->                               -- user_data
    IO ()

foreign import ccall "wrapper"
    mkGestureRotateAngleChangedCallback :: GestureRotateAngleChangedCallbackC -> IO (FunPtr GestureRotateAngleChangedCallbackC)

gestureRotateAngleChangedClosure :: GestureRotateAngleChangedCallback -> IO Closure
gestureRotateAngleChangedClosure cb = newCClosure =<< mkGestureRotateAngleChangedCallback wrapped
    where wrapped = gestureRotateAngleChangedCallbackWrapper cb

gestureRotateAngleChangedCallbackWrapper ::
    GestureRotateAngleChangedCallback ->
    Ptr () ->
    CDouble ->
    CDouble ->
    Ptr () ->
    IO ()
gestureRotateAngleChangedCallbackWrapper _cb _ angle angle_delta _ = do
    let angle' = realToFrac angle
    let angle_delta' = realToFrac angle_delta
    _cb  angle' angle_delta'

onGestureRotateAngleChanged :: (GObject a, MonadIO m) => a -> GestureRotateAngleChangedCallback -> m SignalHandlerId
onGestureRotateAngleChanged obj cb = liftIO $ connectGestureRotateAngleChanged obj cb SignalConnectBefore
afterGestureRotateAngleChanged :: (GObject a, MonadIO m) => a -> GestureRotateAngleChangedCallback -> m SignalHandlerId
afterGestureRotateAngleChanged obj cb = connectGestureRotateAngleChanged obj cb SignalConnectAfter

connectGestureRotateAngleChanged :: (GObject a, MonadIO m) =>
                                    a -> GestureRotateAngleChangedCallback -> SignalConnectMode -> m SignalHandlerId
connectGestureRotateAngleChanged obj cb after = liftIO $ do
    cb' <- mkGestureRotateAngleChangedCallback (gestureRotateAngleChangedCallbackWrapper cb)
    connectSignalFunPtr obj "angle-changed" cb' after

type instance AttributeList GestureRotate = GestureRotateAttributeList
type GestureRotateAttributeList = ('[ '("n-points", GestureNPointsPropertyInfo), '("propagation-phase", EventControllerPropagationPhasePropertyInfo), '("widget", EventControllerWidgetPropertyInfo), '("window", GestureWindowPropertyInfo)] :: [(Symbol, *)])

data GestureRotateAngleChangedSignalInfo
instance SignalInfo GestureRotateAngleChangedSignalInfo where
    type HaskellCallbackType GestureRotateAngleChangedSignalInfo = GestureRotateAngleChangedCallback
    connectSignal _ = connectGestureRotateAngleChanged

type instance SignalList GestureRotate = GestureRotateSignalList
type GestureRotateSignalList = ('[ '("angle-changed", GestureRotateAngleChangedSignalInfo), '("begin", GestureBeginSignalInfo), '("cancel", GestureCancelSignalInfo), '("end", GestureEndSignalInfo), '("notify", GObject.ObjectNotifySignalInfo), '("sequence-state-changed", GestureSequenceStateChangedSignalInfo), '("update", GestureUpdateSignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method GestureRotate::new
-- method type : Constructor
-- Args : [Arg {argName = "widget", argType = TInterface "Gtk" "Widget", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "widget", argType = TInterface "Gtk" "Widget", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "Gtk" "GestureRotate"
-- throws : False
-- Skip return : False

foreign import ccall "gtk_gesture_rotate_new" gtk_gesture_rotate_new :: 
    Ptr Widget ->                           -- widget : TInterface "Gtk" "Widget"
    IO (Ptr GestureRotate)


gestureRotateNew ::
    (MonadIO m, WidgetK a) =>
    a ->                                    -- widget
    m GestureRotate
gestureRotateNew widget = liftIO $ do
    let widget' = unsafeManagedPtrCastPtr widget
    result <- gtk_gesture_rotate_new widget'
    checkUnexpectedReturnNULL "gtk_gesture_rotate_new" result
    result' <- (wrapObject GestureRotate) result
    touchManagedPtr widget
    return result'

-- method GestureRotate::get_angle_delta
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "GestureRotate", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "GestureRotate", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TDouble
-- throws : False
-- Skip return : False

foreign import ccall "gtk_gesture_rotate_get_angle_delta" gtk_gesture_rotate_get_angle_delta :: 
    Ptr GestureRotate ->                    -- _obj : TInterface "Gtk" "GestureRotate"
    IO CDouble


gestureRotateGetAngleDelta ::
    (MonadIO m, GestureRotateK a) =>
    a ->                                    -- _obj
    m Double
gestureRotateGetAngleDelta _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- gtk_gesture_rotate_get_angle_delta _obj'
    let result' = realToFrac result
    touchManagedPtr _obj
    return result'


