
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Gtk.Objects.IMContextSimple
    ( 

-- * Exported types
    IMContextSimple(..)                     ,
    IMContextSimpleK                        ,
    toIMContextSimple                       ,
    noIMContextSimple                       ,


 -- * Methods
-- ** iMContextSimpleNew
    iMContextSimpleNew                      ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Gtk.Types
import GI.Gtk.Callbacks
import qualified GI.GObject as GObject

newtype IMContextSimple = IMContextSimple (ForeignPtr IMContextSimple)
foreign import ccall "gtk_im_context_simple_get_type"
    c_gtk_im_context_simple_get_type :: IO GType

type instance ParentTypes IMContextSimple = IMContextSimpleParentTypes
type IMContextSimpleParentTypes = '[IMContext, GObject.Object]

instance GObject IMContextSimple where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_gtk_im_context_simple_get_type
    

class GObject o => IMContextSimpleK o
instance (GObject o, IsDescendantOf IMContextSimple o) => IMContextSimpleK o

toIMContextSimple :: IMContextSimpleK o => o -> IO IMContextSimple
toIMContextSimple = unsafeCastTo IMContextSimple

noIMContextSimple :: Maybe IMContextSimple
noIMContextSimple = Nothing

type instance AttributeList IMContextSimple = IMContextSimpleAttributeList
type IMContextSimpleAttributeList = ('[ '("input-hints", IMContextInputHintsPropertyInfo), '("input-purpose", IMContextInputPurposePropertyInfo)] :: [(Symbol, *)])

type instance SignalList IMContextSimple = IMContextSimpleSignalList
type IMContextSimpleSignalList = ('[ '("commit", IMContextCommitSignalInfo), '("delete-surrounding", IMContextDeleteSurroundingSignalInfo), '("notify", GObject.ObjectNotifySignalInfo), '("preedit-changed", IMContextPreeditChangedSignalInfo), '("preedit-end", IMContextPreeditEndSignalInfo), '("preedit-start", IMContextPreeditStartSignalInfo), '("retrieve-surrounding", IMContextRetrieveSurroundingSignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method IMContextSimple::new
-- method type : Constructor
-- Args : []
-- Lengths : []
-- hInArgs : []
-- returnType : TInterface "Gtk" "IMContextSimple"
-- throws : False
-- Skip return : False

foreign import ccall "gtk_im_context_simple_new" gtk_im_context_simple_new :: 
    IO (Ptr IMContextSimple)


iMContextSimpleNew ::
    (MonadIO m) =>
    m IMContextSimple
iMContextSimpleNew  = liftIO $ do
    result <- gtk_im_context_simple_new
    checkUnexpectedReturnNULL "gtk_im_context_simple_new" result
    result' <- (wrapObject IMContextSimple) result
    return result'


