
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Gtk.Objects.LevelBar
    ( 

-- * Exported types
    LevelBar(..)                            ,
    LevelBarK                               ,
    toLevelBar                              ,
    noLevelBar                              ,


 -- * Methods
-- ** levelBarAddOffsetValue
    levelBarAddOffsetValue                  ,


-- ** levelBarGetInverted
    levelBarGetInverted                     ,


-- ** levelBarGetMaxValue
    levelBarGetMaxValue                     ,


-- ** levelBarGetMinValue
    levelBarGetMinValue                     ,


-- ** levelBarGetMode
    levelBarGetMode                         ,


-- ** levelBarGetOffsetValue
    levelBarGetOffsetValue                  ,


-- ** levelBarGetValue
    levelBarGetValue                        ,


-- ** levelBarNew
    levelBarNew                             ,


-- ** levelBarNewForInterval
    levelBarNewForInterval                  ,


-- ** levelBarRemoveOffsetValue
    levelBarRemoveOffsetValue               ,


-- ** levelBarSetInverted
    levelBarSetInverted                     ,


-- ** levelBarSetMaxValue
    levelBarSetMaxValue                     ,


-- ** levelBarSetMinValue
    levelBarSetMinValue                     ,


-- ** levelBarSetMode
    levelBarSetMode                         ,


-- ** levelBarSetValue
    levelBarSetValue                        ,




 -- * Properties
-- ** Inverted
    LevelBarInvertedPropertyInfo            ,
    constructLevelBarInverted               ,
    getLevelBarInverted                     ,
    setLevelBarInverted                     ,


-- ** MaxValue
    LevelBarMaxValuePropertyInfo            ,
    constructLevelBarMaxValue               ,
    getLevelBarMaxValue                     ,
    setLevelBarMaxValue                     ,


-- ** MinValue
    LevelBarMinValuePropertyInfo            ,
    constructLevelBarMinValue               ,
    getLevelBarMinValue                     ,
    setLevelBarMinValue                     ,


-- ** Mode
    LevelBarModePropertyInfo                ,
    constructLevelBarMode                   ,
    getLevelBarMode                         ,
    setLevelBarMode                         ,


-- ** Value
    LevelBarValuePropertyInfo               ,
    constructLevelBarValue                  ,
    getLevelBarValue                        ,
    setLevelBarValue                        ,




 -- * Signals
-- ** OffsetChanged
    LevelBarOffsetChangedCallback           ,
    LevelBarOffsetChangedCallbackC          ,
    LevelBarOffsetChangedSignalInfo         ,
    afterLevelBarOffsetChanged              ,
    levelBarOffsetChangedCallbackWrapper    ,
    levelBarOffsetChangedClosure            ,
    mkLevelBarOffsetChangedCallback         ,
    noLevelBarOffsetChangedCallback         ,
    onLevelBarOffsetChanged                 ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Gtk.Types
import GI.Gtk.Callbacks
import qualified GI.Atk as Atk
import qualified GI.GObject as GObject

newtype LevelBar = LevelBar (ForeignPtr LevelBar)
foreign import ccall "gtk_level_bar_get_type"
    c_gtk_level_bar_get_type :: IO GType

type instance ParentTypes LevelBar = LevelBarParentTypes
type LevelBarParentTypes = '[Widget, GObject.Object, Atk.ImplementorIface, Buildable, Orientable]

instance GObject LevelBar where
    gobjectIsInitiallyUnowned _ = True
    gobjectType _ = c_gtk_level_bar_get_type
    

class GObject o => LevelBarK o
instance (GObject o, IsDescendantOf LevelBar o) => LevelBarK o

toLevelBar :: LevelBarK o => o -> IO LevelBar
toLevelBar = unsafeCastTo LevelBar

noLevelBar :: Maybe LevelBar
noLevelBar = Nothing

-- signal LevelBar::offset-changed
type LevelBarOffsetChangedCallback =
    T.Text ->
    IO ()

noLevelBarOffsetChangedCallback :: Maybe LevelBarOffsetChangedCallback
noLevelBarOffsetChangedCallback = Nothing

type LevelBarOffsetChangedCallbackC =
    Ptr () ->                               -- object
    CString ->
    Ptr () ->                               -- user_data
    IO ()

foreign import ccall "wrapper"
    mkLevelBarOffsetChangedCallback :: LevelBarOffsetChangedCallbackC -> IO (FunPtr LevelBarOffsetChangedCallbackC)

levelBarOffsetChangedClosure :: LevelBarOffsetChangedCallback -> IO Closure
levelBarOffsetChangedClosure cb = newCClosure =<< mkLevelBarOffsetChangedCallback wrapped
    where wrapped = levelBarOffsetChangedCallbackWrapper cb

levelBarOffsetChangedCallbackWrapper ::
    LevelBarOffsetChangedCallback ->
    Ptr () ->
    CString ->
    Ptr () ->
    IO ()
levelBarOffsetChangedCallbackWrapper _cb _ name _ = do
    name' <- cstringToText name
    _cb  name'

onLevelBarOffsetChanged :: (GObject a, MonadIO m) => a -> LevelBarOffsetChangedCallback -> m SignalHandlerId
onLevelBarOffsetChanged obj cb = liftIO $ connectLevelBarOffsetChanged obj cb SignalConnectBefore
afterLevelBarOffsetChanged :: (GObject a, MonadIO m) => a -> LevelBarOffsetChangedCallback -> m SignalHandlerId
afterLevelBarOffsetChanged obj cb = connectLevelBarOffsetChanged obj cb SignalConnectAfter

connectLevelBarOffsetChanged :: (GObject a, MonadIO m) =>
                                a -> LevelBarOffsetChangedCallback -> SignalConnectMode -> m SignalHandlerId
connectLevelBarOffsetChanged obj cb after = liftIO $ do
    cb' <- mkLevelBarOffsetChangedCallback (levelBarOffsetChangedCallbackWrapper cb)
    connectSignalFunPtr obj "offset-changed" cb' after

-- VVV Prop "inverted"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getLevelBarInverted :: (MonadIO m, LevelBarK o) => o -> m Bool
getLevelBarInverted obj = liftIO $ getObjectPropertyBool obj "inverted"

setLevelBarInverted :: (MonadIO m, LevelBarK o) => o -> Bool -> m ()
setLevelBarInverted obj val = liftIO $ setObjectPropertyBool obj "inverted" val

constructLevelBarInverted :: Bool -> IO ([Char], GValue)
constructLevelBarInverted val = constructObjectPropertyBool "inverted" val

data LevelBarInvertedPropertyInfo
instance AttrInfo LevelBarInvertedPropertyInfo where
    type AttrAllowedOps LevelBarInvertedPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint LevelBarInvertedPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint LevelBarInvertedPropertyInfo = LevelBarK
    type AttrGetType LevelBarInvertedPropertyInfo = Bool
    type AttrLabel LevelBarInvertedPropertyInfo = "LevelBar::inverted"
    attrGet _ = getLevelBarInverted
    attrSet _ = setLevelBarInverted
    attrConstruct _ = constructLevelBarInverted

-- VVV Prop "max-value"
   -- Type: TBasicType TDouble
   -- Flags: [PropertyReadable,PropertyWritable]

getLevelBarMaxValue :: (MonadIO m, LevelBarK o) => o -> m Double
getLevelBarMaxValue obj = liftIO $ getObjectPropertyDouble obj "max-value"

setLevelBarMaxValue :: (MonadIO m, LevelBarK o) => o -> Double -> m ()
setLevelBarMaxValue obj val = liftIO $ setObjectPropertyDouble obj "max-value" val

constructLevelBarMaxValue :: Double -> IO ([Char], GValue)
constructLevelBarMaxValue val = constructObjectPropertyDouble "max-value" val

data LevelBarMaxValuePropertyInfo
instance AttrInfo LevelBarMaxValuePropertyInfo where
    type AttrAllowedOps LevelBarMaxValuePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint LevelBarMaxValuePropertyInfo = (~) Double
    type AttrBaseTypeConstraint LevelBarMaxValuePropertyInfo = LevelBarK
    type AttrGetType LevelBarMaxValuePropertyInfo = Double
    type AttrLabel LevelBarMaxValuePropertyInfo = "LevelBar::max-value"
    attrGet _ = getLevelBarMaxValue
    attrSet _ = setLevelBarMaxValue
    attrConstruct _ = constructLevelBarMaxValue

-- VVV Prop "min-value"
   -- Type: TBasicType TDouble
   -- Flags: [PropertyReadable,PropertyWritable]

getLevelBarMinValue :: (MonadIO m, LevelBarK o) => o -> m Double
getLevelBarMinValue obj = liftIO $ getObjectPropertyDouble obj "min-value"

setLevelBarMinValue :: (MonadIO m, LevelBarK o) => o -> Double -> m ()
setLevelBarMinValue obj val = liftIO $ setObjectPropertyDouble obj "min-value" val

constructLevelBarMinValue :: Double -> IO ([Char], GValue)
constructLevelBarMinValue val = constructObjectPropertyDouble "min-value" val

data LevelBarMinValuePropertyInfo
instance AttrInfo LevelBarMinValuePropertyInfo where
    type AttrAllowedOps LevelBarMinValuePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint LevelBarMinValuePropertyInfo = (~) Double
    type AttrBaseTypeConstraint LevelBarMinValuePropertyInfo = LevelBarK
    type AttrGetType LevelBarMinValuePropertyInfo = Double
    type AttrLabel LevelBarMinValuePropertyInfo = "LevelBar::min-value"
    attrGet _ = getLevelBarMinValue
    attrSet _ = setLevelBarMinValue
    attrConstruct _ = constructLevelBarMinValue

-- VVV Prop "mode"
   -- Type: TInterface "Gtk" "LevelBarMode"
   -- Flags: [PropertyReadable,PropertyWritable]

getLevelBarMode :: (MonadIO m, LevelBarK o) => o -> m LevelBarMode
getLevelBarMode obj = liftIO $ getObjectPropertyEnum obj "mode"

setLevelBarMode :: (MonadIO m, LevelBarK o) => o -> LevelBarMode -> m ()
setLevelBarMode obj val = liftIO $ setObjectPropertyEnum obj "mode" val

constructLevelBarMode :: LevelBarMode -> IO ([Char], GValue)
constructLevelBarMode val = constructObjectPropertyEnum "mode" val

data LevelBarModePropertyInfo
instance AttrInfo LevelBarModePropertyInfo where
    type AttrAllowedOps LevelBarModePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint LevelBarModePropertyInfo = (~) LevelBarMode
    type AttrBaseTypeConstraint LevelBarModePropertyInfo = LevelBarK
    type AttrGetType LevelBarModePropertyInfo = LevelBarMode
    type AttrLabel LevelBarModePropertyInfo = "LevelBar::mode"
    attrGet _ = getLevelBarMode
    attrSet _ = setLevelBarMode
    attrConstruct _ = constructLevelBarMode

-- VVV Prop "value"
   -- Type: TBasicType TDouble
   -- Flags: [PropertyReadable,PropertyWritable]

getLevelBarValue :: (MonadIO m, LevelBarK o) => o -> m Double
getLevelBarValue obj = liftIO $ getObjectPropertyDouble obj "value"

setLevelBarValue :: (MonadIO m, LevelBarK o) => o -> Double -> m ()
setLevelBarValue obj val = liftIO $ setObjectPropertyDouble obj "value" val

constructLevelBarValue :: Double -> IO ([Char], GValue)
constructLevelBarValue val = constructObjectPropertyDouble "value" val

data LevelBarValuePropertyInfo
instance AttrInfo LevelBarValuePropertyInfo where
    type AttrAllowedOps LevelBarValuePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint LevelBarValuePropertyInfo = (~) Double
    type AttrBaseTypeConstraint LevelBarValuePropertyInfo = LevelBarK
    type AttrGetType LevelBarValuePropertyInfo = Double
    type AttrLabel LevelBarValuePropertyInfo = "LevelBar::value"
    attrGet _ = getLevelBarValue
    attrSet _ = setLevelBarValue
    attrConstruct _ = constructLevelBarValue

type instance AttributeList LevelBar = LevelBarAttributeList
type LevelBarAttributeList = ('[ '("app-paintable", WidgetAppPaintablePropertyInfo), '("can-default", WidgetCanDefaultPropertyInfo), '("can-focus", WidgetCanFocusPropertyInfo), '("composite-child", WidgetCompositeChildPropertyInfo), '("double-buffered", WidgetDoubleBufferedPropertyInfo), '("events", WidgetEventsPropertyInfo), '("expand", WidgetExpandPropertyInfo), '("halign", WidgetHalignPropertyInfo), '("has-default", WidgetHasDefaultPropertyInfo), '("has-focus", WidgetHasFocusPropertyInfo), '("has-tooltip", WidgetHasTooltipPropertyInfo), '("height-request", WidgetHeightRequestPropertyInfo), '("hexpand", WidgetHexpandPropertyInfo), '("hexpand-set", WidgetHexpandSetPropertyInfo), '("inverted", LevelBarInvertedPropertyInfo), '("is-focus", WidgetIsFocusPropertyInfo), '("margin", WidgetMarginPropertyInfo), '("margin-bottom", WidgetMarginBottomPropertyInfo), '("margin-end", WidgetMarginEndPropertyInfo), '("margin-left", WidgetMarginLeftPropertyInfo), '("margin-right", WidgetMarginRightPropertyInfo), '("margin-start", WidgetMarginStartPropertyInfo), '("margin-top", WidgetMarginTopPropertyInfo), '("max-value", LevelBarMaxValuePropertyInfo), '("min-value", LevelBarMinValuePropertyInfo), '("mode", LevelBarModePropertyInfo), '("name", WidgetNamePropertyInfo), '("no-show-all", WidgetNoShowAllPropertyInfo), '("opacity", WidgetOpacityPropertyInfo), '("orientation", OrientableOrientationPropertyInfo), '("parent", WidgetParentPropertyInfo), '("receives-default", WidgetReceivesDefaultPropertyInfo), '("scale-factor", WidgetScaleFactorPropertyInfo), '("sensitive", WidgetSensitivePropertyInfo), '("style", WidgetStylePropertyInfo), '("tooltip-markup", WidgetTooltipMarkupPropertyInfo), '("tooltip-text", WidgetTooltipTextPropertyInfo), '("valign", WidgetValignPropertyInfo), '("value", LevelBarValuePropertyInfo), '("vexpand", WidgetVexpandPropertyInfo), '("vexpand-set", WidgetVexpandSetPropertyInfo), '("visible", WidgetVisiblePropertyInfo), '("width-request", WidgetWidthRequestPropertyInfo), '("window", WidgetWindowPropertyInfo)] :: [(Symbol, *)])

data LevelBarOffsetChangedSignalInfo
instance SignalInfo LevelBarOffsetChangedSignalInfo where
    type HaskellCallbackType LevelBarOffsetChangedSignalInfo = LevelBarOffsetChangedCallback
    connectSignal _ = connectLevelBarOffsetChanged

type instance SignalList LevelBar = LevelBarSignalList
type LevelBarSignalList = ('[ '("accel-closures-changed", WidgetAccelClosuresChangedSignalInfo), '("button-press-event", WidgetButtonPressEventSignalInfo), '("button-release-event", WidgetButtonReleaseEventSignalInfo), '("can-activate-accel", WidgetCanActivateAccelSignalInfo), '("child-notify", WidgetChildNotifySignalInfo), '("composited-changed", WidgetCompositedChangedSignalInfo), '("configure-event", WidgetConfigureEventSignalInfo), '("damage-event", WidgetDamageEventSignalInfo), '("delete-event", WidgetDeleteEventSignalInfo), '("destroy", WidgetDestroySignalInfo), '("destroy-event", WidgetDestroyEventSignalInfo), '("direction-changed", WidgetDirectionChangedSignalInfo), '("drag-begin", WidgetDragBeginSignalInfo), '("drag-data-delete", WidgetDragDataDeleteSignalInfo), '("drag-data-get", WidgetDragDataGetSignalInfo), '("drag-data-received", WidgetDragDataReceivedSignalInfo), '("drag-drop", WidgetDragDropSignalInfo), '("drag-end", WidgetDragEndSignalInfo), '("drag-failed", WidgetDragFailedSignalInfo), '("drag-leave", WidgetDragLeaveSignalInfo), '("drag-motion", WidgetDragMotionSignalInfo), '("draw", WidgetDrawSignalInfo), '("enter-notify-event", WidgetEnterNotifyEventSignalInfo), '("event", WidgetEventSignalInfo), '("event-after", WidgetEventAfterSignalInfo), '("focus", WidgetFocusSignalInfo), '("focus-in-event", WidgetFocusInEventSignalInfo), '("focus-out-event", WidgetFocusOutEventSignalInfo), '("grab-broken-event", WidgetGrabBrokenEventSignalInfo), '("grab-focus", WidgetGrabFocusSignalInfo), '("grab-notify", WidgetGrabNotifySignalInfo), '("hide", WidgetHideSignalInfo), '("hierarchy-changed", WidgetHierarchyChangedSignalInfo), '("key-press-event", WidgetKeyPressEventSignalInfo), '("key-release-event", WidgetKeyReleaseEventSignalInfo), '("keynav-failed", WidgetKeynavFailedSignalInfo), '("leave-notify-event", WidgetLeaveNotifyEventSignalInfo), '("map", WidgetMapSignalInfo), '("map-event", WidgetMapEventSignalInfo), '("mnemonic-activate", WidgetMnemonicActivateSignalInfo), '("motion-notify-event", WidgetMotionNotifyEventSignalInfo), '("move-focus", WidgetMoveFocusSignalInfo), '("notify", GObject.ObjectNotifySignalInfo), '("offset-changed", LevelBarOffsetChangedSignalInfo), '("parent-set", WidgetParentSetSignalInfo), '("popup-menu", WidgetPopupMenuSignalInfo), '("property-notify-event", WidgetPropertyNotifyEventSignalInfo), '("proximity-in-event", WidgetProximityInEventSignalInfo), '("proximity-out-event", WidgetProximityOutEventSignalInfo), '("query-tooltip", WidgetQueryTooltipSignalInfo), '("realize", WidgetRealizeSignalInfo), '("screen-changed", WidgetScreenChangedSignalInfo), '("scroll-event", WidgetScrollEventSignalInfo), '("selection-clear-event", WidgetSelectionClearEventSignalInfo), '("selection-get", WidgetSelectionGetSignalInfo), '("selection-notify-event", WidgetSelectionNotifyEventSignalInfo), '("selection-received", WidgetSelectionReceivedSignalInfo), '("selection-request-event", WidgetSelectionRequestEventSignalInfo), '("show", WidgetShowSignalInfo), '("show-help", WidgetShowHelpSignalInfo), '("size-allocate", WidgetSizeAllocateSignalInfo), '("state-changed", WidgetStateChangedSignalInfo), '("state-flags-changed", WidgetStateFlagsChangedSignalInfo), '("style-set", WidgetStyleSetSignalInfo), '("style-updated", WidgetStyleUpdatedSignalInfo), '("touch-event", WidgetTouchEventSignalInfo), '("unmap", WidgetUnmapSignalInfo), '("unmap-event", WidgetUnmapEventSignalInfo), '("unrealize", WidgetUnrealizeSignalInfo), '("visibility-notify-event", WidgetVisibilityNotifyEventSignalInfo), '("window-state-event", WidgetWindowStateEventSignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method LevelBar::new
-- method type : Constructor
-- Args : []
-- Lengths : []
-- hInArgs : []
-- returnType : TInterface "Gtk" "LevelBar"
-- throws : False
-- Skip return : False

foreign import ccall "gtk_level_bar_new" gtk_level_bar_new :: 
    IO (Ptr LevelBar)


levelBarNew ::
    (MonadIO m) =>
    m LevelBar
levelBarNew  = liftIO $ do
    result <- gtk_level_bar_new
    checkUnexpectedReturnNULL "gtk_level_bar_new" result
    result' <- (newObject LevelBar) result
    return result'

-- method LevelBar::new_for_interval
-- method type : Constructor
-- Args : [Arg {argName = "min_value", argType = TBasicType TDouble, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "max_value", argType = TBasicType TDouble, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "min_value", argType = TBasicType TDouble, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "max_value", argType = TBasicType TDouble, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "Gtk" "LevelBar"
-- throws : False
-- Skip return : False

foreign import ccall "gtk_level_bar_new_for_interval" gtk_level_bar_new_for_interval :: 
    CDouble ->                              -- min_value : TBasicType TDouble
    CDouble ->                              -- max_value : TBasicType TDouble
    IO (Ptr LevelBar)


levelBarNewForInterval ::
    (MonadIO m) =>
    Double ->                               -- min_value
    Double ->                               -- max_value
    m LevelBar
levelBarNewForInterval min_value max_value = liftIO $ do
    let min_value' = realToFrac min_value
    let max_value' = realToFrac max_value
    result <- gtk_level_bar_new_for_interval min_value' max_value'
    checkUnexpectedReturnNULL "gtk_level_bar_new_for_interval" result
    result' <- (newObject LevelBar) result
    return result'

-- method LevelBar::add_offset_value
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "LevelBar", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "name", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TDouble, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "LevelBar", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "name", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TDouble, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_level_bar_add_offset_value" gtk_level_bar_add_offset_value :: 
    Ptr LevelBar ->                         -- _obj : TInterface "Gtk" "LevelBar"
    CString ->                              -- name : TBasicType TUTF8
    CDouble ->                              -- value : TBasicType TDouble
    IO ()


levelBarAddOffsetValue ::
    (MonadIO m, LevelBarK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- name
    Double ->                               -- value
    m ()
levelBarAddOffsetValue _obj name value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    name' <- textToCString name
    let value' = realToFrac value
    gtk_level_bar_add_offset_value _obj' name' value'
    touchManagedPtr _obj
    freeMem name'
    return ()

-- method LevelBar::get_inverted
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "LevelBar", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "LevelBar", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "gtk_level_bar_get_inverted" gtk_level_bar_get_inverted :: 
    Ptr LevelBar ->                         -- _obj : TInterface "Gtk" "LevelBar"
    IO CInt


levelBarGetInverted ::
    (MonadIO m, LevelBarK a) =>
    a ->                                    -- _obj
    m Bool
levelBarGetInverted _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- gtk_level_bar_get_inverted _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method LevelBar::get_max_value
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "LevelBar", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "LevelBar", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TDouble
-- throws : False
-- Skip return : False

foreign import ccall "gtk_level_bar_get_max_value" gtk_level_bar_get_max_value :: 
    Ptr LevelBar ->                         -- _obj : TInterface "Gtk" "LevelBar"
    IO CDouble


levelBarGetMaxValue ::
    (MonadIO m, LevelBarK a) =>
    a ->                                    -- _obj
    m Double
levelBarGetMaxValue _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- gtk_level_bar_get_max_value _obj'
    let result' = realToFrac result
    touchManagedPtr _obj
    return result'

-- method LevelBar::get_min_value
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "LevelBar", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "LevelBar", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TDouble
-- throws : False
-- Skip return : False

foreign import ccall "gtk_level_bar_get_min_value" gtk_level_bar_get_min_value :: 
    Ptr LevelBar ->                         -- _obj : TInterface "Gtk" "LevelBar"
    IO CDouble


levelBarGetMinValue ::
    (MonadIO m, LevelBarK a) =>
    a ->                                    -- _obj
    m Double
levelBarGetMinValue _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- gtk_level_bar_get_min_value _obj'
    let result' = realToFrac result
    touchManagedPtr _obj
    return result'

-- method LevelBar::get_mode
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "LevelBar", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "LevelBar", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "Gtk" "LevelBarMode"
-- throws : False
-- Skip return : False

foreign import ccall "gtk_level_bar_get_mode" gtk_level_bar_get_mode :: 
    Ptr LevelBar ->                         -- _obj : TInterface "Gtk" "LevelBar"
    IO CUInt


levelBarGetMode ::
    (MonadIO m, LevelBarK a) =>
    a ->                                    -- _obj
    m LevelBarMode
levelBarGetMode _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- gtk_level_bar_get_mode _obj'
    let result' = (toEnum . fromIntegral) result
    touchManagedPtr _obj
    return result'

-- method LevelBar::get_offset_value
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "LevelBar", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "name", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = True, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TDouble, direction = DirectionOut, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferEverything}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "LevelBar", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "name", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = True, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "gtk_level_bar_get_offset_value" gtk_level_bar_get_offset_value :: 
    Ptr LevelBar ->                         -- _obj : TInterface "Gtk" "LevelBar"
    CString ->                              -- name : TBasicType TUTF8
    Ptr CDouble ->                          -- value : TBasicType TDouble
    IO CInt


levelBarGetOffsetValue ::
    (MonadIO m, LevelBarK a) =>
    a ->                                    -- _obj
    Maybe (T.Text) ->                       -- name
    m (Bool,Double)
levelBarGetOffsetValue _obj name = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    maybeName <- case name of
        Nothing -> return nullPtr
        Just jName -> do
            jName' <- textToCString jName
            return jName'
    value <- allocMem :: IO (Ptr CDouble)
    result <- gtk_level_bar_get_offset_value _obj' maybeName value
    let result' = (/= 0) result
    value' <- peek value
    let value'' = realToFrac value'
    touchManagedPtr _obj
    freeMem maybeName
    freeMem value
    return (result', value'')

-- method LevelBar::get_value
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "LevelBar", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "LevelBar", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TDouble
-- throws : False
-- Skip return : False

foreign import ccall "gtk_level_bar_get_value" gtk_level_bar_get_value :: 
    Ptr LevelBar ->                         -- _obj : TInterface "Gtk" "LevelBar"
    IO CDouble


levelBarGetValue ::
    (MonadIO m, LevelBarK a) =>
    a ->                                    -- _obj
    m Double
levelBarGetValue _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- gtk_level_bar_get_value _obj'
    let result' = realToFrac result
    touchManagedPtr _obj
    return result'

-- method LevelBar::remove_offset_value
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "LevelBar", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "name", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = True, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "LevelBar", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "name", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = True, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_level_bar_remove_offset_value" gtk_level_bar_remove_offset_value :: 
    Ptr LevelBar ->                         -- _obj : TInterface "Gtk" "LevelBar"
    CString ->                              -- name : TBasicType TUTF8
    IO ()


levelBarRemoveOffsetValue ::
    (MonadIO m, LevelBarK a) =>
    a ->                                    -- _obj
    Maybe (T.Text) ->                       -- name
    m ()
levelBarRemoveOffsetValue _obj name = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    maybeName <- case name of
        Nothing -> return nullPtr
        Just jName -> do
            jName' <- textToCString jName
            return jName'
    gtk_level_bar_remove_offset_value _obj' maybeName
    touchManagedPtr _obj
    freeMem maybeName
    return ()

-- method LevelBar::set_inverted
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "LevelBar", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "inverted", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "LevelBar", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "inverted", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_level_bar_set_inverted" gtk_level_bar_set_inverted :: 
    Ptr LevelBar ->                         -- _obj : TInterface "Gtk" "LevelBar"
    CInt ->                                 -- inverted : TBasicType TBoolean
    IO ()


levelBarSetInverted ::
    (MonadIO m, LevelBarK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- inverted
    m ()
levelBarSetInverted _obj inverted = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let inverted' = (fromIntegral . fromEnum) inverted
    gtk_level_bar_set_inverted _obj' inverted'
    touchManagedPtr _obj
    return ()

-- method LevelBar::set_max_value
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "LevelBar", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TDouble, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "LevelBar", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TDouble, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_level_bar_set_max_value" gtk_level_bar_set_max_value :: 
    Ptr LevelBar ->                         -- _obj : TInterface "Gtk" "LevelBar"
    CDouble ->                              -- value : TBasicType TDouble
    IO ()


levelBarSetMaxValue ::
    (MonadIO m, LevelBarK a) =>
    a ->                                    -- _obj
    Double ->                               -- value
    m ()
levelBarSetMaxValue _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = realToFrac value
    gtk_level_bar_set_max_value _obj' value'
    touchManagedPtr _obj
    return ()

-- method LevelBar::set_min_value
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "LevelBar", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TDouble, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "LevelBar", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TDouble, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_level_bar_set_min_value" gtk_level_bar_set_min_value :: 
    Ptr LevelBar ->                         -- _obj : TInterface "Gtk" "LevelBar"
    CDouble ->                              -- value : TBasicType TDouble
    IO ()


levelBarSetMinValue ::
    (MonadIO m, LevelBarK a) =>
    a ->                                    -- _obj
    Double ->                               -- value
    m ()
levelBarSetMinValue _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = realToFrac value
    gtk_level_bar_set_min_value _obj' value'
    touchManagedPtr _obj
    return ()

-- method LevelBar::set_mode
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "LevelBar", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "mode", argType = TInterface "Gtk" "LevelBarMode", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "LevelBar", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "mode", argType = TInterface "Gtk" "LevelBarMode", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_level_bar_set_mode" gtk_level_bar_set_mode :: 
    Ptr LevelBar ->                         -- _obj : TInterface "Gtk" "LevelBar"
    CUInt ->                                -- mode : TInterface "Gtk" "LevelBarMode"
    IO ()


levelBarSetMode ::
    (MonadIO m, LevelBarK a) =>
    a ->                                    -- _obj
    LevelBarMode ->                         -- mode
    m ()
levelBarSetMode _obj mode = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let mode' = (fromIntegral . fromEnum) mode
    gtk_level_bar_set_mode _obj' mode'
    touchManagedPtr _obj
    return ()

-- method LevelBar::set_value
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "LevelBar", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TDouble, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "LevelBar", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TDouble, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_level_bar_set_value" gtk_level_bar_set_value :: 
    Ptr LevelBar ->                         -- _obj : TInterface "Gtk" "LevelBar"
    CDouble ->                              -- value : TBasicType TDouble
    IO ()


levelBarSetValue ::
    (MonadIO m, LevelBarK a) =>
    a ->                                    -- _obj
    Double ->                               -- value
    m ()
levelBarSetValue _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = realToFrac value
    gtk_level_bar_set_value _obj' value'
    touchManagedPtr _obj
    return ()


