
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Gtk.Objects.ListBoxRow
    ( 

-- * Exported types
    ListBoxRow(..)                          ,
    ListBoxRowK                             ,
    toListBoxRow                            ,
    noListBoxRow                            ,


 -- * Methods
-- ** listBoxRowChanged
    listBoxRowChanged                       ,


-- ** listBoxRowGetActivatable
    listBoxRowGetActivatable                ,


-- ** listBoxRowGetHeader
    listBoxRowGetHeader                     ,


-- ** listBoxRowGetIndex
    listBoxRowGetIndex                      ,


-- ** listBoxRowGetSelectable
    listBoxRowGetSelectable                 ,


-- ** listBoxRowIsSelected
    listBoxRowIsSelected                    ,


-- ** listBoxRowNew
    listBoxRowNew                           ,


-- ** listBoxRowSetActivatable
    listBoxRowSetActivatable                ,


-- ** listBoxRowSetHeader
    listBoxRowSetHeader                     ,


-- ** listBoxRowSetSelectable
    listBoxRowSetSelectable                 ,




 -- * Properties
-- ** Activatable
    ListBoxRowActivatablePropertyInfo       ,
    constructListBoxRowActivatable          ,
    getListBoxRowActivatable                ,
    setListBoxRowActivatable                ,


-- ** Selectable
    ListBoxRowSelectablePropertyInfo        ,
    constructListBoxRowSelectable           ,
    getListBoxRowSelectable                 ,
    setListBoxRowSelectable                 ,




 -- * Signals
-- ** Activate
    ListBoxRowActivateCallback              ,
    ListBoxRowActivateCallbackC             ,
    ListBoxRowActivateSignalInfo            ,
    afterListBoxRowActivate                 ,
    listBoxRowActivateCallbackWrapper       ,
    listBoxRowActivateClosure               ,
    mkListBoxRowActivateCallback            ,
    noListBoxRowActivateCallback            ,
    onListBoxRowActivate                    ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Gtk.Types
import GI.Gtk.Callbacks
import qualified GI.Atk as Atk
import qualified GI.GObject as GObject

newtype ListBoxRow = ListBoxRow (ForeignPtr ListBoxRow)
foreign import ccall "gtk_list_box_row_get_type"
    c_gtk_list_box_row_get_type :: IO GType

type instance ParentTypes ListBoxRow = ListBoxRowParentTypes
type ListBoxRowParentTypes = '[Bin, Container, Widget, GObject.Object, Atk.ImplementorIface, Buildable]

instance GObject ListBoxRow where
    gobjectIsInitiallyUnowned _ = True
    gobjectType _ = c_gtk_list_box_row_get_type
    

class GObject o => ListBoxRowK o
instance (GObject o, IsDescendantOf ListBoxRow o) => ListBoxRowK o

toListBoxRow :: ListBoxRowK o => o -> IO ListBoxRow
toListBoxRow = unsafeCastTo ListBoxRow

noListBoxRow :: Maybe ListBoxRow
noListBoxRow = Nothing

-- signal ListBoxRow::activate
type ListBoxRowActivateCallback =
    IO ()

noListBoxRowActivateCallback :: Maybe ListBoxRowActivateCallback
noListBoxRowActivateCallback = Nothing

type ListBoxRowActivateCallbackC =
    Ptr () ->                               -- object
    Ptr () ->                               -- user_data
    IO ()

foreign import ccall "wrapper"
    mkListBoxRowActivateCallback :: ListBoxRowActivateCallbackC -> IO (FunPtr ListBoxRowActivateCallbackC)

listBoxRowActivateClosure :: ListBoxRowActivateCallback -> IO Closure
listBoxRowActivateClosure cb = newCClosure =<< mkListBoxRowActivateCallback wrapped
    where wrapped = listBoxRowActivateCallbackWrapper cb

listBoxRowActivateCallbackWrapper ::
    ListBoxRowActivateCallback ->
    Ptr () ->
    Ptr () ->
    IO ()
listBoxRowActivateCallbackWrapper _cb _ _ = do
    _cb 

onListBoxRowActivate :: (GObject a, MonadIO m) => a -> ListBoxRowActivateCallback -> m SignalHandlerId
onListBoxRowActivate obj cb = liftIO $ connectListBoxRowActivate obj cb SignalConnectBefore
afterListBoxRowActivate :: (GObject a, MonadIO m) => a -> ListBoxRowActivateCallback -> m SignalHandlerId
afterListBoxRowActivate obj cb = connectListBoxRowActivate obj cb SignalConnectAfter

connectListBoxRowActivate :: (GObject a, MonadIO m) =>
                             a -> ListBoxRowActivateCallback -> SignalConnectMode -> m SignalHandlerId
connectListBoxRowActivate obj cb after = liftIO $ do
    cb' <- mkListBoxRowActivateCallback (listBoxRowActivateCallbackWrapper cb)
    connectSignalFunPtr obj "activate" cb' after

-- VVV Prop "activatable"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getListBoxRowActivatable :: (MonadIO m, ListBoxRowK o) => o -> m Bool
getListBoxRowActivatable obj = liftIO $ getObjectPropertyBool obj "activatable"

setListBoxRowActivatable :: (MonadIO m, ListBoxRowK o) => o -> Bool -> m ()
setListBoxRowActivatable obj val = liftIO $ setObjectPropertyBool obj "activatable" val

constructListBoxRowActivatable :: Bool -> IO ([Char], GValue)
constructListBoxRowActivatable val = constructObjectPropertyBool "activatable" val

data ListBoxRowActivatablePropertyInfo
instance AttrInfo ListBoxRowActivatablePropertyInfo where
    type AttrAllowedOps ListBoxRowActivatablePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint ListBoxRowActivatablePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint ListBoxRowActivatablePropertyInfo = ListBoxRowK
    type AttrGetType ListBoxRowActivatablePropertyInfo = Bool
    type AttrLabel ListBoxRowActivatablePropertyInfo = "ListBoxRow::activatable"
    attrGet _ = getListBoxRowActivatable
    attrSet _ = setListBoxRowActivatable
    attrConstruct _ = constructListBoxRowActivatable

-- VVV Prop "selectable"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getListBoxRowSelectable :: (MonadIO m, ListBoxRowK o) => o -> m Bool
getListBoxRowSelectable obj = liftIO $ getObjectPropertyBool obj "selectable"

setListBoxRowSelectable :: (MonadIO m, ListBoxRowK o) => o -> Bool -> m ()
setListBoxRowSelectable obj val = liftIO $ setObjectPropertyBool obj "selectable" val

constructListBoxRowSelectable :: Bool -> IO ([Char], GValue)
constructListBoxRowSelectable val = constructObjectPropertyBool "selectable" val

data ListBoxRowSelectablePropertyInfo
instance AttrInfo ListBoxRowSelectablePropertyInfo where
    type AttrAllowedOps ListBoxRowSelectablePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint ListBoxRowSelectablePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint ListBoxRowSelectablePropertyInfo = ListBoxRowK
    type AttrGetType ListBoxRowSelectablePropertyInfo = Bool
    type AttrLabel ListBoxRowSelectablePropertyInfo = "ListBoxRow::selectable"
    attrGet _ = getListBoxRowSelectable
    attrSet _ = setListBoxRowSelectable
    attrConstruct _ = constructListBoxRowSelectable

type instance AttributeList ListBoxRow = ListBoxRowAttributeList
type ListBoxRowAttributeList = ('[ '("activatable", ListBoxRowActivatablePropertyInfo), '("app-paintable", WidgetAppPaintablePropertyInfo), '("border-width", ContainerBorderWidthPropertyInfo), '("can-default", WidgetCanDefaultPropertyInfo), '("can-focus", WidgetCanFocusPropertyInfo), '("child", ContainerChildPropertyInfo), '("composite-child", WidgetCompositeChildPropertyInfo), '("double-buffered", WidgetDoubleBufferedPropertyInfo), '("events", WidgetEventsPropertyInfo), '("expand", WidgetExpandPropertyInfo), '("halign", WidgetHalignPropertyInfo), '("has-default", WidgetHasDefaultPropertyInfo), '("has-focus", WidgetHasFocusPropertyInfo), '("has-tooltip", WidgetHasTooltipPropertyInfo), '("height-request", WidgetHeightRequestPropertyInfo), '("hexpand", WidgetHexpandPropertyInfo), '("hexpand-set", WidgetHexpandSetPropertyInfo), '("is-focus", WidgetIsFocusPropertyInfo), '("margin", WidgetMarginPropertyInfo), '("margin-bottom", WidgetMarginBottomPropertyInfo), '("margin-end", WidgetMarginEndPropertyInfo), '("margin-left", WidgetMarginLeftPropertyInfo), '("margin-right", WidgetMarginRightPropertyInfo), '("margin-start", WidgetMarginStartPropertyInfo), '("margin-top", WidgetMarginTopPropertyInfo), '("name", WidgetNamePropertyInfo), '("no-show-all", WidgetNoShowAllPropertyInfo), '("opacity", WidgetOpacityPropertyInfo), '("parent", WidgetParentPropertyInfo), '("receives-default", WidgetReceivesDefaultPropertyInfo), '("resize-mode", ContainerResizeModePropertyInfo), '("scale-factor", WidgetScaleFactorPropertyInfo), '("selectable", ListBoxRowSelectablePropertyInfo), '("sensitive", WidgetSensitivePropertyInfo), '("style", WidgetStylePropertyInfo), '("tooltip-markup", WidgetTooltipMarkupPropertyInfo), '("tooltip-text", WidgetTooltipTextPropertyInfo), '("valign", WidgetValignPropertyInfo), '("vexpand", WidgetVexpandPropertyInfo), '("vexpand-set", WidgetVexpandSetPropertyInfo), '("visible", WidgetVisiblePropertyInfo), '("width-request", WidgetWidthRequestPropertyInfo), '("window", WidgetWindowPropertyInfo)] :: [(Symbol, *)])

data ListBoxRowActivateSignalInfo
instance SignalInfo ListBoxRowActivateSignalInfo where
    type HaskellCallbackType ListBoxRowActivateSignalInfo = ListBoxRowActivateCallback
    connectSignal _ = connectListBoxRowActivate

type instance SignalList ListBoxRow = ListBoxRowSignalList
type ListBoxRowSignalList = ('[ '("accel-closures-changed", WidgetAccelClosuresChangedSignalInfo), '("activate", ListBoxRowActivateSignalInfo), '("add", ContainerAddSignalInfo), '("button-press-event", WidgetButtonPressEventSignalInfo), '("button-release-event", WidgetButtonReleaseEventSignalInfo), '("can-activate-accel", WidgetCanActivateAccelSignalInfo), '("check-resize", ContainerCheckResizeSignalInfo), '("child-notify", WidgetChildNotifySignalInfo), '("composited-changed", WidgetCompositedChangedSignalInfo), '("configure-event", WidgetConfigureEventSignalInfo), '("damage-event", WidgetDamageEventSignalInfo), '("delete-event", WidgetDeleteEventSignalInfo), '("destroy", WidgetDestroySignalInfo), '("destroy-event", WidgetDestroyEventSignalInfo), '("direction-changed", WidgetDirectionChangedSignalInfo), '("drag-begin", WidgetDragBeginSignalInfo), '("drag-data-delete", WidgetDragDataDeleteSignalInfo), '("drag-data-get", WidgetDragDataGetSignalInfo), '("drag-data-received", WidgetDragDataReceivedSignalInfo), '("drag-drop", WidgetDragDropSignalInfo), '("drag-end", WidgetDragEndSignalInfo), '("drag-failed", WidgetDragFailedSignalInfo), '("drag-leave", WidgetDragLeaveSignalInfo), '("drag-motion", WidgetDragMotionSignalInfo), '("draw", WidgetDrawSignalInfo), '("enter-notify-event", WidgetEnterNotifyEventSignalInfo), '("event", WidgetEventSignalInfo), '("event-after", WidgetEventAfterSignalInfo), '("focus", WidgetFocusSignalInfo), '("focus-in-event", WidgetFocusInEventSignalInfo), '("focus-out-event", WidgetFocusOutEventSignalInfo), '("grab-broken-event", WidgetGrabBrokenEventSignalInfo), '("grab-focus", WidgetGrabFocusSignalInfo), '("grab-notify", WidgetGrabNotifySignalInfo), '("hide", WidgetHideSignalInfo), '("hierarchy-changed", WidgetHierarchyChangedSignalInfo), '("key-press-event", WidgetKeyPressEventSignalInfo), '("key-release-event", WidgetKeyReleaseEventSignalInfo), '("keynav-failed", WidgetKeynavFailedSignalInfo), '("leave-notify-event", WidgetLeaveNotifyEventSignalInfo), '("map", WidgetMapSignalInfo), '("map-event", WidgetMapEventSignalInfo), '("mnemonic-activate", WidgetMnemonicActivateSignalInfo), '("motion-notify-event", WidgetMotionNotifyEventSignalInfo), '("move-focus", WidgetMoveFocusSignalInfo), '("notify", GObject.ObjectNotifySignalInfo), '("parent-set", WidgetParentSetSignalInfo), '("popup-menu", WidgetPopupMenuSignalInfo), '("property-notify-event", WidgetPropertyNotifyEventSignalInfo), '("proximity-in-event", WidgetProximityInEventSignalInfo), '("proximity-out-event", WidgetProximityOutEventSignalInfo), '("query-tooltip", WidgetQueryTooltipSignalInfo), '("realize", WidgetRealizeSignalInfo), '("remove", ContainerRemoveSignalInfo), '("screen-changed", WidgetScreenChangedSignalInfo), '("scroll-event", WidgetScrollEventSignalInfo), '("selection-clear-event", WidgetSelectionClearEventSignalInfo), '("selection-get", WidgetSelectionGetSignalInfo), '("selection-notify-event", WidgetSelectionNotifyEventSignalInfo), '("selection-received", WidgetSelectionReceivedSignalInfo), '("selection-request-event", WidgetSelectionRequestEventSignalInfo), '("set-focus-child", ContainerSetFocusChildSignalInfo), '("show", WidgetShowSignalInfo), '("show-help", WidgetShowHelpSignalInfo), '("size-allocate", WidgetSizeAllocateSignalInfo), '("state-changed", WidgetStateChangedSignalInfo), '("state-flags-changed", WidgetStateFlagsChangedSignalInfo), '("style-set", WidgetStyleSetSignalInfo), '("style-updated", WidgetStyleUpdatedSignalInfo), '("touch-event", WidgetTouchEventSignalInfo), '("unmap", WidgetUnmapSignalInfo), '("unmap-event", WidgetUnmapEventSignalInfo), '("unrealize", WidgetUnrealizeSignalInfo), '("visibility-notify-event", WidgetVisibilityNotifyEventSignalInfo), '("window-state-event", WidgetWindowStateEventSignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method ListBoxRow::new
-- method type : Constructor
-- Args : []
-- Lengths : []
-- hInArgs : []
-- returnType : TInterface "Gtk" "ListBoxRow"
-- throws : False
-- Skip return : False

foreign import ccall "gtk_list_box_row_new" gtk_list_box_row_new :: 
    IO (Ptr ListBoxRow)


listBoxRowNew ::
    (MonadIO m) =>
    m ListBoxRow
listBoxRowNew  = liftIO $ do
    result <- gtk_list_box_row_new
    checkUnexpectedReturnNULL "gtk_list_box_row_new" result
    result' <- (newObject ListBoxRow) result
    return result'

-- method ListBoxRow::changed
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "ListBoxRow", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "ListBoxRow", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_list_box_row_changed" gtk_list_box_row_changed :: 
    Ptr ListBoxRow ->                       -- _obj : TInterface "Gtk" "ListBoxRow"
    IO ()


listBoxRowChanged ::
    (MonadIO m, ListBoxRowK a) =>
    a ->                                    -- _obj
    m ()
listBoxRowChanged _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    gtk_list_box_row_changed _obj'
    touchManagedPtr _obj
    return ()

-- method ListBoxRow::get_activatable
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "ListBoxRow", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "ListBoxRow", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "gtk_list_box_row_get_activatable" gtk_list_box_row_get_activatable :: 
    Ptr ListBoxRow ->                       -- _obj : TInterface "Gtk" "ListBoxRow"
    IO CInt


listBoxRowGetActivatable ::
    (MonadIO m, ListBoxRowK a) =>
    a ->                                    -- _obj
    m Bool
listBoxRowGetActivatable _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- gtk_list_box_row_get_activatable _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method ListBoxRow::get_header
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "ListBoxRow", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "ListBoxRow", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "Gtk" "Widget"
-- throws : False
-- Skip return : False

foreign import ccall "gtk_list_box_row_get_header" gtk_list_box_row_get_header :: 
    Ptr ListBoxRow ->                       -- _obj : TInterface "Gtk" "ListBoxRow"
    IO (Ptr Widget)


listBoxRowGetHeader ::
    (MonadIO m, ListBoxRowK a) =>
    a ->                                    -- _obj
    m Widget
listBoxRowGetHeader _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- gtk_list_box_row_get_header _obj'
    checkUnexpectedReturnNULL "gtk_list_box_row_get_header" result
    result' <- (newObject Widget) result
    touchManagedPtr _obj
    return result'

-- method ListBoxRow::get_index
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "ListBoxRow", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "ListBoxRow", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TInt32
-- throws : False
-- Skip return : False

foreign import ccall "gtk_list_box_row_get_index" gtk_list_box_row_get_index :: 
    Ptr ListBoxRow ->                       -- _obj : TInterface "Gtk" "ListBoxRow"
    IO Int32


listBoxRowGetIndex ::
    (MonadIO m, ListBoxRowK a) =>
    a ->                                    -- _obj
    m Int32
listBoxRowGetIndex _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- gtk_list_box_row_get_index _obj'
    touchManagedPtr _obj
    return result

-- method ListBoxRow::get_selectable
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "ListBoxRow", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "ListBoxRow", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "gtk_list_box_row_get_selectable" gtk_list_box_row_get_selectable :: 
    Ptr ListBoxRow ->                       -- _obj : TInterface "Gtk" "ListBoxRow"
    IO CInt


listBoxRowGetSelectable ::
    (MonadIO m, ListBoxRowK a) =>
    a ->                                    -- _obj
    m Bool
listBoxRowGetSelectable _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- gtk_list_box_row_get_selectable _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method ListBoxRow::is_selected
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "ListBoxRow", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "ListBoxRow", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "gtk_list_box_row_is_selected" gtk_list_box_row_is_selected :: 
    Ptr ListBoxRow ->                       -- _obj : TInterface "Gtk" "ListBoxRow"
    IO CInt


listBoxRowIsSelected ::
    (MonadIO m, ListBoxRowK a) =>
    a ->                                    -- _obj
    m Bool
listBoxRowIsSelected _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- gtk_list_box_row_is_selected _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method ListBoxRow::set_activatable
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "ListBoxRow", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "activatable", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "ListBoxRow", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "activatable", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_list_box_row_set_activatable" gtk_list_box_row_set_activatable :: 
    Ptr ListBoxRow ->                       -- _obj : TInterface "Gtk" "ListBoxRow"
    CInt ->                                 -- activatable : TBasicType TBoolean
    IO ()


listBoxRowSetActivatable ::
    (MonadIO m, ListBoxRowK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- activatable
    m ()
listBoxRowSetActivatable _obj activatable = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let activatable' = (fromIntegral . fromEnum) activatable
    gtk_list_box_row_set_activatable _obj' activatable'
    touchManagedPtr _obj
    return ()

-- method ListBoxRow::set_header
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "ListBoxRow", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "header", argType = TInterface "Gtk" "Widget", direction = DirectionIn, mayBeNull = True, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "ListBoxRow", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "header", argType = TInterface "Gtk" "Widget", direction = DirectionIn, mayBeNull = True, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_list_box_row_set_header" gtk_list_box_row_set_header :: 
    Ptr ListBoxRow ->                       -- _obj : TInterface "Gtk" "ListBoxRow"
    Ptr Widget ->                           -- header : TInterface "Gtk" "Widget"
    IO ()


listBoxRowSetHeader ::
    (MonadIO m, ListBoxRowK a, WidgetK b) =>
    a ->                                    -- _obj
    Maybe (b) ->                            -- header
    m ()
listBoxRowSetHeader _obj header = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    maybeHeader <- case header of
        Nothing -> return nullPtr
        Just jHeader -> do
            let jHeader' = unsafeManagedPtrCastPtr jHeader
            return jHeader'
    gtk_list_box_row_set_header _obj' maybeHeader
    touchManagedPtr _obj
    whenJust header touchManagedPtr
    return ()

-- method ListBoxRow::set_selectable
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "ListBoxRow", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "selectable", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "ListBoxRow", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "selectable", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_list_box_row_set_selectable" gtk_list_box_row_set_selectable :: 
    Ptr ListBoxRow ->                       -- _obj : TInterface "Gtk" "ListBoxRow"
    CInt ->                                 -- selectable : TBasicType TBoolean
    IO ()


listBoxRowSetSelectable ::
    (MonadIO m, ListBoxRowK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- selectable
    m ()
listBoxRowSetSelectable _obj selectable = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let selectable' = (fromIntegral . fromEnum) selectable
    gtk_list_box_row_set_selectable _obj' selectable'
    touchManagedPtr _obj
    return ()


