
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Gtk.Objects.ModelButton
    ( 

-- * Exported types
    ModelButton(..)                         ,
    ModelButtonK                            ,
    toModelButton                           ,
    noModelButton                           ,


 -- * Methods
-- ** modelButtonNew
    modelButtonNew                          ,




 -- * Properties
-- ** Active
    ModelButtonActivePropertyInfo           ,
    constructModelButtonActive              ,
    getModelButtonActive                    ,
    setModelButtonActive                    ,


-- ** Centered
    ModelButtonCenteredPropertyInfo         ,
    constructModelButtonCentered            ,
    getModelButtonCentered                  ,
    setModelButtonCentered                  ,


-- ** Icon
    ModelButtonIconPropertyInfo             ,
    constructModelButtonIcon                ,
    getModelButtonIcon                      ,
    setModelButtonIcon                      ,


-- ** Iconic
    ModelButtonIconicPropertyInfo           ,
    constructModelButtonIconic              ,
    getModelButtonIconic                    ,
    setModelButtonIconic                    ,


-- ** Inverted
    ModelButtonInvertedPropertyInfo         ,
    constructModelButtonInverted            ,
    getModelButtonInverted                  ,
    setModelButtonInverted                  ,


-- ** MenuName
    ModelButtonMenuNamePropertyInfo         ,
    constructModelButtonMenuName            ,
    getModelButtonMenuName                  ,
    setModelButtonMenuName                  ,


-- ** Role
    ModelButtonRolePropertyInfo             ,
    constructModelButtonRole                ,
    getModelButtonRole                      ,
    setModelButtonRole                      ,


-- ** Text
    ModelButtonTextPropertyInfo             ,
    constructModelButtonText                ,
    getModelButtonText                      ,
    setModelButtonText                      ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Gtk.Types
import GI.Gtk.Callbacks
import qualified GI.Atk as Atk
import qualified GI.GObject as GObject
import qualified GI.Gio as Gio

newtype ModelButton = ModelButton (ForeignPtr ModelButton)
foreign import ccall "gtk_model_button_get_type"
    c_gtk_model_button_get_type :: IO GType

type instance ParentTypes ModelButton = ModelButtonParentTypes
type ModelButtonParentTypes = '[Button, Bin, Container, Widget, GObject.Object, Atk.ImplementorIface, Actionable, Activatable, Buildable]

instance GObject ModelButton where
    gobjectIsInitiallyUnowned _ = True
    gobjectType _ = c_gtk_model_button_get_type
    

class GObject o => ModelButtonK o
instance (GObject o, IsDescendantOf ModelButton o) => ModelButtonK o

toModelButton :: ModelButtonK o => o -> IO ModelButton
toModelButton = unsafeCastTo ModelButton

noModelButton :: Maybe ModelButton
noModelButton = Nothing

-- VVV Prop "active"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getModelButtonActive :: (MonadIO m, ModelButtonK o) => o -> m Bool
getModelButtonActive obj = liftIO $ getObjectPropertyBool obj "active"

setModelButtonActive :: (MonadIO m, ModelButtonK o) => o -> Bool -> m ()
setModelButtonActive obj val = liftIO $ setObjectPropertyBool obj "active" val

constructModelButtonActive :: Bool -> IO ([Char], GValue)
constructModelButtonActive val = constructObjectPropertyBool "active" val

data ModelButtonActivePropertyInfo
instance AttrInfo ModelButtonActivePropertyInfo where
    type AttrAllowedOps ModelButtonActivePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint ModelButtonActivePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint ModelButtonActivePropertyInfo = ModelButtonK
    type AttrGetType ModelButtonActivePropertyInfo = Bool
    type AttrLabel ModelButtonActivePropertyInfo = "ModelButton::active"
    attrGet _ = getModelButtonActive
    attrSet _ = setModelButtonActive
    attrConstruct _ = constructModelButtonActive

-- VVV Prop "centered"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getModelButtonCentered :: (MonadIO m, ModelButtonK o) => o -> m Bool
getModelButtonCentered obj = liftIO $ getObjectPropertyBool obj "centered"

setModelButtonCentered :: (MonadIO m, ModelButtonK o) => o -> Bool -> m ()
setModelButtonCentered obj val = liftIO $ setObjectPropertyBool obj "centered" val

constructModelButtonCentered :: Bool -> IO ([Char], GValue)
constructModelButtonCentered val = constructObjectPropertyBool "centered" val

data ModelButtonCenteredPropertyInfo
instance AttrInfo ModelButtonCenteredPropertyInfo where
    type AttrAllowedOps ModelButtonCenteredPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint ModelButtonCenteredPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint ModelButtonCenteredPropertyInfo = ModelButtonK
    type AttrGetType ModelButtonCenteredPropertyInfo = Bool
    type AttrLabel ModelButtonCenteredPropertyInfo = "ModelButton::centered"
    attrGet _ = getModelButtonCentered
    attrSet _ = setModelButtonCentered
    attrConstruct _ = constructModelButtonCentered

-- VVV Prop "icon"
   -- Type: TInterface "Gio" "Icon"
   -- Flags: [PropertyReadable,PropertyWritable]

getModelButtonIcon :: (MonadIO m, ModelButtonK o) => o -> m Gio.Icon
getModelButtonIcon obj = liftIO $ getObjectPropertyObject obj "icon" Gio.Icon

setModelButtonIcon :: (MonadIO m, ModelButtonK o, Gio.IconK a) => o -> a -> m ()
setModelButtonIcon obj val = liftIO $ setObjectPropertyObject obj "icon" val

constructModelButtonIcon :: (Gio.IconK a) => a -> IO ([Char], GValue)
constructModelButtonIcon val = constructObjectPropertyObject "icon" val

data ModelButtonIconPropertyInfo
instance AttrInfo ModelButtonIconPropertyInfo where
    type AttrAllowedOps ModelButtonIconPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint ModelButtonIconPropertyInfo = Gio.IconK
    type AttrBaseTypeConstraint ModelButtonIconPropertyInfo = ModelButtonK
    type AttrGetType ModelButtonIconPropertyInfo = Gio.Icon
    type AttrLabel ModelButtonIconPropertyInfo = "ModelButton::icon"
    attrGet _ = getModelButtonIcon
    attrSet _ = setModelButtonIcon
    attrConstruct _ = constructModelButtonIcon

-- VVV Prop "iconic"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getModelButtonIconic :: (MonadIO m, ModelButtonK o) => o -> m Bool
getModelButtonIconic obj = liftIO $ getObjectPropertyBool obj "iconic"

setModelButtonIconic :: (MonadIO m, ModelButtonK o) => o -> Bool -> m ()
setModelButtonIconic obj val = liftIO $ setObjectPropertyBool obj "iconic" val

constructModelButtonIconic :: Bool -> IO ([Char], GValue)
constructModelButtonIconic val = constructObjectPropertyBool "iconic" val

data ModelButtonIconicPropertyInfo
instance AttrInfo ModelButtonIconicPropertyInfo where
    type AttrAllowedOps ModelButtonIconicPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint ModelButtonIconicPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint ModelButtonIconicPropertyInfo = ModelButtonK
    type AttrGetType ModelButtonIconicPropertyInfo = Bool
    type AttrLabel ModelButtonIconicPropertyInfo = "ModelButton::iconic"
    attrGet _ = getModelButtonIconic
    attrSet _ = setModelButtonIconic
    attrConstruct _ = constructModelButtonIconic

-- VVV Prop "inverted"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getModelButtonInverted :: (MonadIO m, ModelButtonK o) => o -> m Bool
getModelButtonInverted obj = liftIO $ getObjectPropertyBool obj "inverted"

setModelButtonInverted :: (MonadIO m, ModelButtonK o) => o -> Bool -> m ()
setModelButtonInverted obj val = liftIO $ setObjectPropertyBool obj "inverted" val

constructModelButtonInverted :: Bool -> IO ([Char], GValue)
constructModelButtonInverted val = constructObjectPropertyBool "inverted" val

data ModelButtonInvertedPropertyInfo
instance AttrInfo ModelButtonInvertedPropertyInfo where
    type AttrAllowedOps ModelButtonInvertedPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint ModelButtonInvertedPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint ModelButtonInvertedPropertyInfo = ModelButtonK
    type AttrGetType ModelButtonInvertedPropertyInfo = Bool
    type AttrLabel ModelButtonInvertedPropertyInfo = "ModelButton::inverted"
    attrGet _ = getModelButtonInverted
    attrSet _ = setModelButtonInverted
    attrConstruct _ = constructModelButtonInverted

-- VVV Prop "menu-name"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getModelButtonMenuName :: (MonadIO m, ModelButtonK o) => o -> m T.Text
getModelButtonMenuName obj = liftIO $ getObjectPropertyString obj "menu-name"

setModelButtonMenuName :: (MonadIO m, ModelButtonK o) => o -> T.Text -> m ()
setModelButtonMenuName obj val = liftIO $ setObjectPropertyString obj "menu-name" val

constructModelButtonMenuName :: T.Text -> IO ([Char], GValue)
constructModelButtonMenuName val = constructObjectPropertyString "menu-name" val

data ModelButtonMenuNamePropertyInfo
instance AttrInfo ModelButtonMenuNamePropertyInfo where
    type AttrAllowedOps ModelButtonMenuNamePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint ModelButtonMenuNamePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint ModelButtonMenuNamePropertyInfo = ModelButtonK
    type AttrGetType ModelButtonMenuNamePropertyInfo = T.Text
    type AttrLabel ModelButtonMenuNamePropertyInfo = "ModelButton::menu-name"
    attrGet _ = getModelButtonMenuName
    attrSet _ = setModelButtonMenuName
    attrConstruct _ = constructModelButtonMenuName

-- VVV Prop "role"
   -- Type: TInterface "Gtk" "ButtonRole"
   -- Flags: [PropertyReadable,PropertyWritable]

getModelButtonRole :: (MonadIO m, ModelButtonK o) => o -> m ButtonRole
getModelButtonRole obj = liftIO $ getObjectPropertyEnum obj "role"

setModelButtonRole :: (MonadIO m, ModelButtonK o) => o -> ButtonRole -> m ()
setModelButtonRole obj val = liftIO $ setObjectPropertyEnum obj "role" val

constructModelButtonRole :: ButtonRole -> IO ([Char], GValue)
constructModelButtonRole val = constructObjectPropertyEnum "role" val

data ModelButtonRolePropertyInfo
instance AttrInfo ModelButtonRolePropertyInfo where
    type AttrAllowedOps ModelButtonRolePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint ModelButtonRolePropertyInfo = (~) ButtonRole
    type AttrBaseTypeConstraint ModelButtonRolePropertyInfo = ModelButtonK
    type AttrGetType ModelButtonRolePropertyInfo = ButtonRole
    type AttrLabel ModelButtonRolePropertyInfo = "ModelButton::role"
    attrGet _ = getModelButtonRole
    attrSet _ = setModelButtonRole
    attrConstruct _ = constructModelButtonRole

-- VVV Prop "text"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getModelButtonText :: (MonadIO m, ModelButtonK o) => o -> m T.Text
getModelButtonText obj = liftIO $ getObjectPropertyString obj "text"

setModelButtonText :: (MonadIO m, ModelButtonK o) => o -> T.Text -> m ()
setModelButtonText obj val = liftIO $ setObjectPropertyString obj "text" val

constructModelButtonText :: T.Text -> IO ([Char], GValue)
constructModelButtonText val = constructObjectPropertyString "text" val

data ModelButtonTextPropertyInfo
instance AttrInfo ModelButtonTextPropertyInfo where
    type AttrAllowedOps ModelButtonTextPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint ModelButtonTextPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint ModelButtonTextPropertyInfo = ModelButtonK
    type AttrGetType ModelButtonTextPropertyInfo = T.Text
    type AttrLabel ModelButtonTextPropertyInfo = "ModelButton::text"
    attrGet _ = getModelButtonText
    attrSet _ = setModelButtonText
    attrConstruct _ = constructModelButtonText

type instance AttributeList ModelButton = ModelButtonAttributeList
type ModelButtonAttributeList = ('[ '("action-name", ActionableActionNamePropertyInfo), '("action-target", ActionableActionTargetPropertyInfo), '("active", ModelButtonActivePropertyInfo), '("always-show-image", ButtonAlwaysShowImagePropertyInfo), '("app-paintable", WidgetAppPaintablePropertyInfo), '("border-width", ContainerBorderWidthPropertyInfo), '("can-default", WidgetCanDefaultPropertyInfo), '("can-focus", WidgetCanFocusPropertyInfo), '("centered", ModelButtonCenteredPropertyInfo), '("child", ContainerChildPropertyInfo), '("composite-child", WidgetCompositeChildPropertyInfo), '("double-buffered", WidgetDoubleBufferedPropertyInfo), '("events", WidgetEventsPropertyInfo), '("expand", WidgetExpandPropertyInfo), '("focus-on-click", ButtonFocusOnClickPropertyInfo), '("halign", WidgetHalignPropertyInfo), '("has-default", WidgetHasDefaultPropertyInfo), '("has-focus", WidgetHasFocusPropertyInfo), '("has-tooltip", WidgetHasTooltipPropertyInfo), '("height-request", WidgetHeightRequestPropertyInfo), '("hexpand", WidgetHexpandPropertyInfo), '("hexpand-set", WidgetHexpandSetPropertyInfo), '("icon", ModelButtonIconPropertyInfo), '("iconic", ModelButtonIconicPropertyInfo), '("image", ButtonImagePropertyInfo), '("image-position", ButtonImagePositionPropertyInfo), '("inverted", ModelButtonInvertedPropertyInfo), '("is-focus", WidgetIsFocusPropertyInfo), '("label", ButtonLabelPropertyInfo), '("margin", WidgetMarginPropertyInfo), '("margin-bottom", WidgetMarginBottomPropertyInfo), '("margin-end", WidgetMarginEndPropertyInfo), '("margin-left", WidgetMarginLeftPropertyInfo), '("margin-right", WidgetMarginRightPropertyInfo), '("margin-start", WidgetMarginStartPropertyInfo), '("margin-top", WidgetMarginTopPropertyInfo), '("menu-name", ModelButtonMenuNamePropertyInfo), '("name", WidgetNamePropertyInfo), '("no-show-all", WidgetNoShowAllPropertyInfo), '("opacity", WidgetOpacityPropertyInfo), '("parent", WidgetParentPropertyInfo), '("receives-default", WidgetReceivesDefaultPropertyInfo), '("related-action", ActivatableRelatedActionPropertyInfo), '("relief", ButtonReliefPropertyInfo), '("resize-mode", ContainerResizeModePropertyInfo), '("role", ModelButtonRolePropertyInfo), '("scale-factor", WidgetScaleFactorPropertyInfo), '("sensitive", WidgetSensitivePropertyInfo), '("style", WidgetStylePropertyInfo), '("text", ModelButtonTextPropertyInfo), '("tooltip-markup", WidgetTooltipMarkupPropertyInfo), '("tooltip-text", WidgetTooltipTextPropertyInfo), '("use-action-appearance", ActivatableUseActionAppearancePropertyInfo), '("use-stock", ButtonUseStockPropertyInfo), '("use-underline", ButtonUseUnderlinePropertyInfo), '("valign", WidgetValignPropertyInfo), '("vexpand", WidgetVexpandPropertyInfo), '("vexpand-set", WidgetVexpandSetPropertyInfo), '("visible", WidgetVisiblePropertyInfo), '("width-request", WidgetWidthRequestPropertyInfo), '("window", WidgetWindowPropertyInfo), '("xalign", ButtonXalignPropertyInfo), '("yalign", ButtonYalignPropertyInfo)] :: [(Symbol, *)])

type instance SignalList ModelButton = ModelButtonSignalList
type ModelButtonSignalList = ('[ '("accel-closures-changed", WidgetAccelClosuresChangedSignalInfo), '("activate", ButtonActivateSignalInfo), '("add", ContainerAddSignalInfo), '("button-press-event", WidgetButtonPressEventSignalInfo), '("button-release-event", WidgetButtonReleaseEventSignalInfo), '("can-activate-accel", WidgetCanActivateAccelSignalInfo), '("check-resize", ContainerCheckResizeSignalInfo), '("child-notify", WidgetChildNotifySignalInfo), '("clicked", ButtonClickedSignalInfo), '("composited-changed", WidgetCompositedChangedSignalInfo), '("configure-event", WidgetConfigureEventSignalInfo), '("damage-event", WidgetDamageEventSignalInfo), '("delete-event", WidgetDeleteEventSignalInfo), '("destroy", WidgetDestroySignalInfo), '("destroy-event", WidgetDestroyEventSignalInfo), '("direction-changed", WidgetDirectionChangedSignalInfo), '("drag-begin", WidgetDragBeginSignalInfo), '("drag-data-delete", WidgetDragDataDeleteSignalInfo), '("drag-data-get", WidgetDragDataGetSignalInfo), '("drag-data-received", WidgetDragDataReceivedSignalInfo), '("drag-drop", WidgetDragDropSignalInfo), '("drag-end", WidgetDragEndSignalInfo), '("drag-failed", WidgetDragFailedSignalInfo), '("drag-leave", WidgetDragLeaveSignalInfo), '("drag-motion", WidgetDragMotionSignalInfo), '("draw", WidgetDrawSignalInfo), '("enter", ButtonEnterSignalInfo), '("enter-notify-event", WidgetEnterNotifyEventSignalInfo), '("event", WidgetEventSignalInfo), '("event-after", WidgetEventAfterSignalInfo), '("focus", WidgetFocusSignalInfo), '("focus-in-event", WidgetFocusInEventSignalInfo), '("focus-out-event", WidgetFocusOutEventSignalInfo), '("grab-broken-event", WidgetGrabBrokenEventSignalInfo), '("grab-focus", WidgetGrabFocusSignalInfo), '("grab-notify", WidgetGrabNotifySignalInfo), '("hide", WidgetHideSignalInfo), '("hierarchy-changed", WidgetHierarchyChangedSignalInfo), '("key-press-event", WidgetKeyPressEventSignalInfo), '("key-release-event", WidgetKeyReleaseEventSignalInfo), '("keynav-failed", WidgetKeynavFailedSignalInfo), '("leave", ButtonLeaveSignalInfo), '("leave-notify-event", WidgetLeaveNotifyEventSignalInfo), '("map", WidgetMapSignalInfo), '("map-event", WidgetMapEventSignalInfo), '("mnemonic-activate", WidgetMnemonicActivateSignalInfo), '("motion-notify-event", WidgetMotionNotifyEventSignalInfo), '("move-focus", WidgetMoveFocusSignalInfo), '("notify", GObject.ObjectNotifySignalInfo), '("parent-set", WidgetParentSetSignalInfo), '("popup-menu", WidgetPopupMenuSignalInfo), '("pressed", ButtonPressedSignalInfo), '("property-notify-event", WidgetPropertyNotifyEventSignalInfo), '("proximity-in-event", WidgetProximityInEventSignalInfo), '("proximity-out-event", WidgetProximityOutEventSignalInfo), '("query-tooltip", WidgetQueryTooltipSignalInfo), '("realize", WidgetRealizeSignalInfo), '("released", ButtonReleasedSignalInfo), '("remove", ContainerRemoveSignalInfo), '("screen-changed", WidgetScreenChangedSignalInfo), '("scroll-event", WidgetScrollEventSignalInfo), '("selection-clear-event", WidgetSelectionClearEventSignalInfo), '("selection-get", WidgetSelectionGetSignalInfo), '("selection-notify-event", WidgetSelectionNotifyEventSignalInfo), '("selection-received", WidgetSelectionReceivedSignalInfo), '("selection-request-event", WidgetSelectionRequestEventSignalInfo), '("set-focus-child", ContainerSetFocusChildSignalInfo), '("show", WidgetShowSignalInfo), '("show-help", WidgetShowHelpSignalInfo), '("size-allocate", WidgetSizeAllocateSignalInfo), '("state-changed", WidgetStateChangedSignalInfo), '("state-flags-changed", WidgetStateFlagsChangedSignalInfo), '("style-set", WidgetStyleSetSignalInfo), '("style-updated", WidgetStyleUpdatedSignalInfo), '("touch-event", WidgetTouchEventSignalInfo), '("unmap", WidgetUnmapSignalInfo), '("unmap-event", WidgetUnmapEventSignalInfo), '("unrealize", WidgetUnrealizeSignalInfo), '("visibility-notify-event", WidgetVisibilityNotifyEventSignalInfo), '("window-state-event", WidgetWindowStateEventSignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method ModelButton::new
-- method type : Constructor
-- Args : []
-- Lengths : []
-- hInArgs : []
-- returnType : TInterface "Gtk" "ModelButton"
-- throws : False
-- Skip return : False

foreign import ccall "gtk_model_button_new" gtk_model_button_new :: 
    IO (Ptr ModelButton)


modelButtonNew ::
    (MonadIO m) =>
    m ModelButton
modelButtonNew  = liftIO $ do
    result <- gtk_model_button_new
    checkUnexpectedReturnNULL "gtk_model_button_new" result
    result' <- (newObject ModelButton) result
    return result'


