
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Gtk.Objects.NotebookPageAccessible
    ( 

-- * Exported types
    NotebookPageAccessible(..)              ,
    NotebookPageAccessibleK                 ,
    toNotebookPageAccessible                ,
    noNotebookPageAccessible                ,


 -- * Methods
-- ** notebookPageAccessibleInvalidate
    notebookPageAccessibleInvalidate        ,


-- ** notebookPageAccessibleNew
    notebookPageAccessibleNew               ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Gtk.Types
import GI.Gtk.Callbacks
import qualified GI.Atk as Atk
import qualified GI.GObject as GObject

newtype NotebookPageAccessible = NotebookPageAccessible (ForeignPtr NotebookPageAccessible)
foreign import ccall "gtk_notebook_page_accessible_get_type"
    c_gtk_notebook_page_accessible_get_type :: IO GType

type instance ParentTypes NotebookPageAccessible = NotebookPageAccessibleParentTypes
type NotebookPageAccessibleParentTypes = '[Atk.Object, GObject.Object, Atk.Component]

instance GObject NotebookPageAccessible where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_gtk_notebook_page_accessible_get_type
    

class GObject o => NotebookPageAccessibleK o
instance (GObject o, IsDescendantOf NotebookPageAccessible o) => NotebookPageAccessibleK o

toNotebookPageAccessible :: NotebookPageAccessibleK o => o -> IO NotebookPageAccessible
toNotebookPageAccessible = unsafeCastTo NotebookPageAccessible

noNotebookPageAccessible :: Maybe NotebookPageAccessible
noNotebookPageAccessible = Nothing

type instance AttributeList NotebookPageAccessible = NotebookPageAccessibleAttributeList
type NotebookPageAccessibleAttributeList = ('[ '("accessible-component-layer", Atk.ObjectAccessibleComponentLayerPropertyInfo), '("accessible-component-mdi-zorder", Atk.ObjectAccessibleComponentMdiZorderPropertyInfo), '("accessible-description", Atk.ObjectAccessibleDescriptionPropertyInfo), '("accessible-hypertext-nlinks", Atk.ObjectAccessibleHypertextNlinksPropertyInfo), '("accessible-name", Atk.ObjectAccessibleNamePropertyInfo), '("accessible-parent", Atk.ObjectAccessibleParentPropertyInfo), '("accessible-role", Atk.ObjectAccessibleRolePropertyInfo), '("accessible-table-caption", Atk.ObjectAccessibleTableCaptionPropertyInfo), '("accessible-table-caption-object", Atk.ObjectAccessibleTableCaptionObjectPropertyInfo), '("accessible-table-column-description", Atk.ObjectAccessibleTableColumnDescriptionPropertyInfo), '("accessible-table-column-header", Atk.ObjectAccessibleTableColumnHeaderPropertyInfo), '("accessible-table-row-description", Atk.ObjectAccessibleTableRowDescriptionPropertyInfo), '("accessible-table-row-header", Atk.ObjectAccessibleTableRowHeaderPropertyInfo), '("accessible-table-summary", Atk.ObjectAccessibleTableSummaryPropertyInfo), '("accessible-value", Atk.ObjectAccessibleValuePropertyInfo)] :: [(Symbol, *)])

type instance SignalList NotebookPageAccessible = NotebookPageAccessibleSignalList
type NotebookPageAccessibleSignalList = ('[ '("active-descendant-changed", Atk.ObjectActiveDescendantChangedSignalInfo), '("bounds-changed", Atk.ComponentBoundsChangedSignalInfo), '("children-changed", Atk.ObjectChildrenChangedSignalInfo), '("focus-event", Atk.ObjectFocusEventSignalInfo), '("notify", GObject.ObjectNotifySignalInfo), '("property-change", Atk.ObjectPropertyChangeSignalInfo), '("state-change", Atk.ObjectStateChangeSignalInfo), '("visible-data-changed", Atk.ObjectVisibleDataChangedSignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method NotebookPageAccessible::new
-- method type : Constructor
-- Args : [Arg {argName = "notebook", argType = TInterface "Gtk" "NotebookAccessible", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "child", argType = TInterface "Gtk" "Widget", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "notebook", argType = TInterface "Gtk" "NotebookAccessible", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "child", argType = TInterface "Gtk" "Widget", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "Gtk" "NotebookPageAccessible"
-- throws : False
-- Skip return : False

foreign import ccall "gtk_notebook_page_accessible_new" gtk_notebook_page_accessible_new :: 
    Ptr NotebookAccessible ->               -- notebook : TInterface "Gtk" "NotebookAccessible"
    Ptr Widget ->                           -- child : TInterface "Gtk" "Widget"
    IO (Ptr NotebookPageAccessible)


notebookPageAccessibleNew ::
    (MonadIO m, NotebookAccessibleK a, WidgetK b) =>
    a ->                                    -- notebook
    b ->                                    -- child
    m NotebookPageAccessible
notebookPageAccessibleNew notebook child = liftIO $ do
    let notebook' = unsafeManagedPtrCastPtr notebook
    let child' = unsafeManagedPtrCastPtr child
    result <- gtk_notebook_page_accessible_new notebook' child'
    checkUnexpectedReturnNULL "gtk_notebook_page_accessible_new" result
    result' <- (wrapObject NotebookPageAccessible) result
    touchManagedPtr notebook
    touchManagedPtr child
    return result'

-- method NotebookPageAccessible::invalidate
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "NotebookPageAccessible", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "NotebookPageAccessible", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_notebook_page_accessible_invalidate" gtk_notebook_page_accessible_invalidate :: 
    Ptr NotebookPageAccessible ->           -- _obj : TInterface "Gtk" "NotebookPageAccessible"
    IO ()


notebookPageAccessibleInvalidate ::
    (MonadIO m, NotebookPageAccessibleK a) =>
    a ->                                    -- _obj
    m ()
notebookPageAccessibleInvalidate _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    gtk_notebook_page_accessible_invalidate _obj'
    touchManagedPtr _obj
    return ()


