
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Gtk.Objects.ToggleButton
    ( 

-- * Exported types
    ToggleButton(..)                        ,
    ToggleButtonK                           ,
    toToggleButton                          ,
    noToggleButton                          ,


 -- * Methods
-- ** toggleButtonGetActive
    toggleButtonGetActive                   ,


-- ** toggleButtonGetInconsistent
    toggleButtonGetInconsistent             ,


-- ** toggleButtonGetMode
    toggleButtonGetMode                     ,


-- ** toggleButtonNew
    toggleButtonNew                         ,


-- ** toggleButtonNewWithLabel
    toggleButtonNewWithLabel                ,


-- ** toggleButtonNewWithMnemonic
    toggleButtonNewWithMnemonic             ,


-- ** toggleButtonSetActive
    toggleButtonSetActive                   ,


-- ** toggleButtonSetInconsistent
    toggleButtonSetInconsistent             ,


-- ** toggleButtonSetMode
    toggleButtonSetMode                     ,


-- ** toggleButtonToggled
    toggleButtonToggled                     ,




 -- * Properties
-- ** Active
    ToggleButtonActivePropertyInfo          ,
    constructToggleButtonActive             ,
    getToggleButtonActive                   ,
    setToggleButtonActive                   ,


-- ** DrawIndicator
    ToggleButtonDrawIndicatorPropertyInfo   ,
    constructToggleButtonDrawIndicator      ,
    getToggleButtonDrawIndicator            ,
    setToggleButtonDrawIndicator            ,


-- ** Inconsistent
    ToggleButtonInconsistentPropertyInfo    ,
    constructToggleButtonInconsistent       ,
    getToggleButtonInconsistent             ,
    setToggleButtonInconsistent             ,




 -- * Signals
-- ** Toggled
    ToggleButtonToggledCallback             ,
    ToggleButtonToggledCallbackC            ,
    ToggleButtonToggledSignalInfo           ,
    afterToggleButtonToggled                ,
    mkToggleButtonToggledCallback           ,
    noToggleButtonToggledCallback           ,
    onToggleButtonToggled                   ,
    toggleButtonToggledCallbackWrapper      ,
    toggleButtonToggledClosure              ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Gtk.Types
import GI.Gtk.Callbacks
import qualified GI.Atk as Atk
import qualified GI.GObject as GObject

newtype ToggleButton = ToggleButton (ForeignPtr ToggleButton)
foreign import ccall "gtk_toggle_button_get_type"
    c_gtk_toggle_button_get_type :: IO GType

type instance ParentTypes ToggleButton = ToggleButtonParentTypes
type ToggleButtonParentTypes = '[Button, Bin, Container, Widget, GObject.Object, Atk.ImplementorIface, Actionable, Activatable, Buildable]

instance GObject ToggleButton where
    gobjectIsInitiallyUnowned _ = True
    gobjectType _ = c_gtk_toggle_button_get_type
    

class GObject o => ToggleButtonK o
instance (GObject o, IsDescendantOf ToggleButton o) => ToggleButtonK o

toToggleButton :: ToggleButtonK o => o -> IO ToggleButton
toToggleButton = unsafeCastTo ToggleButton

noToggleButton :: Maybe ToggleButton
noToggleButton = Nothing

-- signal ToggleButton::toggled
type ToggleButtonToggledCallback =
    IO ()

noToggleButtonToggledCallback :: Maybe ToggleButtonToggledCallback
noToggleButtonToggledCallback = Nothing

type ToggleButtonToggledCallbackC =
    Ptr () ->                               -- object
    Ptr () ->                               -- user_data
    IO ()

foreign import ccall "wrapper"
    mkToggleButtonToggledCallback :: ToggleButtonToggledCallbackC -> IO (FunPtr ToggleButtonToggledCallbackC)

toggleButtonToggledClosure :: ToggleButtonToggledCallback -> IO Closure
toggleButtonToggledClosure cb = newCClosure =<< mkToggleButtonToggledCallback wrapped
    where wrapped = toggleButtonToggledCallbackWrapper cb

toggleButtonToggledCallbackWrapper ::
    ToggleButtonToggledCallback ->
    Ptr () ->
    Ptr () ->
    IO ()
toggleButtonToggledCallbackWrapper _cb _ _ = do
    _cb 

onToggleButtonToggled :: (GObject a, MonadIO m) => a -> ToggleButtonToggledCallback -> m SignalHandlerId
onToggleButtonToggled obj cb = liftIO $ connectToggleButtonToggled obj cb SignalConnectBefore
afterToggleButtonToggled :: (GObject a, MonadIO m) => a -> ToggleButtonToggledCallback -> m SignalHandlerId
afterToggleButtonToggled obj cb = connectToggleButtonToggled obj cb SignalConnectAfter

connectToggleButtonToggled :: (GObject a, MonadIO m) =>
                              a -> ToggleButtonToggledCallback -> SignalConnectMode -> m SignalHandlerId
connectToggleButtonToggled obj cb after = liftIO $ do
    cb' <- mkToggleButtonToggledCallback (toggleButtonToggledCallbackWrapper cb)
    connectSignalFunPtr obj "toggled" cb' after

-- VVV Prop "active"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getToggleButtonActive :: (MonadIO m, ToggleButtonK o) => o -> m Bool
getToggleButtonActive obj = liftIO $ getObjectPropertyBool obj "active"

setToggleButtonActive :: (MonadIO m, ToggleButtonK o) => o -> Bool -> m ()
setToggleButtonActive obj val = liftIO $ setObjectPropertyBool obj "active" val

constructToggleButtonActive :: Bool -> IO ([Char], GValue)
constructToggleButtonActive val = constructObjectPropertyBool "active" val

data ToggleButtonActivePropertyInfo
instance AttrInfo ToggleButtonActivePropertyInfo where
    type AttrAllowedOps ToggleButtonActivePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint ToggleButtonActivePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint ToggleButtonActivePropertyInfo = ToggleButtonK
    type AttrGetType ToggleButtonActivePropertyInfo = Bool
    type AttrLabel ToggleButtonActivePropertyInfo = "ToggleButton::active"
    attrGet _ = getToggleButtonActive
    attrSet _ = setToggleButtonActive
    attrConstruct _ = constructToggleButtonActive

-- VVV Prop "draw-indicator"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getToggleButtonDrawIndicator :: (MonadIO m, ToggleButtonK o) => o -> m Bool
getToggleButtonDrawIndicator obj = liftIO $ getObjectPropertyBool obj "draw-indicator"

setToggleButtonDrawIndicator :: (MonadIO m, ToggleButtonK o) => o -> Bool -> m ()
setToggleButtonDrawIndicator obj val = liftIO $ setObjectPropertyBool obj "draw-indicator" val

constructToggleButtonDrawIndicator :: Bool -> IO ([Char], GValue)
constructToggleButtonDrawIndicator val = constructObjectPropertyBool "draw-indicator" val

data ToggleButtonDrawIndicatorPropertyInfo
instance AttrInfo ToggleButtonDrawIndicatorPropertyInfo where
    type AttrAllowedOps ToggleButtonDrawIndicatorPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint ToggleButtonDrawIndicatorPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint ToggleButtonDrawIndicatorPropertyInfo = ToggleButtonK
    type AttrGetType ToggleButtonDrawIndicatorPropertyInfo = Bool
    type AttrLabel ToggleButtonDrawIndicatorPropertyInfo = "ToggleButton::draw-indicator"
    attrGet _ = getToggleButtonDrawIndicator
    attrSet _ = setToggleButtonDrawIndicator
    attrConstruct _ = constructToggleButtonDrawIndicator

-- VVV Prop "inconsistent"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getToggleButtonInconsistent :: (MonadIO m, ToggleButtonK o) => o -> m Bool
getToggleButtonInconsistent obj = liftIO $ getObjectPropertyBool obj "inconsistent"

setToggleButtonInconsistent :: (MonadIO m, ToggleButtonK o) => o -> Bool -> m ()
setToggleButtonInconsistent obj val = liftIO $ setObjectPropertyBool obj "inconsistent" val

constructToggleButtonInconsistent :: Bool -> IO ([Char], GValue)
constructToggleButtonInconsistent val = constructObjectPropertyBool "inconsistent" val

data ToggleButtonInconsistentPropertyInfo
instance AttrInfo ToggleButtonInconsistentPropertyInfo where
    type AttrAllowedOps ToggleButtonInconsistentPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint ToggleButtonInconsistentPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint ToggleButtonInconsistentPropertyInfo = ToggleButtonK
    type AttrGetType ToggleButtonInconsistentPropertyInfo = Bool
    type AttrLabel ToggleButtonInconsistentPropertyInfo = "ToggleButton::inconsistent"
    attrGet _ = getToggleButtonInconsistent
    attrSet _ = setToggleButtonInconsistent
    attrConstruct _ = constructToggleButtonInconsistent

type instance AttributeList ToggleButton = ToggleButtonAttributeList
type ToggleButtonAttributeList = ('[ '("action-name", ActionableActionNamePropertyInfo), '("action-target", ActionableActionTargetPropertyInfo), '("active", ToggleButtonActivePropertyInfo), '("always-show-image", ButtonAlwaysShowImagePropertyInfo), '("app-paintable", WidgetAppPaintablePropertyInfo), '("border-width", ContainerBorderWidthPropertyInfo), '("can-default", WidgetCanDefaultPropertyInfo), '("can-focus", WidgetCanFocusPropertyInfo), '("child", ContainerChildPropertyInfo), '("composite-child", WidgetCompositeChildPropertyInfo), '("double-buffered", WidgetDoubleBufferedPropertyInfo), '("draw-indicator", ToggleButtonDrawIndicatorPropertyInfo), '("events", WidgetEventsPropertyInfo), '("expand", WidgetExpandPropertyInfo), '("focus-on-click", ButtonFocusOnClickPropertyInfo), '("halign", WidgetHalignPropertyInfo), '("has-default", WidgetHasDefaultPropertyInfo), '("has-focus", WidgetHasFocusPropertyInfo), '("has-tooltip", WidgetHasTooltipPropertyInfo), '("height-request", WidgetHeightRequestPropertyInfo), '("hexpand", WidgetHexpandPropertyInfo), '("hexpand-set", WidgetHexpandSetPropertyInfo), '("image", ButtonImagePropertyInfo), '("image-position", ButtonImagePositionPropertyInfo), '("inconsistent", ToggleButtonInconsistentPropertyInfo), '("is-focus", WidgetIsFocusPropertyInfo), '("label", ButtonLabelPropertyInfo), '("margin", WidgetMarginPropertyInfo), '("margin-bottom", WidgetMarginBottomPropertyInfo), '("margin-end", WidgetMarginEndPropertyInfo), '("margin-left", WidgetMarginLeftPropertyInfo), '("margin-right", WidgetMarginRightPropertyInfo), '("margin-start", WidgetMarginStartPropertyInfo), '("margin-top", WidgetMarginTopPropertyInfo), '("name", WidgetNamePropertyInfo), '("no-show-all", WidgetNoShowAllPropertyInfo), '("opacity", WidgetOpacityPropertyInfo), '("parent", WidgetParentPropertyInfo), '("receives-default", WidgetReceivesDefaultPropertyInfo), '("related-action", ActivatableRelatedActionPropertyInfo), '("relief", ButtonReliefPropertyInfo), '("resize-mode", ContainerResizeModePropertyInfo), '("scale-factor", WidgetScaleFactorPropertyInfo), '("sensitive", WidgetSensitivePropertyInfo), '("style", WidgetStylePropertyInfo), '("tooltip-markup", WidgetTooltipMarkupPropertyInfo), '("tooltip-text", WidgetTooltipTextPropertyInfo), '("use-action-appearance", ActivatableUseActionAppearancePropertyInfo), '("use-stock", ButtonUseStockPropertyInfo), '("use-underline", ButtonUseUnderlinePropertyInfo), '("valign", WidgetValignPropertyInfo), '("vexpand", WidgetVexpandPropertyInfo), '("vexpand-set", WidgetVexpandSetPropertyInfo), '("visible", WidgetVisiblePropertyInfo), '("width-request", WidgetWidthRequestPropertyInfo), '("window", WidgetWindowPropertyInfo), '("xalign", ButtonXalignPropertyInfo), '("yalign", ButtonYalignPropertyInfo)] :: [(Symbol, *)])

data ToggleButtonToggledSignalInfo
instance SignalInfo ToggleButtonToggledSignalInfo where
    type HaskellCallbackType ToggleButtonToggledSignalInfo = ToggleButtonToggledCallback
    connectSignal _ = connectToggleButtonToggled

type instance SignalList ToggleButton = ToggleButtonSignalList
type ToggleButtonSignalList = ('[ '("accel-closures-changed", WidgetAccelClosuresChangedSignalInfo), '("activate", ButtonActivateSignalInfo), '("add", ContainerAddSignalInfo), '("button-press-event", WidgetButtonPressEventSignalInfo), '("button-release-event", WidgetButtonReleaseEventSignalInfo), '("can-activate-accel", WidgetCanActivateAccelSignalInfo), '("check-resize", ContainerCheckResizeSignalInfo), '("child-notify", WidgetChildNotifySignalInfo), '("clicked", ButtonClickedSignalInfo), '("composited-changed", WidgetCompositedChangedSignalInfo), '("configure-event", WidgetConfigureEventSignalInfo), '("damage-event", WidgetDamageEventSignalInfo), '("delete-event", WidgetDeleteEventSignalInfo), '("destroy", WidgetDestroySignalInfo), '("destroy-event", WidgetDestroyEventSignalInfo), '("direction-changed", WidgetDirectionChangedSignalInfo), '("drag-begin", WidgetDragBeginSignalInfo), '("drag-data-delete", WidgetDragDataDeleteSignalInfo), '("drag-data-get", WidgetDragDataGetSignalInfo), '("drag-data-received", WidgetDragDataReceivedSignalInfo), '("drag-drop", WidgetDragDropSignalInfo), '("drag-end", WidgetDragEndSignalInfo), '("drag-failed", WidgetDragFailedSignalInfo), '("drag-leave", WidgetDragLeaveSignalInfo), '("drag-motion", WidgetDragMotionSignalInfo), '("draw", WidgetDrawSignalInfo), '("enter", ButtonEnterSignalInfo), '("enter-notify-event", WidgetEnterNotifyEventSignalInfo), '("event", WidgetEventSignalInfo), '("event-after", WidgetEventAfterSignalInfo), '("focus", WidgetFocusSignalInfo), '("focus-in-event", WidgetFocusInEventSignalInfo), '("focus-out-event", WidgetFocusOutEventSignalInfo), '("grab-broken-event", WidgetGrabBrokenEventSignalInfo), '("grab-focus", WidgetGrabFocusSignalInfo), '("grab-notify", WidgetGrabNotifySignalInfo), '("hide", WidgetHideSignalInfo), '("hierarchy-changed", WidgetHierarchyChangedSignalInfo), '("key-press-event", WidgetKeyPressEventSignalInfo), '("key-release-event", WidgetKeyReleaseEventSignalInfo), '("keynav-failed", WidgetKeynavFailedSignalInfo), '("leave", ButtonLeaveSignalInfo), '("leave-notify-event", WidgetLeaveNotifyEventSignalInfo), '("map", WidgetMapSignalInfo), '("map-event", WidgetMapEventSignalInfo), '("mnemonic-activate", WidgetMnemonicActivateSignalInfo), '("motion-notify-event", WidgetMotionNotifyEventSignalInfo), '("move-focus", WidgetMoveFocusSignalInfo), '("notify", GObject.ObjectNotifySignalInfo), '("parent-set", WidgetParentSetSignalInfo), '("popup-menu", WidgetPopupMenuSignalInfo), '("pressed", ButtonPressedSignalInfo), '("property-notify-event", WidgetPropertyNotifyEventSignalInfo), '("proximity-in-event", WidgetProximityInEventSignalInfo), '("proximity-out-event", WidgetProximityOutEventSignalInfo), '("query-tooltip", WidgetQueryTooltipSignalInfo), '("realize", WidgetRealizeSignalInfo), '("released", ButtonReleasedSignalInfo), '("remove", ContainerRemoveSignalInfo), '("screen-changed", WidgetScreenChangedSignalInfo), '("scroll-event", WidgetScrollEventSignalInfo), '("selection-clear-event", WidgetSelectionClearEventSignalInfo), '("selection-get", WidgetSelectionGetSignalInfo), '("selection-notify-event", WidgetSelectionNotifyEventSignalInfo), '("selection-received", WidgetSelectionReceivedSignalInfo), '("selection-request-event", WidgetSelectionRequestEventSignalInfo), '("set-focus-child", ContainerSetFocusChildSignalInfo), '("show", WidgetShowSignalInfo), '("show-help", WidgetShowHelpSignalInfo), '("size-allocate", WidgetSizeAllocateSignalInfo), '("state-changed", WidgetStateChangedSignalInfo), '("state-flags-changed", WidgetStateFlagsChangedSignalInfo), '("style-set", WidgetStyleSetSignalInfo), '("style-updated", WidgetStyleUpdatedSignalInfo), '("toggled", ToggleButtonToggledSignalInfo), '("touch-event", WidgetTouchEventSignalInfo), '("unmap", WidgetUnmapSignalInfo), '("unmap-event", WidgetUnmapEventSignalInfo), '("unrealize", WidgetUnrealizeSignalInfo), '("visibility-notify-event", WidgetVisibilityNotifyEventSignalInfo), '("window-state-event", WidgetWindowStateEventSignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method ToggleButton::new
-- method type : Constructor
-- Args : []
-- Lengths : []
-- hInArgs : []
-- returnType : TInterface "Gtk" "ToggleButton"
-- throws : False
-- Skip return : False

foreign import ccall "gtk_toggle_button_new" gtk_toggle_button_new :: 
    IO (Ptr ToggleButton)


toggleButtonNew ::
    (MonadIO m) =>
    m ToggleButton
toggleButtonNew  = liftIO $ do
    result <- gtk_toggle_button_new
    checkUnexpectedReturnNULL "gtk_toggle_button_new" result
    result' <- (newObject ToggleButton) result
    return result'

-- method ToggleButton::new_with_label
-- method type : Constructor
-- Args : [Arg {argName = "label", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "label", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "Gtk" "ToggleButton"
-- throws : False
-- Skip return : False

foreign import ccall "gtk_toggle_button_new_with_label" gtk_toggle_button_new_with_label :: 
    CString ->                              -- label : TBasicType TUTF8
    IO (Ptr ToggleButton)


toggleButtonNewWithLabel ::
    (MonadIO m) =>
    T.Text ->                               -- label
    m ToggleButton
toggleButtonNewWithLabel label = liftIO $ do
    label' <- textToCString label
    result <- gtk_toggle_button_new_with_label label'
    checkUnexpectedReturnNULL "gtk_toggle_button_new_with_label" result
    result' <- (newObject ToggleButton) result
    freeMem label'
    return result'

-- method ToggleButton::new_with_mnemonic
-- method type : Constructor
-- Args : [Arg {argName = "label", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "label", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "Gtk" "ToggleButton"
-- throws : False
-- Skip return : False

foreign import ccall "gtk_toggle_button_new_with_mnemonic" gtk_toggle_button_new_with_mnemonic :: 
    CString ->                              -- label : TBasicType TUTF8
    IO (Ptr ToggleButton)


toggleButtonNewWithMnemonic ::
    (MonadIO m) =>
    T.Text ->                               -- label
    m ToggleButton
toggleButtonNewWithMnemonic label = liftIO $ do
    label' <- textToCString label
    result <- gtk_toggle_button_new_with_mnemonic label'
    checkUnexpectedReturnNULL "gtk_toggle_button_new_with_mnemonic" result
    result' <- (newObject ToggleButton) result
    freeMem label'
    return result'

-- method ToggleButton::get_active
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "ToggleButton", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "ToggleButton", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "gtk_toggle_button_get_active" gtk_toggle_button_get_active :: 
    Ptr ToggleButton ->                     -- _obj : TInterface "Gtk" "ToggleButton"
    IO CInt


toggleButtonGetActive ::
    (MonadIO m, ToggleButtonK a) =>
    a ->                                    -- _obj
    m Bool
toggleButtonGetActive _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- gtk_toggle_button_get_active _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method ToggleButton::get_inconsistent
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "ToggleButton", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "ToggleButton", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "gtk_toggle_button_get_inconsistent" gtk_toggle_button_get_inconsistent :: 
    Ptr ToggleButton ->                     -- _obj : TInterface "Gtk" "ToggleButton"
    IO CInt


toggleButtonGetInconsistent ::
    (MonadIO m, ToggleButtonK a) =>
    a ->                                    -- _obj
    m Bool
toggleButtonGetInconsistent _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- gtk_toggle_button_get_inconsistent _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method ToggleButton::get_mode
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "ToggleButton", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "ToggleButton", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "gtk_toggle_button_get_mode" gtk_toggle_button_get_mode :: 
    Ptr ToggleButton ->                     -- _obj : TInterface "Gtk" "ToggleButton"
    IO CInt


toggleButtonGetMode ::
    (MonadIO m, ToggleButtonK a) =>
    a ->                                    -- _obj
    m Bool
toggleButtonGetMode _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- gtk_toggle_button_get_mode _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method ToggleButton::set_active
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "ToggleButton", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "is_active", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "ToggleButton", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "is_active", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_toggle_button_set_active" gtk_toggle_button_set_active :: 
    Ptr ToggleButton ->                     -- _obj : TInterface "Gtk" "ToggleButton"
    CInt ->                                 -- is_active : TBasicType TBoolean
    IO ()


toggleButtonSetActive ::
    (MonadIO m, ToggleButtonK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- is_active
    m ()
toggleButtonSetActive _obj is_active = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let is_active' = (fromIntegral . fromEnum) is_active
    gtk_toggle_button_set_active _obj' is_active'
    touchManagedPtr _obj
    return ()

-- method ToggleButton::set_inconsistent
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "ToggleButton", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "setting", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "ToggleButton", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "setting", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_toggle_button_set_inconsistent" gtk_toggle_button_set_inconsistent :: 
    Ptr ToggleButton ->                     -- _obj : TInterface "Gtk" "ToggleButton"
    CInt ->                                 -- setting : TBasicType TBoolean
    IO ()


toggleButtonSetInconsistent ::
    (MonadIO m, ToggleButtonK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- setting
    m ()
toggleButtonSetInconsistent _obj setting = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let setting' = (fromIntegral . fromEnum) setting
    gtk_toggle_button_set_inconsistent _obj' setting'
    touchManagedPtr _obj
    return ()

-- method ToggleButton::set_mode
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "ToggleButton", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "draw_indicator", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "ToggleButton", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "draw_indicator", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_toggle_button_set_mode" gtk_toggle_button_set_mode :: 
    Ptr ToggleButton ->                     -- _obj : TInterface "Gtk" "ToggleButton"
    CInt ->                                 -- draw_indicator : TBasicType TBoolean
    IO ()


toggleButtonSetMode ::
    (MonadIO m, ToggleButtonK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- draw_indicator
    m ()
toggleButtonSetMode _obj draw_indicator = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let draw_indicator' = (fromIntegral . fromEnum) draw_indicator
    gtk_toggle_button_set_mode _obj' draw_indicator'
    touchManagedPtr _obj
    return ()

-- method ToggleButton::toggled
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gtk" "ToggleButton", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gtk" "ToggleButton", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "gtk_toggle_button_toggled" gtk_toggle_button_toggled :: 
    Ptr ToggleButton ->                     -- _obj : TInterface "Gtk" "ToggleButton"
    IO ()


toggleButtonToggled ::
    (MonadIO m, ToggleButtonK a) =>
    a ->                                    -- _obj
    m ()
toggleButtonToggled _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    gtk_toggle_button_toggled _obj'
    touchManagedPtr _obj
    return ()


