
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Gtk.Structs.AccelGroupEntry
    ( 

-- * Exported types
    AccelGroupEntry(..)                     ,
    noAccelGroupEntry                       ,


 -- * Properties
-- ** AccelPathQuark
    accelGroupEntryReadAccelPathQuark       ,


-- ** Closure
    accelGroupEntryReadClosure              ,


-- ** Key
    accelGroupEntryReadKey                  ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Gtk.Types
import GI.Gtk.Callbacks

newtype AccelGroupEntry = AccelGroupEntry (ForeignPtr AccelGroupEntry)
noAccelGroupEntry :: Maybe AccelGroupEntry
noAccelGroupEntry = Nothing

accelGroupEntryReadKey :: AccelGroupEntry -> IO AccelKey
accelGroupEntryReadKey s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 0) :: IO (Ptr AccelKey)
    val' <- (newPtr 12 AccelKey) val
    return val'

accelGroupEntryReadClosure :: AccelGroupEntry -> IO Closure
accelGroupEntryReadClosure s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 16) :: IO (Ptr Closure)
    val' <- (newBoxed Closure) val
    return val'

accelGroupEntryReadAccelPathQuark :: AccelGroupEntry -> IO Word32
accelGroupEntryReadAccelPathQuark s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 24) :: IO Word32
    return val


