
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Gtk.Structs.FixedChild
    ( 

-- * Exported types
    FixedChild(..)                          ,
    noFixedChild                            ,


 -- * Properties
-- ** Widget
    fixedChildReadWidget                    ,


-- ** X
    fixedChildReadX                         ,


-- ** Y
    fixedChildReadY                         ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Gtk.Types
import GI.Gtk.Callbacks

newtype FixedChild = FixedChild (ForeignPtr FixedChild)
noFixedChild :: Maybe FixedChild
noFixedChild = Nothing

fixedChildReadWidget :: FixedChild -> IO Widget
fixedChildReadWidget s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 0) :: IO (Ptr Widget)
    val' <- (newObject Widget) val
    return val'

fixedChildReadX :: FixedChild -> IO Int32
fixedChildReadX s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 8) :: IO Int32
    return val

fixedChildReadY :: FixedChild -> IO Int32
fixedChildReadY s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 12) :: IO Int32
    return val


