
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)

See also gtk_print_settings_set_page_ranges().
-}

module GI.Gtk.Structs.PageRange
    ( 

-- * Exported types
    PageRange(..)                           ,
    noPageRange                             ,


 -- * Properties
-- ** End
    pageRangeReadEnd                        ,


-- ** Start
    pageRangeReadStart                      ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Gtk.Types
import GI.Gtk.Callbacks

newtype PageRange = PageRange (ForeignPtr PageRange)
noPageRange :: Maybe PageRange
noPageRange = Nothing

pageRangeReadStart :: PageRange -> IO Int32
pageRangeReadStart s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 0) :: IO Int32
    return val

pageRangeReadEnd :: PageRange -> IO Int32
pageRangeReadEnd s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 4) :: IO Int32
    return val


