
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)

Meta-data to be passed to gtk_recent_manager_add_full() when
registering a recently used resource.
-}

module GI.Gtk.Structs.RecentData
    ( 

-- * Exported types
    RecentData(..)                          ,
    noRecentData                            ,


 -- * Properties
-- ** AppExec
    recentDataReadAppExec                   ,


-- ** AppName
    recentDataReadAppName                   ,


-- ** Description
    recentDataReadDescription               ,


-- ** DisplayName
    recentDataReadDisplayName               ,


-- ** Groups
    recentDataReadGroups                    ,


-- ** IsPrivate
    recentDataReadIsPrivate                 ,


-- ** MimeType
    recentDataReadMimeType                  ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Gtk.Types
import GI.Gtk.Callbacks

newtype RecentData = RecentData (ForeignPtr RecentData)
noRecentData :: Maybe RecentData
noRecentData = Nothing

recentDataReadDisplayName :: RecentData -> IO T.Text
recentDataReadDisplayName s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 0) :: IO CString
    val' <- cstringToText val
    return val'

recentDataReadDescription :: RecentData -> IO T.Text
recentDataReadDescription s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 8) :: IO CString
    val' <- cstringToText val
    return val'

recentDataReadMimeType :: RecentData -> IO T.Text
recentDataReadMimeType s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 16) :: IO CString
    val' <- cstringToText val
    return val'

recentDataReadAppName :: RecentData -> IO T.Text
recentDataReadAppName s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 24) :: IO CString
    val' <- cstringToText val
    return val'

recentDataReadAppExec :: RecentData -> IO T.Text
recentDataReadAppExec s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 32) :: IO CString
    val' <- cstringToText val
    return val'

recentDataReadGroups :: RecentData -> IO [T.Text]
recentDataReadGroups s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 40) :: IO (Ptr CString)
    val' <- unpackZeroTerminatedUTF8CArray val
    return val'

recentDataReadIsPrivate :: RecentData -> IO Bool
recentDataReadIsPrivate s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 48) :: IO CInt
    let val' = (/= 0) val
    return val'


