
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)

#GtkToggleActionEntry structs are used with
gtk_action_group_add_toggle_actions() to construct toggle actions.
-}

module GI.Gtk.Structs.ToggleActionEntry
    ( 

-- * Exported types
    ToggleActionEntry(..)                   ,
    noToggleActionEntry                     ,


 -- * Properties
-- ** Accelerator
    toggleActionEntryReadAccelerator        ,


-- ** IsActive
    toggleActionEntryReadIsActive           ,


-- ** Label
    toggleActionEntryReadLabel              ,


-- ** Name
    toggleActionEntryReadName               ,


-- ** StockId
    toggleActionEntryReadStockId            ,


-- ** Tooltip
    toggleActionEntryReadTooltip            ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Gtk.Types
import GI.Gtk.Callbacks

newtype ToggleActionEntry = ToggleActionEntry (ForeignPtr ToggleActionEntry)
noToggleActionEntry :: Maybe ToggleActionEntry
noToggleActionEntry = Nothing

toggleActionEntryReadName :: ToggleActionEntry -> IO T.Text
toggleActionEntryReadName s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 0) :: IO CString
    val' <- cstringToText val
    return val'

toggleActionEntryReadStockId :: ToggleActionEntry -> IO T.Text
toggleActionEntryReadStockId s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 8) :: IO CString
    val' <- cstringToText val
    return val'

toggleActionEntryReadLabel :: ToggleActionEntry -> IO T.Text
toggleActionEntryReadLabel s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 16) :: IO CString
    val' <- cstringToText val
    return val'

toggleActionEntryReadAccelerator :: ToggleActionEntry -> IO T.Text
toggleActionEntryReadAccelerator s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 24) :: IO CString
    val' <- cstringToText val
    return val'

toggleActionEntryReadTooltip :: ToggleActionEntry -> IO T.Text
toggleActionEntryReadTooltip s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 32) :: IO CString
    val' <- cstringToText val
    return val'

-- XXX Skipped getter for "ToggleActionEntry:callback" :: Not implemented: "Wrapping foreign callbacks is not supported yet"

toggleActionEntryReadIsActive :: ToggleActionEntry -> IO Bool
toggleActionEntryReadIsActive s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 48) :: IO CInt
    let val' = (/= 0) val
    return val'


